theory NFA_Refine
imports 
  Main 
  "../../Automata_Malik_Tuerk/NFA"
  "../../Automata_Malik_Tuerk/LTS"
  "../Collections/Refine_Dflt_ICF" 
begin

fun \<Q>_impl where "\<Q>_impl (Q,S,D,I,F) = Q"
fun \<Sigma>_impl where "\<Sigma>_impl (Q,S,D,I,F) = S"
fun \<Delta>_impl where "\<Delta>_impl (Q,S,D,I,F) = D"
fun \<I>_impl where "\<I>_impl (Q,S,D,I,F) = I"
fun \<F>_impl where "\<F>_impl (Q,S,D,I,F) = F"

definition 
  NFA_rel :: "_ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> _ \<Rightarrow> (_\<times>(_,_)NFA_rec) set"
  where
  NFA_rel_internal_def: "NFA_rel Rqs Rss Rds Ris Rfs R\<Q> R\<Sigma> \<equiv> 
  { ((Q,S,D,I,F),\<A>) . 
    NFA \<A> \<and> 
    (Q,\<Q> \<A>)\<in>\<langle>R\<Q>\<rangle>Rqs \<and> 
    (S,\<Sigma> \<A>)\<in>\<langle>R\<Sigma>\<rangle>Rss \<and>       
    (D,\<Delta> \<A>)\<in>\<langle>\<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel\<rangle>Rds \<and>
    (I,\<I> \<A>)\<in>\<langle>R\<Q>\<rangle>Ris \<and>       
    (F,\<F> \<A>)\<in>\<langle>R\<Q>\<rangle>Rfs}"

lemma NFA_rel_def: "\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<equiv> { ((Q,S,D,I,F),\<A>) . 
    NFA \<A> \<and> 
    (Q,\<Q> \<A>)\<in>\<langle>R\<Q>\<rangle>Rqs \<and> 
    (S,\<Sigma> \<A>)\<in>\<langle>R\<Sigma>\<rangle>Rss \<and>       
    (D,\<Delta> \<A>)\<in>\<langle>\<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel\<rangle>Rds \<and>
    (I,\<I> \<A>)\<in>\<langle>R\<Q>\<rangle>Ris \<and>       
    (F,\<F> \<A>)\<in>\<langle>R\<Q>\<rangle>Rfs}"
  unfolding NFA_rel_internal_def[abs_def] relAPP_def .
  
lemma NFA_rel_sv[relator_props]:
  assumes "single_valued (\<langle>R\<Q>\<rangle>Rqs)"
  assumes "single_valued (\<langle>R\<Sigma>\<rangle>Rss)"
  assumes "single_valued (\<langle>\<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel\<rangle>Rds)"
  assumes "single_valued (\<langle>R\<Q>\<rangle>Ris)"
  assumes "single_valued (\<langle>R\<Q>\<rangle>Rfs)"
  shows "single_valued (\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs)"
  apply (intro single_valuedI allI)
  apply (auto simp add: NFA_rel_def)
  apply (case_tac y)
  apply (case_tac z)
  apply (auto dest: assms[THEN single_valuedD])
  done

consts i_NFA :: "interface \<Rightarrow> interface \<Rightarrow> interface"

definition nfa_succ_label_it where "nfa_succ_label_it \<A> u = FOREACH {(c,v). (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_succ_it where "nfa_succ_it \<A> u = FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_pred_label_it where "nfa_pred_label_it \<A> v = FOREACH {(u,c). (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_pred_it where "nfa_pred_it \<A> v = FOREACH {u. \<exists>c. (u,c,v) \<in> \<Delta> \<A>}"

definition nfa_state_label_it_rel:
  "NFA_state_label_it_rel Rqs Rss Rds Ris Rfs R\<Q> R\<Sigma> R \<equiv> 
       NFA_rel Rqs Rss Rds Ris Rfs R\<Q> R\<Sigma> \<rightarrow> R\<Q> \<rightarrow> 
           (\<langle>R\<Q>,R\<Sigma>\<rangle>prod_rel \<rightarrow> R \<rightarrow> \<langle>R\<rangle>nres_rel) \<rightarrow> R \<rightarrow> \<langle>R\<rangle>nres_rel"

definition nfa_state_it_rel:
  "NFA_state_it_rel Rqs Rss Rds Ris Rfs R\<Q> R\<Sigma> R \<equiv> 
       NFA_rel Rqs Rss Rds Ris Rfs R\<Q> R\<Sigma> \<rightarrow> R\<Q> \<rightarrow> (R\<Q> \<rightarrow> R \<rightarrow> \<langle>R\<rangle>nres_rel) \<rightarrow> R \<rightarrow> \<langle>R\<rangle>nres_rel"





lemmas [autoref_rel_intf] = 
  REL_INTFI[of "NFA_rel Rqs Rss Rds Ris Rfs" i_NFA for Rqs Rss Rds Ris Rfs]

lemma \<Q>_autoref[autoref_rules]:
  "(\<Q>_impl,\<Q>)\<in>\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
  unfolding NFA_rel_def by auto
lemma \<Sigma>_autoref[autoref_rules]:
  "(\<Sigma>_impl,\<Sigma>)\<in>\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
  unfolding NFA_rel_def by auto
lemma \<Delta>_autoref[autoref_rules]:
  "(\<Delta>_impl,\<Delta>)\<in>\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs 
    \<rightarrow> \<langle>\<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel\<rangle>Rds"
  unfolding NFA_rel_def by auto
lemma \<I>_autoref[autoref_rules]:
  "(\<I>_impl,\<I>)\<in>\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<rightarrow> \<langle>R\<Q>\<rangle>Ris"
  unfolding NFA_rel_def by auto
lemma \<F>_autoref[autoref_rules]:
  "(\<F>_impl,\<F>)\<in>\<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<rightarrow> \<langle>R\<Q>\<rangle>Rfs"
  unfolding NFA_rel_def by auto


fun NFA_reverse_impl where
  "NFA_reverse_impl D_img (Q,S,D,I,F) = 
  (Q, S, D_img (\<lambda>(q1,l,q2). (q2,l,q1)) D, F, I)"

lemma NFA_reverse_alt: "NFA_reverse \<A> =
  \<lparr>\<Q> = \<Q> \<A>, \<Sigma> = \<Sigma> \<A>, \<Delta> = (\<lambda>(q, \<sigma>, p). (p, \<sigma>, q))`\<Delta> \<A>, \<I> = \<F> \<A>, \<F> = \<I> \<A>\<rparr>"
  unfolding NFA_reverse_def 
  by (force simp: image_def split: prod.splits) 

lemma NFA_reverse_autoref[autoref_rules]:
  fixes R\<Q> R\<Sigma>
  defines [simp]: "trip_rel \<equiv> \<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  assumes [unfolded autoref_tag_defs trip_rel_def, param]: 
    "GEN_OP D_img op ` ((trip_rel \<rightarrow> trip_rel) \<rightarrow> \<langle>trip_rel\<rangle>Rds \<rightarrow> \<langle>trip_rel\<rangle>Rds)"
  shows "(NFA_reverse_impl D_img, NFA_reverse) \<in> 
    \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Rifs Rifs 
    \<rightarrow> \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Rifs Rifs"
  apply (rule fun_relI)
  unfolding NFA_rel_def
  apply clarsimp
  apply (rule conjI)
  apply (erule NFA_reverse___is_well_formed)
  unfolding NFA_reverse_alt
  apply clarsimp
  apply parametricity
  done
  
fun NFA_rename_states_impl where
  "NFA_rename_states_impl Q_img D_img I_img F_img (Q,S,D,I,F) f = 
    (Q_img f Q, S, D_img (\<lambda>(u,c,v). (f u, c, f v)) D, I_img f I, F_img f F)"

thm NFA_rename_states_def SemiAutomaton_rename_states_ext_def

lemma NFA_rename_states_alt: "NFA_rename_states \<A> f =
  \<lparr>\<Q> = f`\<Q> \<A>, \<Sigma> = \<Sigma> \<A>, 
    \<Delta> = (\<lambda>(p, \<sigma>, q). (f p, \<sigma>, f q))`\<Delta> \<A>, \<I> = f`\<I> \<A>, \<F> = f`\<F> \<A>
  \<rparr>"
  unfolding NFA_rename_states_def SemiAutomaton_rename_states_ext_def
  by (force simp: image_def split: prod.splits)

lemma NFA_rename_states_autoref[autoref_rules]:
  fixes R\<Q> R\<Sigma>
  defines [simp]: "trip_rel \<equiv> \<langle>R\<Q>,\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  assumes [unfolded autoref_tag_defs trip_rel_def, param]: 
    "GEN_OP Q_img op ` ((R\<Q> \<rightarrow> R\<Q>) \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
    "GEN_OP D_img op ` ((trip_rel \<rightarrow> trip_rel) \<rightarrow> \<langle>trip_rel\<rangle>Rds \<rightarrow> \<langle>trip_rel\<rangle>Rds)"
    "GEN_OP I_img op ` ((R\<Q> \<rightarrow> R\<Q>) \<rightarrow> \<langle>R\<Q>\<rangle>Ris \<rightarrow> \<langle>R\<Q>\<rangle>Ris)"
    "GEN_OP F_img op ` ((R\<Q> \<rightarrow> R\<Q>) \<rightarrow> \<langle>R\<Q>\<rangle>Rfs \<rightarrow> \<langle>R\<Q>\<rangle>Rfs)"
  shows "(NFA_rename_states_impl Q_img D_img I_img F_img, NFA_rename_states) \<in> 
    \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs \<rightarrow> (R\<Q> \<rightarrow> R\<Q>)
    \<rightarrow> \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Ris Rfs"
  apply (rule fun_relI)
  unfolding NFA_rel_def
  apply clarsimp
  apply (intro conjI)
  apply (erule NFA_rename_states___is_well_formed)
  apply parametricity
  unfolding NFA_rename_states_alt
  apply clarsimp
  apply parametricity
  apply parametricity
  apply parametricity
  done



definition NFA_construct_impl :: 
    "('q list \<Rightarrow> 'qset) \<Rightarrow> ('q \<Rightarrow> 'qset \<Rightarrow> 'qset) \<Rightarrow> ('qset \<Rightarrow> 'qset \<Rightarrow> 'qset) \<Rightarrow>
     ('c list \<Rightarrow> 'cset) \<Rightarrow> ('c \<Rightarrow> 'cset \<Rightarrow> 'cset) \<Rightarrow>
     'dset \<Rightarrow> ('q\<times>'c\<times>'q \<Rightarrow> 'dset \<Rightarrow> 'dset) \<Rightarrow> 
     'q list \<times> 'c list \<times> ('q\<times>'c list\<times>'q) list \<times> 'q list \<times> 'q list \<Rightarrow>
     'qset \<times> 'cset \<times> 'dset \<times> 'qset \<times> 'qset"
where
"NFA_construct_impl Qlist2set Qset_ins Qset_union 
      \<Sigma>list2set \<Sigma>set_ins Dset_empty Dset_ins = 
  (\<lambda>(Q,A,D,I,F).
     let I' = Qlist2set I; F' = Qlist2set F; 
         Q' = Qset_union (Qset_union (Qlist2set Q) I') F'
     in (foldl (\<lambda>s (u,_,v). Qset_ins v (Qset_ins u s)) Q' D,
         foldl (\<lambda>s (_,as,_). foldl (\<lambda>s x. \<Sigma>set_ins x s) s as) (\<Sigma>list2set A) D,
         foldl (\<lambda>s (u,as,v). foldl (\<lambda>s a. Dset_ins (u,a,v) s) s as) Dset_empty D,
         I', F'))"

lemma NFA_construct_impl_aux1':
  assumes "(ins, Set.insert) \<in> R2 \<rightarrow> \<langle>R2\<rangle>Rs \<rightarrow> \<langle>R2\<rangle>Rs"
  assumes "(s,s') \<in> \<langle>R2\<rangle>Rs"
  assumes "(f,f') \<in> R1 \<rightarrow> R2"
  assumes "(xs,xs') \<in> \<langle>R1\<rangle>list_rel"
  shows "(foldl (\<lambda>s x. ins (f x) s) s xs, f' ` set xs' \<union>  s') \<in> \<langle>R2\<rangle>Rs"
proof (insert assms(2), induction arbitrary: s s'
       rule: list_rel_induct[OF assms(4)])
  case goal1 thus ?case by simp
next
  case (goal2 x x' xs xs' s s')
    hence "(ins (f x) s, insert (f' x') s') \<in> \<langle>R2\<rangle>Rs" 
        using assms(1,3) by parametricity
    from goal2(3)[OF this]
        have "(foldl (\<lambda>s x. ins (f x) s) (ins (f x) s) xs,
               insert (f' x') (f'`set xs' \<union> s')) \<in> \<langle>R2\<rangle>Rs" by simp
    thus ?case by simp
qed

lemma NFA_construct_impl_aux1:
  assumes "(ins, Set.insert) \<in> R \<rightarrow> \<langle>R\<rangle>Rs \<rightarrow> \<langle>R\<rangle>Rs"
  assumes "(s,s') \<in> \<langle>R\<rangle>Rs"
  assumes "(xs,xs') \<in> \<langle>R\<rangle>list_rel"
  shows "(foldl (\<lambda>s x. ins x s) s xs, set xs' \<union> s') \<in> \<langle>R\<rangle>Rs"
  using NFA_construct_impl_aux1'[OF assms(1,2) param_id assms(3)] by simp

lemma NFA_construct_impl_aux2:
  fixes R\<Q> R\<Sigma> Rs
  defines [simp]: "tripl_rel \<equiv> \<langle>R\<Q>, \<langle>Rs,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  defines [simp]: "trip_rel \<equiv> \<langle>R\<Q>, \<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  assumes "(Qset_ins, Set.insert) \<in> R\<Q> \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
  assumes "(D,D') \<in> \<langle>tripl_rel\<rangle>list_rel"
  assumes "(s,s') \<in> \<langle>R\<Q>\<rangle>Rqs"
  shows "(foldl (\<lambda>s (u,_,v). Qset_ins v (Qset_ins u s)) s D,
          s' \<union> fst ` set D' \<union> (snd \<circ> snd) ` set D') \<in> \<langle>R\<Q>\<rangle>Rqs"
         (is "(foldl ?f _ _, _) \<in> _")
proof (insert assms(5), induction arbitrary: s s' 
       rule: list_rel_induct[OF assms(4)])
  case goal1 thus ?case by simp
next
  case (goal2 x x' xs xs' s s')
    obtain u cs v where [simp]: "x = (u,cs,v)" by (cases x)
    obtain u' cs' v' where [simp]: "x' = (u',cs',v')" by (cases x')
    from goal2(1) have [simp]: "(u,u') \<in> R\<Q>" "(v,v') \<in> R\<Q>" by simp_all
    have "(Qset_ins v (Qset_ins u s), insert v' (insert u' s')) \<in> \<langle>R\<Q>\<rangle>Rqs"
        using goal2(4) assms(3)[param_fo] by simp
    from goal2(3)[OF this] show ?case by simp
qed

lemma NFA_construct_impl_aux3:
  fixes R\<Q> R\<Sigma>
  defines [simp]: "tripl_rel \<equiv> \<langle>R\<Q>, \<langle>\<langle>R\<Sigma>\<rangle>list_rel,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  defines [simp]: "trip_rel \<equiv> \<langle>R\<Q>, \<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  assumes "(\<Sigma>set_ins, Set.insert) \<in> R\<Sigma> \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
  assumes "(D,D') \<in> \<langle>tripl_rel\<rangle>list_rel"
  assumes "(s,s') \<in> \<langle>R\<Sigma>\<rangle>Rss"
  shows "(foldl (\<lambda>s (_,as,_). foldl (\<lambda>s x. \<Sigma>set_ins x s) s as) s D,
          s' \<union> (\<Union>x\<in>set D'. set (fst (snd x)))) \<in> \<langle>R\<Sigma>\<rangle>Rss"
proof (insert assms(5), induction arbitrary: s s' 
       rule: list_rel_induct[OF assms(4)])
  case goal1 thus ?case by simp
next
  case (goal2 x x' xs xs' s s')
    obtain u cs v where [simp]: "x = (u,cs,v)" by (cases x)
    obtain u' cs' v' where [simp]: "x' = (u',cs',v')" by (cases x')
    from goal2(1) have [simp]: "(cs,cs') \<in> \<langle>R\<Sigma>\<rangle>list_rel" by simp
    from NFA_construct_impl_aux1[OF assms(3) goal2(4) this]
        have "(foldl (\<lambda>s x. \<Sigma>set_ins x s) s cs, set cs' \<union> s') \<in> \<langle>R\<Sigma>\<rangle>Rss" .
    from goal2(3)[OF this] show ?case by (simp add: Un_assoc Un_left_commute)
qed

lemma NFA_construct_impl_aux4:
  fixes R\<Q> R\<Sigma>
  defines [simp]: "tripl_rel \<equiv> \<langle>R\<Q>, \<langle>\<langle>R\<Sigma>\<rangle>list_rel,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  defines [simp]: "trip_rel \<equiv> \<langle>R\<Q>, \<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
  assumes "(Dset_ins, Set.insert) \<in> trip_rel \<rightarrow> \<langle>trip_rel\<rangle>Rds \<rightarrow> \<langle>trip_rel\<rangle>Rds"
  assumes "(D,D') \<in> \<langle>tripl_rel\<rangle>list_rel"
  assumes "(Dset_empty,{}) \<in> \<langle>trip_rel\<rangle>Rds"
  shows "(foldl (\<lambda>s (u,as,v). foldl (\<lambda>s a. Dset_ins (u,a,v) s) s as) 
              Dset_empty D,
          {(q1, a, q2). \<exists>l. (q1, l, q2) \<in> set D' \<and> a \<in> set l})
          \<in> \<langle>trip_rel\<rangle>Rds"
proof-
  have "\<And>s s'. (s,s') \<in> \<langle>trip_rel\<rangle>Rds \<Longrightarrow> 
        (foldl (\<lambda>s (u,as,v). foldl (\<lambda>s a. Dset_ins (u,a,v) s) s as) s D,
          {(q1, a, q2). \<exists>l. (q1, l, q2) \<in> set D' \<and> a \<in> set l} \<union> s') 
        \<in> \<langle>trip_rel\<rangle>Rds"
  proof (induction arbitrary: s s' rule: list_rel_induct[OF assms(4)])
    case goal1
      have A: "{(q1, a, q2). False} = {}" by force
      from goal1 show ?case by (simp add: A)
  next
    case (goal2 x x' xs xs' s s')
      obtain u as v where [simp]: "x = (u,as,v)" by (cases x)
      obtain u' as' v' where [simp]: "x' = (u',as',v')" by (cases x')
      from goal2(1) have [simp]: "(u,u') \<in> R\<Q>" and [simp]: "(v,v') \<in> R\<Q>" and 
          Ras: "(as,as') \<in> \<langle>R\<Sigma>\<rangle>list_rel" by simp_all
      have "(foldl (\<lambda>s a. Dset_ins (u,a,v) s) s as,
              {(u', a, v')|a. a \<in> set as'} \<union> s') \<in> \<langle>trip_rel\<rangle>Rds"
      proof (insert goal2(4), induction arbitrary: s s'
             rule: list_rel_induct[OF Ras])
        case goal1 thus ?case by simp
      next
        case (goal2 a a' as as' s s')
          have [simp]: "{(u', a, v') |a. a = a' \<or> a \<in> set as'} \<union> s' = 
              {(u', a, v') |a. a \<in> set as'} \<union> insert (u',a',v') s'" by blast
          from goal2 have "(Dset_ins (u,a,v) s, 
              insert (u',a',v') s') \<in> \<langle>trip_rel\<rangle>Rds"
              using assms(3)[param_fo] by simp
          from goal2(3)[OF this] show ?case by simp
      qed
      note goal2(3)[OF this]
      also have "{(q1, a, q2). \<exists>l. (q1, l, q2) \<in> set xs' \<and> a \<in> set l} \<union>
                     ({(u', a, v') |a. a \<in> set as'} \<union> s') =
                {(q1, a, q2). \<exists>l. (q1, l, q2) \<in> set (x'#xs') \<and> a \<in> set l} \<union> s'"
          by force
      finally show ?case by simp
  qed
  from this[OF assms(5)] show ?thesis by simp
qed


lemma NFA_construct_autoref[autoref_rules] :
fixes R\<Q> R\<Sigma>
defines tripl_rel_def[simp]: "tripl_rel \<equiv> \<langle>R\<Q>, \<langle>\<langle>R\<Sigma>\<rangle>list_rel,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
defines trip_rel_def[simp]: "trip_rel \<equiv> \<langle>R\<Q>, \<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
assumes "GEN_OP Qlist2set set (\<langle>R\<Q>\<rangle>list_rel \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP Qset_ins Set.insert (R\<Q> \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP Qset_union op\<union> (\<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP \<Sigma>list2set set (\<langle>R\<Sigma>\<rangle>list_rel \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss)"
assumes "GEN_OP \<Sigma>set_ins Set.insert (R\<Sigma> \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss)"
assumes "GEN_OP Dset_empty {} (\<langle>trip_rel\<rangle>Rds)"
assumes "GEN_OP Dset_ins Set.insert (trip_rel \<rightarrow> \<langle>trip_rel\<rangle>Rds \<rightarrow> \<langle>trip_rel\<rangle>Rds)"
shows "(NFA_construct_impl Qlist2set Qset_ins Qset_union \<Sigma>list2set 
            \<Sigma>set_ins Dset_empty Dset_ins, NFA_construct) \<in> 
       \<langle>\<langle>R\<Q>\<rangle>list_rel,\<langle>\<langle>R\<Sigma>\<rangle>list_rel,
          \<langle>\<langle>tripl_rel\<rangle>list_rel, \<langle>\<langle>R\<Q>\<rangle>list_rel,\<langle>R\<Q>\<rangle>list_rel\<rangle>
          prod_rel\<rangle>prod_rel\<rangle>prod_rel\<rangle>prod_rel \<rightarrow> 
          \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Rqs Rqs"
proof-
from assms have ops:
    "(Qlist2set,set) \<in> \<langle>R\<Q>\<rangle>list_rel \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(Qset_ins, Set.insert) \<in> R\<Q> \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(Qset_union, op\<union>) \<in> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(\<Sigma>list2set, set) \<in> \<langle>R\<Sigma>\<rangle>list_rel \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
    "(\<Sigma>set_ins, Set.insert) \<in> R\<Sigma> \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
    "(Dset_empty, {}) \<in> \<langle>trip_rel\<rangle>Rds"
    "(Dset_ins, Set.insert) \<in> trip_rel \<rightarrow> \<langle>trip_rel\<rangle>Rds \<rightarrow> \<langle>trip_rel\<rangle>Rds"
         by simp_all
show ?thesis unfolding NFA_construct_impl_def Let_def
apply (intro fun_relI, unfold NFA_rel_def)
apply clarsimp
apply (intro conjI)
apply (rule NFA_construct___is_well_formed)
unfolding NFA_construct_alt_def
apply simp_all
apply (parametricity add: ops NFA_construct_impl_aux2)
apply (parametricity add: ops NFA_construct_impl_aux3)
apply (parametricity add: ops[unfolded trip_rel_def] NFA_construct_impl_aux4)
apply (parametricity add: ops)
apply (parametricity add: ops)
done
qed

definition NFA_construct_simple_impl :: 
    "('q list \<Rightarrow> 'qset) \<Rightarrow> ('q \<Rightarrow> 'qset \<Rightarrow> 'qset) \<Rightarrow> ('qset \<Rightarrow> 'qset \<Rightarrow> 'qset) \<Rightarrow>
     ('c list \<Rightarrow> 'cset) \<Rightarrow> ('c \<Rightarrow> 'cset \<Rightarrow> 'cset) \<Rightarrow>
     (('q\<times>'c\<times>'q) list \<Rightarrow> 'dset) \<Rightarrow> 
     'q list \<times> 'c list \<times> ('q\<times>'c\<times>'q) list \<times> 'q list \<times> 'q list \<Rightarrow>
     'qset \<times> 'cset \<times> 'dset \<times> 'qset \<times> 'qset" where
"NFA_construct_simple_impl Qlist2set Qset_ins Qset_union 
      \<Sigma>list2set \<Sigma>set_ins Dlist2set = 
  (\<lambda>(Q,A,D,I,F).
     let I' = Qlist2set I; F' = Qlist2set F; 
         Q' = Qset_union (Qset_union (Qlist2set Q) I') F'
     in (foldl (\<lambda>s (u,_,v). Qset_ins v (Qset_ins u s)) Q' D,
         foldl (\<lambda>s (_,a,_). \<Sigma>set_ins a s) (\<Sigma>list2set A) D,
         Dlist2set D, I', F'))"


lemma NFA_construct_simple_autoref[autoref_rules]:
fixes R\<Q> R\<Sigma>
defines trip_rel_def[simp]: "trip_rel \<equiv> \<langle>R\<Q>, \<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel\<rangle>prod_rel"
assumes "GEN_OP Qlist2set set (\<langle>R\<Q>\<rangle>list_rel \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP Qset_ins Set.insert (R\<Q> \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP Qset_union op\<union> (\<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs)"
assumes "GEN_OP \<Sigma>list2set set (\<langle>R\<Sigma>\<rangle>list_rel \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss)"
assumes "GEN_OP \<Sigma>set_ins Set.insert (R\<Sigma> \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss)"
assumes "GEN_OP Dlist2set set (\<langle>trip_rel\<rangle>list_rel \<rightarrow> \<langle>trip_rel\<rangle>Rds)"
shows "(NFA_construct_simple_impl Qlist2set Qset_ins Qset_union 
      \<Sigma>list2set \<Sigma>set_ins Dlist2set, NFA_construct_simple) \<in> 
       \<langle>\<langle>R\<Q>\<rangle>list_rel,\<langle>\<langle>R\<Sigma>\<rangle>list_rel,
          \<langle>\<langle>trip_rel\<rangle>list_rel, \<langle>\<langle>R\<Q>\<rangle>list_rel,\<langle>R\<Q>\<rangle>list_rel\<rangle>
          prod_rel\<rangle>prod_rel\<rangle>prod_rel\<rangle>prod_rel \<rightarrow> 
          \<langle>R\<Q>,R\<Sigma>\<rangle>NFA_rel Rqs Rss Rds Rqs Rqs"
proof-
from assms have ops:
    "(Qlist2set,set) \<in> \<langle>R\<Q>\<rangle>list_rel \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(Qset_ins, Set.insert) \<in> R\<Q> \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(Qset_union, op\<union>) \<in> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs \<rightarrow> \<langle>R\<Q>\<rangle>Rqs"
    "(\<Sigma>list2set, set) \<in> \<langle>R\<Sigma>\<rangle>list_rel \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
    "(\<Sigma>set_ins, Set.insert) \<in> R\<Sigma> \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss \<rightarrow> \<langle>R\<Sigma>\<rangle>Rss"
    "(Dlist2set, set) \<in> \<langle>trip_rel\<rangle>list_rel \<rightarrow> \<langle>trip_rel\<rangle>Rds"
         by simp_all
show ?thesis unfolding NFA_construct_simple_impl_def Let_def
proof (intro fun_relI, unfold NFA_rel_def, clarsimp, 
       rename_tac Q S D I F Q' S' D' I' F', intro conjI,
       rule NFA_construct___is_well_formed, unfold NFA_construct_alt_def,
       simp_all only: SemiAutomaton_rec.simps NFA_rec.simps set_map)
  case goal1
    have [simp]: "fst ` (\<lambda>(q1, a, q2). (q1, [a], q2)) ` set D' = fst ` set D'" 
        by force
    have [simp]: "(snd o snd) ` (\<lambda>(q1, a, q2). (q1, [a], q2)) ` set D' = 
        (snd o snd) ` set D'" by force
    from goal1 show ?case apply simp
        using ops NFA_construct_impl_aux2 by parametricity
next
  case goal2
    have A: "\<Union>((set \<circ> fst \<circ> snd) ` (\<lambda>(q1, a, q2). (q1, [a], q2)) ` set D') =
        (fst \<circ> snd) ` set D'" by force
    have B: "(\<lambda>s (_, a, _). \<Sigma>set_ins a s) = (\<lambda>s x. \<Sigma>set_ins ((fst \<circ> snd) x) s)"
        by force
    from goal2 show ?case apply (simp only: A B) apply (subst Un_commute)
        using ops NFA_construct_impl_aux1' by parametricity
next
  case goal3
    have A: "{(q1,a,q2).\<exists>l.(q1,l,q2)\<in>(\<lambda>(q1,a,q2). 
        (q1,[a],q2))`set D' \<and> a\<in>set l} = set D'" by force
    from goal3 show ?case apply (subst A)
        using ops unfolding trip_rel_def by parametricity
qed (insert ops, parametricity+)
qed





definition FinSemiAutomaton_reachable_states_invar where
"FinSemiAutomaton_reachable_states_invar \<A> = (\<lambda>(W,R). W \<inter> R = {} \<and>
  W \<subseteq> \<Q> \<A> \<and> R \<subseteq> \<Q> \<A> \<and> \<I> \<A> \<subseteq> R \<union> W \<and> 
  (let lts = LTS_forget_labels (\<Delta> \<A>)
    in (lts``R \<subseteq> R \<union> W) \<and> R \<union> W \<subseteq> accessible lts (\<I> \<A>)))"

lemma (in FinSemiAutomaton) 
  FinSemiAutomaton_reachable_states_invarI[intro]:
  assumes "W \<inter> R = {}" "W \<subseteq> \<Q> \<A>" "R \<subseteq> \<Q> \<A>" "\<I> \<A> \<subseteq> R \<union> W"
  assumes "(LTS_forget_labels (\<Delta> \<A>)) `` R \<subseteq> R \<union> W"
  assumes "R \<union> W \<subseteq> accessible (LTS_forget_labels (\<Delta> \<A>)) (\<I> \<A>)"
  shows "FinSemiAutomaton_reachable_states_invar \<A> (W,R)"
using assms unfolding FinSemiAutomaton_reachable_states_invar_def Let_def
  by simp

lemma (in FinSemiAutomaton)
  FinSemiAutomaton_reachable_states_invarD[dest]:
  assumes "FinSemiAutomaton_reachable_states_invar \<A> (W,R)"
  shows "W \<inter> R = {}" "W \<subseteq> \<Q> \<A>" "R \<subseteq> \<Q> \<A>" "\<I> \<A> \<subseteq> R \<union> W"
        "(LTS_forget_labels (\<Delta> \<A>)) `` R \<subseteq> R \<union> W"
        "R \<union> W \<subseteq> accessible (LTS_forget_labels (\<Delta> \<A>)) (\<I> \<A>)"
using assms unfolding FinSemiAutomaton_reachable_states_invar_def Let_def
  by simp_all

definition "FinSemiAutomaton_reachable_states_step \<A> W R u =
    W \<union> {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A> \<and> v \<notin> R}"

definition FinSemiAutomaton_reachable_states_abstr where
"FinSemiAutomaton_reachable_states_abstr \<A> \<equiv> do {
  (_, R) \<leftarrow> WHILE\<^sub>T\<^bsup>FinSemiAutomaton_reachable_states_invar \<A>\<^esup> 
    (\<lambda>(W,_). W \<noteq> {}) 
    (\<lambda>(W,R). do {
      u \<leftarrow> SPEC (\<lambda>u. u \<in> W);
      W' \<leftarrow> SPEC (\<lambda>W'. W' = FinSemiAutomaton_reachable_states_step 
                                \<A> W R u);
      RETURN (W' - {u}, insert u R)
    }) 
    (\<I> \<A>, {});
  RETURN R
}"

lemma (in FinSemiAutomaton)
  FinSemiAutomaton_reachable_states_invar_preserved:
  assumes I: "FinSemiAutomaton_reachable_states_invar \<A> (W, R)"
      and "u \<in> W"
  defines "W' \<equiv> W \<union> {v. (\<exists>c. (u, c, v) \<in> \<Delta> \<A>) \<and> v \<notin> R} - {u}"
      and "R' \<equiv> insert u R"
  notes inv = FinSemiAutomaton_reachable_states_invarD[OF I]
    shows "FinSemiAutomaton_reachable_states_invar \<A> (W', R')"
proof
  def lts \<equiv> "LTS_forget_labels (\<Delta> \<A>)"
  have W'_def': "W' = W \<union> {v. (u,v) \<in> lts} - R - {u}"
    unfolding W'_def lts_def LTS_forget_labels_def using inv by blast

  from inv(1) show "W' \<inter> R' = {}" unfolding W'_def R'_def by blast
  from inv(2) show "W' \<subseteq> \<Q> \<A>" unfolding W'_def
      by (force simp: \<Delta>_consistent)
  from inv(2,3) and `u \<in> W` show "R' \<subseteq> \<Q> \<A>" unfolding R'_def by blast
  from inv(4) show "\<I> \<A> \<subseteq> R' \<union> W'" unfolding R'_def W'_def by blast

  from inv(5) have inv': "lts `` R \<subseteq> R \<union> W" unfolding lts_def .
  from inv' have "lts `` R' \<subseteq> R' \<union> W'" unfolding R'_def W'_def' by blast
  thus "LTS_forget_labels (\<Delta> \<A>) `` R' \<subseteq> R' \<union> W'" unfolding lts_def .

  from inv(6) have inv': "R \<union> W \<subseteq> accessible lts (\<I> \<A>)" unfolding lts_def .
  hence "R' \<union> W' \<subseteq> accessible lts (\<I> \<A>)" using `u \<in> W`
      unfolding R'_def W'_def' accessible_def
      by (blast intro: rtrancl_image_advance)
  thus "R' \<union> W' \<subseteq> accessible (LTS_forget_labels (\<Delta> \<A>)) (\<I> \<A>)"
      unfolding lts_def .
qed

lemma (in FinSemiAutomaton) FinSemiAutomaton_reachable_states_measure:
  assumes "FinSemiAutomaton_reachable_states_invar \<A> (W,R)"
  assumes "u \<in> W"
    shows "(snd (W', insert u R), snd (W, R)) \<in> finite_psupset (\<Q> \<A>)"
  unfolding inv_image_def finite_psupset_def using assms by force

lemma (in FinSemiAutomaton) FinSemiAutomaton_reachable_states_invar_imp_goal:
  assumes "FinSemiAutomaton_reachable_states_invar \<A> ({}, R)"
  shows "R = SemiAutomaton_reachable_states \<A>"
proof-
  def lts \<equiv> "LTS_forget_labels (\<Delta> \<A>)"
  with assms have "lts `` R \<subseteq> R" by blast
  hence closed: "accessible lts R \<subseteq> R" unfolding accessible_def
      by (simp add: Image_closed_trancl)
  from assms have "\<I> \<A> \<subseteq> R" by blast
  hence "accessible lts (\<I> \<A>) \<subseteq> accessible lts R"
      by (rule accessible_mono)
  hence "accessible lts (\<I> \<A>) \<subseteq> R" using closed by blast
  moreover from assms have "R \<subseteq> accessible lts (\<I> \<A>)"
      unfolding lts_def by blast
  ultimately have R_props: "R = accessible lts (\<I> \<A>)" by simp
  also have "... = SemiAutomaton_reachable_states \<A>"
      by (force simp: lts_def SemiAutomaton_reachable_states_reachable
                      LTS_is_reachable_from_initial_alt_def)
  finally show ?thesis .
qed

lemma (in FinSemiAutomaton) FinSemiAutomaton_reachable_states_abstr_correct:
    "FinSemiAutomaton_reachable_states_abstr \<A> \<le> 
         SPEC (\<lambda>R. R = SemiAutomaton_reachable_states \<A>)"
unfolding FinSemiAutomaton_reachable_states_abstr_def
          FinSemiAutomaton_reachable_states_step_def
apply (intro refine_vcg)
apply (rule wf_inv_image, rule finite_psupset_wf, fact finite_\<Q>)
apply (rule, simp_all add: \<I>_consistent accessible_subset_ws)
apply (clarify, intro conjI)
apply (erule (1) FinSemiAutomaton_reachable_states_invar_preserved)
apply (erule (1) FinSemiAutomaton_reachable_states_measure)
apply (erule FinSemiAutomaton_reachable_states_invar_imp_goal)
done

lemma (in FinSemiAutomaton) 
    FinSemiAutomaton_reachable_states_step_refine:
"FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>} (\<lambda>v W. 
          if v\<in>R then RETURN W else RETURN (insert v W)) W \<le> 
   SPEC (\<lambda>W'. W' = FinSemiAutomaton_reachable_states_step \<A> W R u)"
  unfolding FinSemiAutomaton_reachable_states_step_def
  by (rule FOREACH_rule[where I="\<lambda>it W'. W' = W \<union>
                                   ({v. \<exists>c.(u,c,v)\<in>\<Delta> \<A> \<and> v\<notin>R}-it)"])
     (auto intro: refine_vcg finite_subset[OF _ finite_\<Q>] 
           simp: \<Delta>_consistent)


definition FinSemiAutomaton_reachable_states_impl where
"FinSemiAutomaton_reachable_states_impl \<A> \<equiv> do {
  (_, R) \<leftarrow> WHILE\<^sub>T
    (\<lambda>(W,_). W \<noteq> {}) 
    (\<lambda>(W,R). do {
      u \<leftarrow> SPEC (\<lambda>u. u \<in> W);
      W' \<leftarrow> FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>} 
             (\<lambda>v W. if v\<in>R then RETURN W else RETURN (insert v W)) W;
      RETURN (W' - {u}, insert u R)
    }) 
    (\<I> \<A>, {});
  RETURN R
}"


lemma (in FinSemiAutomaton)
    FinSemiAutomaton_reachable_states_refine:
       "FinSemiAutomaton_reachable_states_impl \<A> \<le> \<Down>Id
             (FinSemiAutomaton_reachable_states_abstr \<A>)"
unfolding FinSemiAutomaton_reachable_states_impl_def 
          FinSemiAutomaton_reachable_states_abstr_def
apply refine_rcg
apply (rule IdI)
apply simp_all[2]
apply (clarify, rule FinSemiAutomaton_reachable_states_step_refine)
apply simp_all
done


abbreviation "dflt_NFA_rel 
  \<equiv> NFA_rel dflt_rs_rel dflt_rs_rel dflt_rs_rel dflt_rs_rel dflt_rs_rel"

lemma dflt_NFA_rel_sv[relator_props]:
  assumes [relator_props]: "single_valued R\<Q>" "single_valued R\<Sigma>"
  shows "single_valued (\<langle>R\<Q>,R\<Sigma>\<rangle>dflt_NFA_rel)"
  by tagged_solver



(*
definition nfa_succ_label_it where "nfa_succ_label_it \<A> u = FOREACH {(c,v). (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_succ_it where "nfa_succ_it \<A> u = FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_pred_label_it where "nfa_pred_label_it \<A> v = FOREACH {(u,c). (u,c,v) \<in> \<Delta> \<A>}"
definition nfa_pred_it where "nfa_pred_it \<A> v = FOREACH {u. \<exists>c. (u,c,v) \<in> \<Delta> \<A>}"*)


term is_set_to_list
term is_map_to_list

context begin interpretation autoref_syn .
definition [simp]: "op_nfa_successors u \<A> \<equiv> {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>}"
lemma [autoref_op_pat]: "{v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>} \<equiv> 
  (OP op_nfa_successors :::\<^sub>i Is \<rightarrow>\<^sub>i \<langle>Is,Il\<rangle>\<^sub>ii_NFA \<rightarrow>\<^sub>i \<langle>Is\<rangle>\<^sub>ii_set)$u$\<A>"
  by simp
end

definition nfa_succ_set_rel'_def_internal:
  "nfa_succ_set_rel' R\<Q> R\<Sigma> \<equiv> \<langle>R\<Q>,\<langle>R\<Q>,R\<Sigma>\<rangle>dflt_NFA_rel\<rangle>prod_rel"
lemma nfa_succ_set_rel'_def: "\<langle>R\<Q>,R\<Sigma>\<rangle>nfa_succ_set_rel' = \<langle>R\<Q>,\<langle>R\<Q>,R\<Sigma>\<rangle>dflt_NFA_rel\<rangle>prod_rel"
  unfolding nfa_succ_set_rel'_def_internal[abs_def]
  by (simp add: relAPP_def)

definition nfa_succ_set_rel_internal_def:
  "nfa_succ_set_rel R\<Q> R\<Sigma> \<equiv> 
  \<langle>R\<Q>,R\<Sigma>\<rangle>nfa_succ_set_rel' O br (\<lambda>(u,\<A>). op_nfa_successors u \<A>) (\<lambda>_. True)"
lemma nfa_succ_set_rel_def: "\<langle>R\<Q>,R\<Sigma>\<rangle>nfa_succ_set_rel 
  = \<langle>R\<Q>,R\<Sigma>\<rangle>nfa_succ_set_rel' O br (\<lambda>(u,\<A>). op_nfa_successors u \<A>) (\<lambda>_. True) "
  by (simp add: relAPP_def nfa_succ_set_rel_internal_def)

lemma autoref_nfa_successors[autoref_rules]:
  "(\<lambda>u \<A>. (u,\<A>),op_nfa_successors)\<in>R\<Q> \<rightarrow> \<langle>R\<Q>,R\<Sigma>\<rangle>dflt_NFA_rel \<rightarrow> \<langle>R\<Q>,R\<Sigma>\<rangle>nfa_succ_set_rel"
  apply (intro fun_relI)
  apply (simp add: nfa_succ_set_rel_def)
  apply rule
  apply (simp add: nfa_succ_set_rel'_def)
  apply (rule prod_relI, assumption+)
  apply (auto simp: br_def)
  done

(* TODO: Move to Relators! Or define unit_rel =abbrev= Id *)
lemma [relator_props]: "single_valued unit_rel"
  apply (auto intro: single_valuedI) done

definition foo where "foo \<A> u f s \<equiv> FOREACH (\<Delta> \<A>) (\<lambda>(u',_,v) \<sigma>. 
  if u = u' then f v \<sigma> else RETURN \<sigma>) s"

thm autoref_itype

lemma refine_optI: "\<lbrakk> (c',a)\<in>R; c=c' \<rbrakk> \<Longrightarrow> (c,a)\<in>R" 
  by simp

(*
schematic_lemma 
  assumes [autoref_rules]: "(\<A>impl,\<A>)\<in>\<langle>nat_rel,nat_rel\<rangle>dflt_NFA_rel"
  assumes [autoref_rules]: "(u_impl,u)\<in>nat_rel"
  shows "(?f::?'c, 
    FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>} 
      (\<lambda>v W. RETURN ()) ()
  ) \<in> ?R"
  using [[autoref_trace_failed_id]]
  apply (autoref (keep_goal))

  apply (autoref_trans_step)
  apply (autoref_side)

xxx: ?tsl implementieren

  thm unit_rel_def
  apply (rule single_valued_Id)
  apply tagged_solver

  done
*)


(*
schematic_lemma 
  assumes [relator_props]: "single_valued RS"
  (*assumes [relator_props]: "single_valued R\<Sigma>"
  assumes [relator_props]: "single_valued R\<Q>"*)
  assumes [autoref_rules]: "(ai,a)\<in>\<langle>nat_rel,nat_rel\<rangle>dflt_NFA_rel"
  assumes [autoref_rules]: "(ui,u)\<in>nat_rel"
  assumes [autoref_rules]: "(fi,f)\<in>nat_rel \<rightarrow> RS \<rightarrow> \<langle>RS\<rangle>nres_rel"
  assumes [autoref_rules]: "(si,s)\<in>RS"
  shows "(RETURN (?c::?'c), foo a u f s) \<in> ?R"
  unfolding foo_def[abs_def]
  apply autoref_monadic
  apply (autoref_trans_step)
  apply (autoref_side)
  apply (rule GEN_OP_tagI)
  apply (autoref_trans_step)
  apply (autoref_side)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)
  apply (autoref_trans_step)

  apply (rule autoref_detI)
  using [[autoref_trace_failed_id]]
  apply (autoref (keep_goal))

  apply autoref_monadic

  thm autoref_detI
  apply (rule autoref_detI)
  unfolding foo_def[abs_def]
  thm autoref_detI

  using [[autoref_trace_failed_id]]
  using [[autoref_trace_intf_unif]]
  apply (autoref (keep_goal))
  apply (tactic {* optimize_iterators_tac @{context} 1  *})
  done

(*
  apply (autoref_trans_step)
  apply (autoref_side)
  apply (rule GEN_OP_tagI)
  apply (autoref_trans_step)
  apply (autoref_side)
*)

thm iterator_simps
*)

(*
definition dflt_nfa_succ_it where
  "dflt_nfa_succ_it \<A> u f = ((rs_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True)
       (\<lambda>(u',_,v) \<sigma>. if u = u' then f v \<sigma> else \<sigma>)"


definition dflt_nfa_succ_it where
  "dflt_nfa_succ_it \<A> u f = (map_iterator_dom (rm_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True)
       (\<lambda>(u',_,v) \<sigma>. if u = u' then f v \<sigma> else \<sigma>)"


schematic_lemma 
  assumes [autoref_rules]: "(\<A>impl,\<A>)\<in>\<langle>nat_rel,nat_rel\<rangle>dflt_NFA_rel"
  assumes [autoref_rules]: "(u_impl,u)\<in>nat_rel"
  shows "(?f::?'c, 
    FOREACH {v. \<exists>c. (u,c,v) \<in> \<Delta> \<A>} 
      (\<lambda>v W. RETURN ()) ()
  ) \<in> ?R"
  using [[autoref_trace_failed_id]]
  apply (autoref (keep_goal))

  apply (autoref_trans_step)
  apply (autoref_side)
  thm unit_rel_def
  apply (rule single_valued_Id)
  apply tagged_solver

  done

*)

section {* Implementation of iterators *}

definition dflt_nfa_succ_label_it where
  "dflt_nfa_succ_label_it \<A> u f = (map_iterator_dom (rm_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True)
       (\<lambda>(u',c,v) \<sigma>. if u = u' then f (c,v) \<sigma> else \<sigma>)"

definition dflt_nfa_succ_it where
  "dflt_nfa_succ_it \<A> u f = (map_iterator_dom (rm_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True)
       (\<lambda>(u',_,v) \<sigma>. if u = u' then f v \<sigma> else \<sigma>)"

definition dflt_nfa_pred_label_it where
  "dflt_nfa_pred_label_it \<A> v f = (map_iterator_dom (rm_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True) 
       (\<lambda>(u,c,v') \<sigma>. if v = v' then f (u,c) \<sigma> else \<sigma>)"

definition dflt_nfa_pred_it where
  "dflt_nfa_pred_it \<A> v f = (map_iterator_dom (rm_iterateoi (\<Delta>_impl \<A>))) (\<lambda>_. True)
       (\<lambda>(u,_,v') \<sigma>. if v = v' then f u \<sigma> else \<sigma>)"

(* TODO: integrate iterators somehow *)

(*
lemma "GEN_OP dflt_nfa_succ_label_it nfa_succ_label_it
         (\<langle>R\<Q>, R\<Sigma>\<rangle>dflt_NFA_rel \<rightarrow> R\<Q> \<rightarrow> (\<langle>R\<Sigma>,R\<Q>\<rangle>prod_rel \<rightarrow> R \<rightarrow> R) \<rightarrow> R \<rightarrow> R)"
*)


subsection "Tests"
schematic_lemma 
  assumes [autoref_rules]: "(\<A>impl,\<A>)\<in>\<langle>nat_rel,nat_rel\<rangle>dflt_NFA_rel"
  shows "(?f::?'c, NFA_reverse \<A>) \<in> ?R"
  apply (autoref (keep_goal))
  done

schematic_lemma 
  assumes [autoref_rules]: "(\<A>impl,\<A>)\<in>\<langle>nat_rel,nat_rel\<rangle>dflt_NFA_rel"
  shows "(?f::?'c, RETURN (NFA_rename_states \<A> (\<lambda>x. x+1))) \<in> ?R"
  apply (autoref_monadic)
  done

schematic_lemma
  shows "(?f::?'c, NFA_construct_simple 
             ([], [], [(1::nat, 1::nat, 2::nat)], [], [])) \<in> ?R"
  by autoref


end
