(*<*)
header \<open>Miscellaneous Tests\<close>
theory Sepref_Minitests
imports 
  "../Sepref"
  "../../Collections/Examples/Autoref/Succ_Graph"
  "~~/src/HOL/Library/Code_Target_Numeral"
begin
  definition "bar s \<equiv> do {
    x\<leftarrow>RETURN (insert (1::nat) s);
    y\<leftarrow>RETURN (insert (1::nat) x);
    ASSERT (y\<noteq>{});
    if 1\<in>y then
      RETURN (y)
    else RETURN (insert (1::nat) y)
  }"

definition "bar2 s \<equiv> do {
    if (1::nat)\<in>s then
      RETURN True
    else RETURN False
  }"


definition "bar' \<equiv> do {
    y \<leftarrow> RETURN {1,1::nat};
    if 1\<in>y then
      RETURN (y)
    else RETURN (insert 1 y)
  }"


definition "foo \<equiv> do {
  s \<leftarrow> RETURN [1,1,1::nat];
  y \<leftarrow> RETURN ({}::nat set);
  RECT (\<lambda>D l. 
    case l of 
      [] \<Rightarrow> RETURN (case [0,1] of [] \<Rightarrow> {} | x#xs \<Rightarrow> {x})
    | x#l \<Rightarrow> do {
        (*r \<leftarrow> RETURN (y\<union>y);*)
        r \<leftarrow> D l;
        (*RETURN (insert (x+1) r)*)
        RETURN (if x<1 then insert x r else insert (x+1) r)
    }) s
  }
"

definition "simple_rec \<equiv> do {
  RECT (\<lambda>D l. case l of 
    [] \<Rightarrow> RETURN 0 
  | x#xs \<Rightarrow> do {
      a\<leftarrow>D xs;
      RETURN (a+x)
    }
  ) [1,0::nat]
}"


definition "simple_while \<equiv> do {
  WHILEIT (\<lambda>(i,m). i \<notin> dom m) (\<lambda>(i,m). i\<ge>1) (\<lambda>(i,m). do {
    let i=i+1;
    RETURN (i,m)
  }) (10::nat, Map.empty::nat \<rightharpoonup> nat)
}"

definition "lst_mem_to_sets \<equiv> do {
  l\<leftarrow>RETURN [0,1,0::nat];
  RECT (\<lambda>D l. 
    case l of 
      [] \<Rightarrow> RETURN []
    | x#l \<Rightarrow> do {
        r \<leftarrow> D l;
        RETURN ({x}#r)
    }) l
  }
"

definition "lst_mem_to_sets_nonlin \<equiv> do {
  l\<leftarrow>RETURN [0,1,0::nat];
  RECT (\<lambda>D l. 
    case l of 
      [] \<Rightarrow> RETURN []
    | x#l \<Rightarrow> do {
        r \<leftarrow> D l;
        RETURN ({x,x}#r)
    }) l
  }
"

definition "lst_mem_to_sets_nonlin2 \<equiv> do {
  l\<leftarrow>RETURN [0,1,0::nat];
  RECT (\<lambda>D l. 
    case l of 
      [] \<Rightarrow> RETURN []
    | x#l \<Rightarrow> do {
        r \<leftarrow> D l;
        RETURN ({x}#r@r)
    }) l
  }
"

definition "lst_nonlin \<equiv> do {
  l\<leftarrow>RETURN [0::nat];
  RETURN (case l of [] \<Rightarrow> l | x#xs \<Rightarrow> x#l)
}"

definition "lst_nonlin2 \<equiv> do {
  l\<leftarrow>RETURN [0::nat];
  RETURN (case l of [] \<Rightarrow> [] | x#xs \<Rightarrow> x#(x#xs))
}"

definition "lst_nonlin3 \<equiv> do {
  l\<leftarrow>RETURN [{0::nat}];
  RETURN (case l of [] \<Rightarrow> [] | x#xs \<Rightarrow> x#(x#xs))
}"

definition "lst_nonlin4 \<equiv> do {
  l\<leftarrow>RETURN [{0::nat}];
  RETURN (l@l)
}"


definition "dup_arg == do {
  x <- RETURN [1::nat];
  RETURN (x@x)
}"

definition "big_list == RETURN [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1::nat]"
definition "big_list2 == do {
  x1 <- RETURN ({}::nat set);
  x2 <- RETURN {};
  x3 <- RETURN {};
  x4 <- RETURN {};
  x5 <- RETURN {};
  x6 <- RETURN {};
  x7 <- RETURN {};
  x8 <- RETURN {};
(*  x9 <- RETURN {};
  x10 <- RETURN {};
  x11 <- RETURN {};
  x12 <- RETURN {};
  x13 <- RETURN {};
  x14 <- RETURN {};
  x15 <- RETURN {};
  x16 <- RETURN {};
*)
  RETURN [x1,x2,x3,x4,x5,x6,x7,x8] (*,x9,x10,x11,x12,x13,x14,x14,x15,x16]*)
}"


term Set.insert

definition "foo1 \<equiv> 
  case [] of 
    [] \<Rightarrow> RETURN {} 
  | x#l \<Rightarrow> do {
      r \<leftarrow> RETURN ({}::nat set);
      RETURN (if x<1 then insert x r else insert x r)
  }
"

definition "basic_foreach \<equiv> do {
  FOREACH\<^sub>C {0,1::nat} (\<lambda>s. s>1) (\<lambda>x s. RETURN (x+s)) 0
}"

definition "basic_foreach2 \<equiv> do {
  FOREACH\<^sub>C {0,1::nat} (\<lambda>_. True) (\<lambda>x s. RETURN (insert x s)) {}
}"


definition "basic_option \<equiv> do {
  let a={};
  let b=Some a;
  let c=Some (0::nat);
  let d=Some (1::nat);
  RETURN (a,b,c=d)
}"


definition dfs :: "(('a\<times>'a) set) \<Rightarrow> 'a \<Rightarrow> 'a \<Rightarrow> ('a set \<times> bool) nres" 
  where
  "\<And>E vd v0. dfs E vd v0 \<equiv> REC\<^sub>T (\<lambda>D (V,v). 
    if v=vd then RETURN (V,True)
    else if v\<in>V then RETURN (V,False)
    else do {
      let V=insert v V;
      FOREACH\<^sub>C (E``{v}) (\<lambda>(_,b). b=False) (\<lambda>v' (V,_). D (V,v')) (V,False) }
  ) ({},v0)"


lemma ID_unfold_vars: "ID x y T \<Longrightarrow> x\<equiv>y" by simp

schematic_lemma testsuite_basic_param:
  fixes s
  notes [id_rules] = 
    itypeI[of s "TYPE(nat set)"]
  shows 
    "hn_refine (emp * hn_ctxt is_hashset s s') (?c1::?'c1 Heap) ?\<Gamma>1' ?R1 (bar s)"
    "hn_refine (emp * hn_ctxt is_hashset s s') (?c2::?'c2 Heap) ?\<Gamma>2' ?R2 (bar2 s)"

  unfolding bar_def bar2_def
  using [[id_debug]]
  by sepref+



schematic_lemma testsuite_basic1:
  shows "hn_refine emp (?c1::?'c1 Heap) ?\<Gamma>1' ?R1 bar'"
  and "hn_refine emp (?c2::?'c2 Heap) ?\<Gamma>2' ?R2 foo"
  and "hn_refine emp (?c3::?'c3 Heap) ?\<Gamma>3' ?R3 simple_rec"
  and "hn_refine emp (?c4::?'c4 Heap) ?\<Gamma>4' ?R4 lst_mem_to_sets"
  and "hn_refine emp (?c5::?'c5 Heap) ?\<Gamma>5' ?R5 lst_mem_to_sets_nonlin"
  and "hn_refine emp (?c6::?'c6 Heap) ?\<Gamma>6' ?R6 lst_mem_to_sets_nonlin2"
  and "hn_refine emp (?c7::?'c7 Heap) ?\<Gamma>7' ?R7 lst_nonlin"
  and "hn_refine emp (?c8::?'c8 Heap) ?\<Gamma>8' ?R8 lst_nonlin2"
  and "hn_refine emp (?c9::?'c9 Heap) ?\<Gamma>9' ?R9 lst_nonlin3"
  and "hn_refine emp (?ca::?'ca Heap) ?\<Gamma>a' ?Ra lst_nonlin4"
  unfolding bar'_def foo_def simple_rec_def lst_mem_to_sets_def 
    lst_mem_to_sets_nonlin_def lst_mem_to_sets_nonlin2_def
    lst_nonlin_def lst_nonlin2_def lst_nonlin3_def lst_nonlin4_def
  using [[goals_limit = 1]]
  apply sepref+
  done


schematic_lemma testsuite_basic2:
  shows "hn_refine emp (?c1::?'c1 Heap) ?\<Gamma>1' ?R1 dup_arg"
  and "hn_refine emp (?c2::?'c2 Heap) ?\<Gamma>2' ?R2 big_list"
  and "hn_refine emp (?c3::?'c3 Heap) ?\<Gamma>3' ?R3 big_list2"
  and "hn_refine emp (?c4::?'c4 Heap) ?\<Gamma>4' ?R4 foo1"
  and "hn_refine emp (?c5::?'c5 Heap) ?\<Gamma>5' ?R5 basic_foreach"
  and "hn_refine emp (?c6::?'c6 Heap) ?\<Gamma>6' ?R6 basic_foreach2"
  and "hn_refine emp (?c7::?'c7 Heap) ?\<Gamma>7' ?R7 basic_option"
  and "hn_refine emp (?c8::?'c8 Heap) ?\<Gamma>8' ?R8 simple_while"
  unfolding dup_arg_def big_list_def big_list2_def foo1_def 
    basic_foreach_def basic_foreach2_def simple_while_def
    basic_option_def
  using [[goals_limit = 2, id_debug]]
  apply sepref+
  done

schematic_lemma testsuite_dfs:
  fixes succ'
  notes [id_rules] = 
    itypeI[of E "TYPE(nat i_slg)"]
    itypeI[of vd "TYPE(nat)"]
    itypeI[of v0 "TYPE(nat)"]
  (*assumes [sepref_import_param]: 
    "(succ',succ)\<in>nat_rel \<rightarrow> \<langle>nat_rel\<rangle>list_set_rel"*)
  shows "hn_refine 
    ( hn_val nat_rel v0 v0' * hn_val nat_rel vd vd' 
     * hn_val (\<langle>nat_rel\<rangle>slg_rel) E succ')
    (?c::?'c Heap) ?\<Gamma>' ?R (dfs E vd v0)"
  unfolding dfs_def
  using [[goals_limit = 1]]
  apply sepref
  done

concrete_definition imp_dfs uses testsuite_dfs
prepare_code_thms imp_dfs_def
print_theorems
export_code imp_dfs checking SML_imp 

definition "simple_algo a c m x = do {
  let s = {m};
  RECT (\<lambda>D (x,s,l).
    if x\<in>s then RETURN l
    else D ((a*x+c) mod m,insert x s,l+1)
  ) (x::nat,s,0::nat)
}"

schematic_lemma sa_impl:
  notes [autoref_tyrel] = ty_REL[where 'a = "nat set" 
    and R="\<langle>nat_rel\<rangle>iam_set_rel"]
  assumes [autoref_rules]: "(a,a)\<in>nat_rel" 
  assumes [autoref_rules]: "(c,c)\<in>nat_rel" 
  assumes [autoref_rules]: "(m,m)\<in>nat_rel" 
  assumes [autoref_rules]: "(x,x)\<in>nat_rel" 
  shows "(?c::?'c,simple_algo a c m x)\<in>?R"
  unfolding simple_algo_def[abs_def]
  using [[autoref_trace_failed_id]]
  apply autoref_monadic
  done

concrete_definition sa_impl uses sa_impl
prepare_code_thms sa_impl_def
export_code sa_impl checking SML


schematic_lemma sai_impl:
  fixes a c m x
  notes [id_rules] = 
    itypeI[of a "TYPE(nat)"]
    itypeI[of c "TYPE(nat)"]
    itypeI[of m "TYPE(nat)"]
    itypeI[of x "TYPE(nat)"]
  shows "hn_refine 
    (   hn_val nat_rel a a
      * hn_val nat_rel c c 
      * hn_val nat_rel m m 
      * hn_val nat_rel x x 
    )
    (?c::?'c Heap) ?\<Gamma>' ?R (simple_algo a c m x)"
  unfolding simple_algo_def
  using [[goals_limit = 1]]
  using [[id_debug]]
  apply (tactic {* Sepref.sepref_tac @{context} 1 *})
  apply -
  done


concrete_definition sai_impl uses sai_impl
prepare_code_thms sai_impl_def
export_code sai_impl checking SML

term Array.upd

definition "sad_impl a c m x \<equiv> do {
  s\<leftarrow>Array.new m False;
  heap.fixp_fun (\<lambda>D (x,s,l). do {
    brk\<leftarrow>Array.nth s x;
    if brk then return l
    else do {
      _\<leftarrow>Array.len s;
      _\<leftarrow>if x<l then return True else return False; 
      s\<leftarrow>Array.upd x True s;
      D ((a*x+c) mod m,s,l+1)
    }
  }) (x,s,0::nat)
}"

definition "sad_impl2 a c m x \<equiv> do {
  s\<leftarrow>Array.new m False;
  heap.fixp_fun (\<lambda>D (x,l). do {
    brk\<leftarrow>Array.nth s x;
    if brk then return l
    else do {
      Array.upd x True s;
      D ((a*x+c) mod m,l+1)
    }
  }) (x,0::nat)
}"

prepare_code_thms sad_impl_def
prepare_code_thms sad_impl2_def

code_thms sai_impl 

lemma
 "ias_ins k a = do {
    l\<leftarrow>Array.len a;
    if k<l then 
      Array.upd k True a
    else do {
      let newsz = max (k+1) (2 * l);
      a\<leftarrow>Array_Blit.array_grow a newsz False;
      Array.upd k True a
    }    
  }"
  unfolding ias_ins_def
  apply (fo_rule cong[OF arg_cong])
  apply auto
  done

export_code sa_impl sad_impl sad_impl2 sai_impl 
  checking SML_imp

schematic_lemma
  shows "hn_refine emp (?c1::?'c1 Heap) ?\<Gamma>1' ?R1 
  (do {
    let x=(1::nat);
    RETURN {x,x}
  })"
  apply sepref_dbg_id
  apply sepref_dbg_monadify
  apply sepref_dbg_lin_ana
  oops

term hn_invalid



end
(*>*)

