header \<open>Imperative Implementation of of Nested DFS (HPY-Improvement)\<close>
theory Sepref_NDFS
imports 
  "../Sepref"
  "../../Collections/Examples/Autoref/Nested_DFS"
  "Sepref_Graph"
  "~~/src/HOL/Library/Code_Target_Numeral"
begin

typedecl 'v i_red_witness

lemma id_red_witness[id_rules]:
  "red_init_witness ::\<^sub>i TYPE('v \<Rightarrow> 'v \<Rightarrow> 'v i_red_witness option)"
  "prep_wit_red ::\<^sub>i TYPE('v \<Rightarrow> 'v i_red_witness option \<Rightarrow> 'v i_red_witness option)"
  by simp_all

definition 
  red_witness_rel_def_internal: "red_witness_rel R \<equiv> \<langle>\<langle>R\<rangle>list_rel,R\<rangle>prod_rel"

lemma red_witness_rel_def: "\<langle>R\<rangle>red_witness_rel \<equiv> \<langle>\<langle>R\<rangle>list_rel,R\<rangle>prod_rel"
  unfolding red_witness_rel_def_internal[abs_def] by (simp add: relAPP_def)

lemma red_witness_rel_sv[constraint_rules]:
  "single_valued R \<Longrightarrow> single_valued (\<langle>R\<rangle>red_witness_rel)"
  unfolding red_witness_rel_def
  by (blast intro: relator_props) (* TODO/FIXME: tagged_solver should
    do that, but setting in DFS_Framework_Aux prevents this (?)*)

lemma [sepref_fr_rules]: "hn_refine
  (hn_val R u u' * hn_val R v v')
  (return (red_init_witness u' v'))
  (hn_val R u u' * hn_val R v v')
  (hn_option_aux (pure (\<langle>R\<rangle>red_witness_rel)))
  (RETURN$(red_init_witness$u$v))"
  apply simp
  unfolding red_init_witness_def
  apply rule
  apply (sep_auto simp: hn_ctxt_def pure_def red_witness_rel_def)
  done

lemma [sepref_fr_rules]: "hn_refine
  (hn_val R u u' * hn_option (pure (\<langle>R\<rangle>red_witness_rel)) w w')
  (return (prep_wit_red u' w'))
  (hn_val R u u' * hn_option (pure (\<langle>R\<rangle>red_witness_rel)) w w')
  (hn_option_aux (pure (\<langle>R\<rangle>red_witness_rel)))
  (RETURN$(prep_wit_red$u$w))"
  apply rule
  apply (cases w)
  apply (sep_auto simp: hn_ctxt_def pure_def red_witness_rel_def)
  apply (cases w')
  apply (sep_auto simp: hn_ctxt_def pure_def red_witness_rel_def)
  apply (sep_auto simp: hn_ctxt_def pure_def red_witness_rel_def)
  done

schematic_lemma testsuite_red_dfs:
  fixes succ succ'
  notes [id_rules] = 
    itypeI[of E "TYPE(nat i_slg)"]
    itypeI[of onstack "TYPE(nat set)"]
    itypeI[of V "TYPE(nat set)"]
    itypeI[of u "TYPE(nat)"]
  shows "hn_refine 
    (   hn_ctxt (is_graph nat_rel) E succ'
      * hn_val nat_rel u u' 
      * hn_ctxt is_ias V V' 
      * hn_ctxt is_ias onstack onstack'
    )
    (?c::?'c Heap) ?\<Gamma>' ?R (red_dfs E onstack V u)"
  unfolding red_dfs_def
  by sepref

concrete_definition red_dfs_impl uses testsuite_red_dfs
prepare_code_thms red_dfs_impl_def
export_code red_dfs_impl checking SML_imp 

lemma id_red_dfs[id_rules]: 
  "red_dfs ::\<^sub>i TYPE(
    'a i_slg \<Rightarrow> 'a set \<Rightarrow> 'a set \<Rightarrow> 'a 
    \<Rightarrow> ('a set * 'a i_red_witness option) nres)"
  by simp

lemma skel_red_dfs[sepref_la_skel]: "SKEL (red_dfs$E$os$V$s) = la_op (E,os,V,s)"
  by simp

lemma id_init_wit_blue[id_rules]: 
  "init_wit_blue ::\<^sub>i TYPE('a \<Rightarrow> 'a i_red_witness option \<Rightarrow> 'a blue_witness)" 
  by simp

lemma hn_blue_wit[sepref_import_param]: 
  "(NO_CYC,NO_CYC)\<in>blue_wit_rel" 
  "(prep_wit_blue,prep_wit_blue)\<in>nat_rel\<rightarrow>blue_wit_rel\<rightarrow>blue_wit_rel"
  "(op=,op=)\<in>blue_wit_rel\<rightarrow>blue_wit_rel\<rightarrow>bool_rel"
  by simp_all

lemma hn_init_wit_blue[sepref_fr_rules]: "hn_refine
  (hn_val nat_rel v v' * hn_option (pure (\<langle>nat_rel\<rangle>red_witness_rel)) w w')
  (return (init_wit_blue v' w'))
  (hn_val nat_rel v v' * hn_option (pure (\<langle>nat_rel\<rangle>red_witness_rel)) w w')
  (pure blue_wit_rel)
  (RETURN$(init_wit_blue$v$w))"
  apply rule
  apply (sep_auto simp: hn_ctxt_def pure_def)
  apply (case_tac w, sep_auto)
  apply (case_tac w', sep_auto, sep_auto simp: red_witness_rel_def)
  done

lemma hn_extract_res[sepref_import_param]: 
  "(extract_res, extract_res) \<in> blue_wit_rel \<rightarrow> Id"
  by simp

lemma hn_red_dfs[sepref_fr_rules]:
  shows "hn_refine
   (  hn_ctxt (is_graph nat_rel) E succ' 
    * hn_val nat_rel u u' 
    * hn_ctxt is_ias V V' 
    * hn_ctxt is_ias onstack onstack')
   (red_dfs_impl succ' u' V' onstack')
   (  hn_ctxt (is_graph nat_rel) E succ'
    * hn_ctxt is_ias onstack onstack'
    * hn_invalid V V'
    * hn_invalid u u')
   (hn_prod_aux is_ias (hn_option_aux (pure (\<langle>nat_rel\<rangle>red_witness_rel))))
   (red_dfs$E$onstack$V$u)"
  using red_dfs_impl.refine by (simp add: star_aci)

schematic_lemma testsuite_blue_dfs:
  fixes succ' E A s
  notes [id_rules] = 
    itypeI[of E "TYPE(nat i_slg)"]
    itypeI[of A "TYPE(nat set)"]
    itypeI[of s "TYPE(nat)"]
  shows "hn_refine 
    (
        hn_ctxt (is_graph nat_rel) E succ'
      * hn_val nat_rel s s' 
      * hn_ctxt is_ias A A'
    )
    (?c::?'c Heap) ?\<Gamma>' ?R (blue_dfs E A s)"
  unfolding blue_dfs_def
  by sepref
  
concrete_definition blue_dfs_impl for succ' A' s' uses testsuite_blue_dfs
prepare_code_thms blue_dfs_impl_def
export_code blue_dfs_impl checking SML_imp 

theorem blue_dfs_impl_correct:
  fixes E
  assumes "finite (E\<^sup>*``{v0})"
  shows "<is_ias A A_impl * is_graph nat_rel E succ_impl>
      blue_dfs_impl succ_impl A_impl v0 
    <\<lambda>r. is_ias A A_impl * is_graph nat_rel E succ_impl
      * \<up>(
        case r of None \<Rightarrow> \<not>has_acc_cycle E A v0
      | Some (v,pc,pv) \<Rightarrow> is_acc_cycle E A v0 v pv pc
    )>\<^sub>t"
  using assms
  apply vcg
  apply (rule cons_post_rule)
  apply (rule imp_correctI)
  apply (rule hn_refine_cons_pre[rotated])
  apply (rule blue_dfs_impl.refine)
  apply (sep_auto simp: hn_ctxt_def pure_def)
  apply (rule blue_dfs_correct)
  apply simp
  apply (sep_auto simp: hn_ctxt_def pure_def)
  done

text \<open> We tweak the initialization vector of the outer DFS,
  to allow pre-initialization of the size of the array-lists.
  When set to the number of nodes, array-lists will never be resized 
  during the run, which saves some time. \<close>
lemma testsuite_blue_dfs_modify:
  "({}::nat set, {}::nat set, {}::nat set, s) 
  = (empty_set_sz n, empty_set_sz n, empty_set_sz n, s)"
  by simp

schematic_lemma testsuite_blue_dfs_sz:
  fixes succ' E A s and n::nat
  notes [id_rules] = 
    itypeI[of E "TYPE(nat i_slg)"]
    itypeI[of A "TYPE(nat set)"]
    itypeI[of s "TYPE(nat)"]
    itypeI[of n "TYPE(nat)"]
  shows "hn_refine 
    (
        hn_ctxt (is_graph nat_rel) E succ'
      * hn_val nat_rel s s' 
      * hn_val nat_rel n n' 
      * hn_ctxt is_ias A A'
    )
    (?c::?'c Heap) ?\<Gamma>' ?R (blue_dfs E A s)"
  unfolding blue_dfs_def
  unfolding testsuite_blue_dfs_modify[where n=n]
  by sepref


concrete_definition blue_dfs_sz_impl 
  for n' succ' A' s' uses testsuite_blue_dfs_sz
prepare_code_thms blue_dfs_sz_impl_def
export_code blue_dfs_sz_impl checking SML_imp 

theorem blue_dfs_sz_impl_correct:
  fixes E
  assumes "finite (E\<^sup>*``{v0})"
  shows "<is_ias A A_impl * is_graph nat_rel E succ_impl>
      blue_dfs_sz_impl n succ_impl A_impl v0 
    <\<lambda>r. is_ias A A_impl * is_graph nat_rel E succ_impl
      * \<up>(
        case r of None \<Rightarrow> \<not>has_acc_cycle E A v0
      | Some (v,pc,pv) \<Rightarrow> is_acc_cycle E A v0 v pv pc
    )>\<^sub>t"
  using assms
  apply vcg
  apply (rule cons_post_rule)
  apply (rule imp_correctI)
  apply (rule hn_refine_cons_pre[rotated])
  apply (rule blue_dfs_sz_impl.refine)
  apply (sep_auto simp: hn_ctxt_def pure_def)
  apply (rule blue_dfs_correct)
  apply simp
  apply (sep_auto simp: hn_ctxt_def pure_def)
  done

end

