theory Array_Rev
imports 
  "../Sep_Main" 
  "~~/src/HOL/Imperative_HOL/ex/Sublist"
begin

  fun swap :: "'a\<Colon>heap array \<Rightarrow> nat \<Rightarrow> nat \<Rightarrow> unit Heap" where
  "swap a i j = do {
     x \<leftarrow> Array.nth a i;
     y \<leftarrow> Array.nth a j;
     Array.upd i y a;
     Array.upd j x a;
     return ()
   }"

  fun rev :: "'a\<Colon>heap array \<Rightarrow> nat \<Rightarrow> nat \<Rightarrow> unit Heap" where
    "rev a i j = (if (i < j) then do {
       swap a i j;
       rev a (i + 1) (j - 1)
     }
     else return ())"

  declare swap.simps [simp del] rev.simps [simp del]

  term sublist'

  value "sublist' 1 2 [0,1,2,3,4]"

  lemma "\<lbrakk>i<j; j<length l\<rbrakk> \<Longrightarrow> sublist' i j l = l!i # sublist' (i+1) (j - 1) l @ [l!j]"
    


  lemma "\<lbrakk>i<length l; j<length l; i \<le> Suc j\<rbrakk> \<Longrightarrow> 
    < p \<mapsto>\<^sub>a l > 
    rev p i j 
    <\<lambda>r. p \<mapsto>\<^sub>a (take i l @ List.rev (sublist' i j l) @ drop j l)>"
  proof (induction arbitrary: l rule: rev.induct)
    case (1 a i j l)
    from "1.prems" show ?case
      apply (subst rev.simps)
      unfolding swap.simps
      apply sep_auto
      apply (rule cons_post_rule)
      apply (rule "1.IH"[simplified])
      apply simp_all

      apply (simp_all add: take_update_last)

      apply sep_auto


    apply (rule frame_rule)




end
