{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module Ta where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Array;

newtype Nat = Nat Integer deriving (Read, Show);

data Num = One | Bit0 Num | Bit1 Num deriving (Read, Show);

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

class (Ord a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

data Color = R | B deriving (Read, Show);

data Rbta a b = Empty | Branch Color (Rbta a b) a b (Rbta a b)
  deriving (Read, Show);

newtype Rbt a b = Rbt (Rbta a b) deriving (Read, Show);

data Ta_rule a b = Rule a b [a] deriving (Read, Show);

lhs :: forall a b. Ta_rule a b -> a;
lhs (Rule q l qs) = q;

hd :: forall a. [a] -> a;
hd (x : xs) = x;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x : xs) = xs;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

one_nat :: Nat;
one_nat = Nat 1;

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

rhsl :: forall a b. Ta_rule a b -> b;
rhsl (Rule q l qs) = l;

rhsq :: forall a b. Ta_rule a b -> [a];
rhsq (Rule q l qs) = qs;

data Ustate_wrapper a b = USW1 a | USW2 b deriving (Read, Show);

data Tree a = Node a [Tree a] deriving (Read, Show);

data Itself a = Type deriving (Read, Show);

empty :: forall a b. (Linorder a) => Rbt a b;
empty = Rbt Empty;

r_prod :: forall a b c d. Ta_rule a b -> Ta_rule c d -> Ta_rule (a, c) b;
r_prod (Rule q1 l1 qs1) (Rule q2 l2 qs2) = Rule (q1, q2) l1 (zip qs1 qs2);

newtype Dlist a = Dlist [a] deriving (Read, Show);

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

the :: forall a. Maybe a -> a;
the (Just x) = x;

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_ins ::
  forall a b. (Ord a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins f k v Empty = Branch R Empty k v Empty;
rbt_ins f k v (Branch B l x y r) =
  (if less k x then balance (rbt_ins f k v l) x y r
    else (if less x k then balance l x y (rbt_ins f k v r)
           else Branch B l x (f k y v) r));
rbt_ins f k v (Branch R l x y r) =
  (if less k x then Branch R (rbt_ins f k v l) x y r
    else (if less x k then Branch R l x y (rbt_ins f k v r)
           else Branch R l x (f k y v) r));

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_insert_with_key ::
  forall a b. (Ord a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key f k v t = paint B (rbt_ins f k v t);

rbt_insert :: forall a b. (Ord a) => a -> b -> Rbta a b -> Rbta a b;
rbt_insert = rbt_insert_with_key (\ _ _ nv -> nv);

impl_of :: forall a b. (Linorder a) => Rbt a b -> Rbta a b;
impl_of (Rbt x) = x;

insert :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
insert x xa xb = Rbt (rbt_insert x xa (impl_of xb));

rbt_lookup :: forall a b. (Ord a) => Rbta a b -> a -> Maybe b;
rbt_lookup Empty k = Nothing;
rbt_lookup (Branch uu l x y r) k =
  (if less k x then rbt_lookup l k
    else (if less x k then rbt_lookup r k else Just y));

lookup :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
lookup x = rbt_lookup (impl_of x);

emptya :: forall a. Dlist a;
emptya = Dlist [];

member :: forall a. (Eq a) => [a] -> a -> Bool;
member [] y = False;
member (x : xs) y = x == y || member xs y;

inserta :: forall a. (Eq a) => a -> [a] -> [a];
inserta x xs = (if member xs x then xs else x : xs);

list_of_dlist :: forall a. Dlist a -> [a];
list_of_dlist (Dlist x) = x;

insertb :: forall a. (Eq a) => a -> Dlist a -> Dlist a;
insertb x dxs = Dlist (inserta x (list_of_dlist dxs));

membera :: forall a. (Eq a) => Dlist a -> a -> Bool;
membera dxs = member (list_of_dlist dxs);

foldli :: forall a b. [a] -> (b -> Bool) -> (a -> b -> b) -> b -> b;
foldli [] c f sigma = sigma;
foldli (x : xs) c f sigma =
  (if c sigma then foldli xs c f (f x sigma) else sigma);

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if member xs x then remdups xs else x : remdups xs);

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

instance Preorder Nat where {
};

instance Order Nat where {
};

zero_nat :: Nat;
zero_nat = Nat 0;

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max 0 (integer_of_nat m - integer_of_nat n));

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

remap_rule :: forall a b c. (a -> b) -> Ta_rule a c -> Ta_rule b c;
remap_rule f (Rule q l qs) = Rule (f q) l (map f qs);

dlist_iteratei :: forall a b. Dlist a -> (b -> Bool) -> (a -> b -> b) -> b -> b;
dlist_iteratei xs = foldli (list_of_dlist xs);

iteratei_set_op_list_it_ls_ops ::
  forall a b. Dlist a -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_set_op_list_it_ls_ops s = dlist_iteratei s;

g_image_filter_ls_ops_ls_ops ::
  forall a b. (Eq b) => (a -> Maybe b) -> Dlist a -> Dlist b;
g_image_filter_ls_ops_ls_ops f s =
  iteratei_set_op_list_it_ls_ops s (\ _ -> True)
    (\ x res -> (case f x of {
                  Nothing -> res;
                  Just v -> insertb v res;
                }))
    emptya;

newtype Assoc_list a b = Assoc_List [(a, b)] deriving (Read, Show);

class Hashable a where {
  hashcode :: a -> Nat;
  bounded_hashcode :: Nat -> a -> Nat;
  def_hashmap_size :: Itself a -> Nat;
};

newtype Hashmap a b = RBT_HM (Rbt Nat (Assoc_list a b)) deriving (Read, Show);

impl_of_RBT_HM ::
  forall a b. (Hashable a) => Hashmap a b -> Rbt Nat (Assoc_list a b);
impl_of_RBT_HM (RBT_HM x) = x;

impl_ofa :: forall a b. Assoc_list a b -> [(a, b)];
impl_ofa (Assoc_List x) = x;

lookupa :: forall a b. (Eq a) => Assoc_list a b -> a -> Maybe b;
lookupa al = map_of (impl_ofa al);

instance Linorder Nat where {
};

lookupb ::
  forall a b. (Eq a, Hashable a) => a -> Rbt Nat (Assoc_list a b) -> Maybe b;
lookupb k m =
  (case lookup m (hashcode k) of {
    Nothing -> Nothing;
    Just lm -> lookupa lm k;
  });

hm_lookup :: forall a b. (Eq a, Hashable a) => a -> Hashmap a b -> Maybe b;
hm_lookup k hm = lookupb k (impl_of_RBT_HM hm);

lookup_hm_ops_ls_ops ::
  forall a b. (Eq a, Hashable a) => a -> Hashmap a (Dlist b) -> Dlist b;
lookup_hm_ops_ls_ops i m =
  (case hm_lookup i m of {
    Nothing -> emptya;
    Just s -> s;
  });

data HashedTa_ext a b c =
  HashedTa_ext (Hashmap a ()) (Dlist (Ta_rule a b))
    (Maybe (Hashmap b (Dlist (Ta_rule a b))))
    (Maybe (Hashmap a (Dlist (Ta_rule a b))))
    (Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)))) c
  deriving (Read, Show);

hta_idx_f ::
  forall a b c. HashedTa_ext a b c -> Maybe (Hashmap b (Dlist (Ta_rule a b)));
hta_idx_f (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_f;

hta_lookup_f ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext b a c -> Dlist (Ta_rule b a);
hta_lookup_f f h = lookup_hm_ops_ls_ops f (the (hta_idx_f h));

list_all_zip :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all_zip p [] [] = True;
list_all_zip p (a : asa) (b : bs) = p a b && list_all_zip p asa bs;
list_all_zip p (v : va) [] = False;
list_all_zip p [] (v : va) = False;

faccs ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext a b c -> Tree b -> Dlist a;
faccs h (Node f ts) =
  let {
    qs = map (faccs h) ts;
  } in g_image_filter_ls_ops_ls_ops
         (\ r ->
           let {
             (Rule _ _ qsa) = r;
           } in (if list_all_zip membera qs qsa then Just (lhs r) else Nothing))
         (hta_lookup_f f h);

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

emptyc :: forall a b. (Hashable a) => () -> Rbt Nat (Assoc_list a b);
emptyc = (\ _ -> empty);

hm_empty_const :: forall a b. (Hashable a) => Hashmap a b;
hm_empty_const = RBT_HM (emptyc ());

hm_empty :: forall a b. (Hashable a) => () -> Hashmap a b;
hm_empty = (\ _ -> hm_empty_const);

empty_hm_basic_ops :: forall a. (Hashable a) => () -> Hashmap a ();
empty_hm_basic_ops = hm_empty;

update_with_aux ::
  forall a b. (Eq b) => a -> b -> (a -> a) -> [(b, a)] -> [(b, a)];
update_with_aux v k f [] = [(k, f v)];
update_with_aux v k f (p : ps) =
  (if fst p == k then (k, f (snd p)) : ps else p : update_with_aux v k f ps);

update_with ::
  forall b a. (Eq a) => b -> a -> (b -> b) -> Assoc_list a b -> Assoc_list a b;
update_with v k f al = Assoc_List (update_with_aux v k f (impl_ofa al));

update :: forall a b. (Eq a) => a -> b -> Assoc_list a b -> Assoc_list a b;
update k v = update_with v k (\ _ -> v);

emptyb :: forall a b. Assoc_list a b;
emptyb = Assoc_List [];

updatea ::
  forall a b.
    (Eq a,
      Hashable a) => a -> b -> Rbt Nat (Assoc_list a b) ->
                                 Rbt Nat (Assoc_list a b);
updatea k v m =
  let {
    hc = hashcode k;
  } in (case lookup m hc of {
         Nothing -> insert hc (update k v emptyb) m;
         Just bm -> insert hc (update k v bm) m;
       });

hm_update ::
  forall a b. (Eq a, Hashable a) => a -> b -> Hashmap a b -> Hashmap a b;
hm_update k v hm = RBT_HM (updatea k v (impl_of_RBT_HM hm));

ins_hm_basic_ops ::
  forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Hashmap a ();
ins_hm_basic_ops x s = hm_update x () s;

g_image_filter_ls_ops_hs_ops ::
  forall a b. (Eq b, Hashable b) => (a -> Maybe b) -> Dlist a -> Hashmap b ();
g_image_filter_ls_ops_hs_ops f s =
  iteratei_set_op_list_it_ls_ops s (\ _ -> True)
    (\ x res ->
      (case f x of {
        Nothing -> res;
        Just v -> ins_hm_basic_ops v res;
      }))
    (empty_hm_basic_ops ());

brc_iq :: forall a b. (Eq a, Hashable a) => Dlist (Ta_rule a b) -> Hashmap a ();
brc_iq delta =
  g_image_filter_ls_ops_hs_ops
    (\ r -> (if null (rhsq r) then Just (lhs r) else Nothing)) delta;

hta_Qi :: forall a b c. HashedTa_ext a b c -> Hashmap a ();
hta_Qi (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_Qi;

sgn_integer :: Integer -> Integer;
sgn_integer k = (if k == 0 then 0 else (if k < 0 then negate 1 else 1));

abs_integer :: Integer -> Integer;
abs_integer k = (if k < 0 then negate k else k);

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == 0 then (0, 0)
    else (if l == 0 then (0, k)
           else ((apsnd . (\ a b -> a * b)) . sgn_integer) l
                  (if sgn_integer k == sgn_integer l then divMod (abs k) (abs l)
                    else let {
                           (r, s) = divMod (abs k) (abs l);
                         } in (if s == 0 then (negate r, 0)
                                else (negate r - 1, abs_integer l - s)))));

mod_integer :: Integer -> Integer -> Integer;
mod_integer k l = snd (divmod_integer k l);

mod_nat :: Nat -> Nat -> Nat;
mod_nat m n = Nat (mod_integer (integer_of_nat m) (integer_of_nat n));

fifo_empty :: forall a. () -> ([a], [a]);
fifo_empty = (\ _ -> ([], []));

equal_ta_rule :: forall a b. (Eq a, Eq b) => Ta_rule a b -> Ta_rule a b -> Bool;
equal_ta_rule (Rule qa la lista) (Rule q l list) =
  qa == q && la == l && lista == list;

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = equal_ta_rule a b;
};

idx_build_stepfun_hm_ops_ls_ops ::
  forall a b.
    (Eq a, Eq b,
      Hashable b) => (a -> b) ->
                       a -> Hashmap b (Dlist a) -> Hashmap b (Dlist a);
idx_build_stepfun_hm_ops_ls_ops f x m =
  let {
    i = f x;
  } in (case hm_lookup i m of {
         Nothing -> hm_update i (insertb x emptya) m;
         Just s -> hm_update i (insertb x s) m;
       });

idx_build_hm_ops_ls_ops_ls_ops ::
  forall a b.
    (Eq a, Eq b, Hashable b) => (a -> b) -> Dlist a -> Hashmap b (Dlist a);
idx_build_hm_ops_ls_ops_ls_ops f t =
  iteratei_set_op_list_it_ls_ops t (\ _ -> True)
    (idx_build_stepfun_hm_ops_ls_ops f) (hm_empty ());

build_rule_index ::
  forall a b c.
    (Eq a, Eq b, Eq c,
      Hashable c) => (Ta_rule a b -> c) ->
                       Dlist (Ta_rule a b) -> Hashmap c (Dlist (Ta_rule a b));
build_rule_index = idx_build_hm_ops_ls_ops_ls_ops;

build_rule_index_f ::
  forall a b.
    (Eq a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap b (Dlist (Ta_rule a b));
build_rule_index_f delta = build_rule_index rhsl delta;

hta_idx_f_update ::
  forall a b c.
    (Maybe (Hashmap a (Dlist (Ta_rule b a))) ->
      Maybe (Hashmap a (Dlist (Ta_rule b a)))) ->
      HashedTa_ext b a c -> HashedTa_ext b a c;
hta_idx_f_update hta_idx_fa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta (hta_idx_fa hta_idx_f) hta_idx_s hta_idx_sf
    more;

hta_delta :: forall a b c. HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_delta (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_delta;

hta_ensure_idx_f ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_f h =
  (case hta_idx_f h of {
    Nothing ->
      hta_idx_f_update (\ _ -> Just (build_rule_index_f (hta_delta h))) h;
    Just _ -> h;
  });

iteratei_bset_op_list_it_ls_basic_ops ::
  forall a b. Dlist a -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_bset_op_list_it_ls_basic_ops s = dlist_iteratei s;

g_ball_ls_basic_ops :: forall a. Dlist a -> (a -> Bool) -> Bool;
g_ball_ls_basic_ops s p =
  iteratei_bset_op_list_it_ls_basic_ops s (\ c -> c) (\ x _ -> p x) True;

memb_hm_basic_ops :: forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Bool;
memb_hm_basic_ops x s = not (is_none (hm_lookup x s));

g_disjoint_ls_ops_hs_ops ::
  forall a. (Eq a, Hashable a) => Dlist a -> Hashmap a () -> Bool;
g_disjoint_ls_ops_hs_ops s1 s2 =
  g_ball_ls_basic_ops s1 (\ x -> not (memb_hm_basic_ops x s2));

hta_mema ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext b a c -> Bool;
hta_mema t h = not (g_disjoint_ls_ops_hs_ops (faccs h t) (hta_Qi h));

hta_mem ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext b a c -> Bool;
hta_mem t h = hta_mema t (hta_ensure_idx_f h);

pa_cond ::
  forall a b c.
    (Hashable a, Hashable b,
      Hashable c) => (Hashmap (a, b) (),
                       ([(a, b)], Dlist (Ta_rule (a, b) c))) ->
                       Bool;
pa_cond s = let {
              (_, (w, _)) = s;
            } in not (null w);

def_hashmap_size_prod ::
  forall a b. (Hashable a, Hashable b) => Itself (a, b) -> Nat;
def_hashmap_size_prod =
  (\ _ ->
    plus_nat ((def_hashmap_size :: Itself a -> Nat) Type)
      ((def_hashmap_size :: Itself b -> Nat) Type));

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max 0 k);

bounded_hashcode_prod ::
  forall a b. (Hashable a, Hashable b) => Nat -> (a, b) -> Nat;
bounded_hashcode_prod n x =
  mod_nat
    (plus_nat (times_nat (bounded_hashcode n (fst x)) (nat_of_integer 33))
      (bounded_hashcode n (snd x)))
    n;

hashcode_prod :: forall a b. (Hashable a, Hashable b) => (a, b) -> Nat;
hashcode_prod x =
  plus_nat (times_nat (hashcode (fst x)) (nat_of_integer 33))
    (hashcode (snd x));

instance (Hashable a, Hashable b) => Hashable (a, b) where {
  hashcode = hashcode_prod;
  bounded_hashcode = bounded_hashcode_prod;
  def_hashmap_size = def_hashmap_size_prod;
};

hta_idx_sf ::
  forall a b c.
    HashedTa_ext a b c -> Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)));
hta_idx_sf (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_sf;

hta_lookup_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => a -> b -> HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_lookup_sf q f h = lookup_hm_ops_ls_ops (q, f) (the (hta_idx_sf h));

hta_idx_s ::
  forall a b c. HashedTa_ext a b c -> Maybe (Hashmap a (Dlist (Ta_rule a b)));
hta_idx_s (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_s;

hta_lookup_s ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_lookup_s q h = lookup_hm_ops_ls_ops q (the (hta_idx_s h));

pa_upd_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap (a, b) () ->
                       [(a, b)] -> [(a, b)] -> (Hashmap (a, b) (), [(a, b)]);
pa_upd_rule q w [] = (q, w);
pa_upd_rule q w (qp : qs) =
  (if not (memb_hm_basic_ops qp q)
    then pa_upd_rule (ins_hm_basic_ops qp q) (qp : w) qs
    else pa_upd_rule q w qs);

pa_step ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         (Hashmap (a, c) (),
                           ([(a, c)], Dlist (Ta_rule (a, c) b))) ->
                           (Hashmap (a, c) (),
                             ([(a, c)], Dlist (Ta_rule (a, c) b)));
pa_step h1 h2 s =
  let {
    (q, (w, delta_d)) = s;
    (q1, q2) = hd w;
  } in iteratei_set_op_list_it_ls_ops (hta_lookup_s q1 h1) (\ _ -> True)
         (\ r1 ->
           iteratei_set_op_list_it_ls_ops (hta_lookup_sf q2 (rhsl r1) h2)
             (\ _ -> True)
             (\ r2 res ->
               (if equal_nat (size_list (rhsq r1)) (size_list (rhsq r2))
                 then let {
                        rp = r_prod r1 r2;
                        (qa, (wa, delta_da)) = res;
                        (qb, wb) = pa_upd_rule qa wa (rhsq rp);
                      } in (qb, (wb, insertb rp delta_da))
                 else res)))
         (q, (tl w, delta_d));

equal_dlist :: forall a. (Eq a) => Dlist a -> Dlist a -> Bool;
equal_dlist dxs dys = list_of_dlist dxs == list_of_dlist dys;

instance (Eq a) => Eq (Dlist a) where {
  a == b = equal_dlist a b;
};

brc_cond ::
  forall a b.
    (Hashable a,
      Hashable b) => (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat)) -> Bool;
brc_cond = (\ (_, (w, _)) -> not (null w));

def_hashmap_size_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Itself (Ta_rule a b) -> Nat;
def_hashmap_size_ta_rule = (\ _ -> nat_of_integer 32);

hashcode_list :: forall a. (Hashable a) => [a] -> Nat;
hashcode_list =
  foldl (\ h x -> plus_nat (times_nat h (nat_of_integer 33)) (hashcode x))
    (nat_of_integer 5381);

hashcode_of_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Nat;
hashcode_of_ta_rule (Rule q f qs) =
  plus_nat (plus_nat (hashcode q) (hashcode f)) (hashcode_list qs);

bounded_hashcode_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Nat -> Ta_rule a b -> Nat;
bounded_hashcode_ta_rule n r = mod_nat (hashcode_of_ta_rule r) n;

hashcode_ta_rule :: forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Nat;
hashcode_ta_rule = hashcode_of_ta_rule;

instance (Hashable a, Hashable b) => Hashable (Ta_rule a b) where {
  hashcode = hashcode_ta_rule;
  bounded_hashcode = bounded_hashcode_ta_rule;
  def_hashmap_size = def_hashmap_size_ta_rule;
};

brc_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat)) ->
                         (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat));
brc_inner_step r =
  (\ (q, (w, rcm)) ->
    let {
      c = the (hm_lookup r rcm);
      rcma = hm_update r (minus_nat c one_nat) rcm;
      qa = (if less_eq_nat c one_nat then ins_hm_basic_ops (lhs r) q else q);
      wa = (if less_eq_nat c one_nat && not (memb_hm_basic_ops (lhs r) q)
             then lhs r : w else w);
    } in (qa, (wa, rcma)));

rqrm_lookup ::
  forall a b. (Eq a, Hashable a) => Hashmap a (Dlist b) -> a -> Dlist b;
rqrm_lookup rqrm q =
  (case hm_lookup q rqrm of {
    Nothing -> emptya;
    Just s -> s;
  });

brc_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a (Dlist (Ta_rule a b)) ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat)) ->
                         (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat));
brc_step rqrm =
  (\ (q, (w, rcm)) ->
    iteratei_set_op_list_it_ls_ops (rqrm_lookup rqrm (hd w)) (\ _ -> True)
      brc_inner_step (q, (tl w, rcm)));

brec_iqm ::
  forall a b.
    (Eq a, Hashable a, Hashable b) => Dlist (Ta_rule a b) -> Hashmap a (Tree b);
brec_iqm delta =
  iteratei_set_op_list_it_ls_ops delta (\ _ -> True)
    (\ r m ->
      (if null (rhsq r) then hm_update (lhs r) (Node (rhsl r) []) m else m))
    (hm_empty ());

build_rule_index_sf ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) ->
                       Hashmap (a, b) (Dlist (Ta_rule a b));
build_rule_index_sf delta = build_rule_index (\ r -> (lhs r, rhsl r)) delta;

hta_idx_sf_update ::
  forall a b c.
    (Maybe (Hashmap (a, b) (Dlist (Ta_rule a b))) ->
      Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)))) ->
      HashedTa_ext a b c -> HashedTa_ext a b c;
hta_idx_sf_update hta_idx_sfa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s (hta_idx_sfa hta_idx_sf)
    more;

hta_ensure_idx_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_sf h =
  (case hta_idx_sf h of {
    Nothing ->
      hta_idx_sf_update (\ _ -> Just (build_rule_index_sf (hta_delta h))) h;
    Just _ -> h;
  });

build_rule_index_s ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => Dlist (Ta_rule a b) -> Hashmap a (Dlist (Ta_rule a b));
build_rule_index_s delta = build_rule_index lhs delta;

hta_idx_s_update ::
  forall a b c.
    (Maybe (Hashmap a (Dlist (Ta_rule a b))) ->
      Maybe (Hashmap a (Dlist (Ta_rule a b)))) ->
      HashedTa_ext a b c -> HashedTa_ext a b c;
hta_idx_s_update hta_idx_sa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta hta_idx_f (hta_idx_sa hta_idx_s) hta_idx_sf
    more;

hta_ensure_idx_s ::
  forall a b c.
    (Eq a, Hashable a, Eq b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_s h =
  (case hta_idx_s h of {
    Nothing ->
      hta_idx_s_update (\ _ -> Just (build_rule_index_s (hta_delta h))) h;
    Just _ -> h;
  });

iteratei ::
  forall a b c. Assoc_list a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
iteratei al c f = foldli (impl_ofa al) c f;

iteratei_map_op_list_it_lm_ops ::
  forall a b c. Assoc_list a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
iteratei_map_op_list_it_lm_ops s = iteratei s;

rm_iterateoi ::
  forall a b c. Rbta a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoi Empty c f sigma = sigma;
rm_iterateoi (Branch col l k v r) c f sigma =
  (if c sigma
    then let {
           sigmaa = rm_iterateoi l c f sigma;
         } in (if c sigmaa then rm_iterateoi r c f (f (k, v) sigmaa)
                else sigmaa)
    else sigma);

iteratei_map_op_list_it_rm_ops ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
iteratei_map_op_list_it_rm_ops s = rm_iterateoi (impl_of s);

iterateia ::
  forall a b c d.
    (Linorder a) => Rbt a (Assoc_list b c) ->
                      (d -> Bool) -> ((b, c) -> d -> d) -> d -> d;
iterateia m c f sigma_0 =
  iteratei_map_op_list_it_rm_ops m c
    (\ (_, lm) -> iteratei_map_op_list_it_lm_ops lm c f) sigma_0;

hm_iteratei ::
  forall a b c.
    (Hashable a) => Hashmap a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
hm_iteratei hm = iterateia (impl_of_RBT_HM hm);

iteratei_set_op_list_it_hs_ops ::
  forall a b.
    (Hashable a) => Hashmap a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_set_op_list_it_hs_ops s = (\ c f -> hm_iteratei s c (f . fst));

ins_dj_hm_basic_ops ::
  forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Hashmap a ();
ins_dj_hm_basic_ops x s = hm_update x () s;

cart_hs_ops_hs_ops_hs_ops ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () -> Hashmap b () -> Hashmap (a, b) ();
cart_hs_ops_hs_ops_hs_ops s1 s2 =
  iteratei_set_op_list_it_hs_ops s1 (\ _ -> True)
    (\ x ->
      iteratei_set_op_list_it_hs_ops s2 (\ _ -> True)
        (\ y -> ins_dj_hm_basic_ops (x, y)))
    (empty_hm_basic_ops ());

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = (if b s then while b c (c s) else s);

iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops ::
  forall a b.
    (Hashable a) => Hashmap a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s =
  (\ c f -> hm_iteratei s c (f . fst));

g_to_list_dflt_basic_ops_hm_basic_ops ::
  forall a. (Hashable a) => Hashmap a () -> [a];
g_to_list_dflt_basic_ops_hm_basic_ops s =
  iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s (\ _ -> True)
    (\ a b -> a : b) [];

pa_initial ::
  forall a b c.
    (Eq a, Hashable a, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         (Hashmap (a, c) (),
                           ([(a, c)], Dlist (Ta_rule (a, c) b)));
pa_initial h1 h2 =
  let {
    qip = cart_hs_ops_hs_ops_hs_ops (hta_Qi h1) (hta_Qi h2);
  } in (qip, (g_to_list_dflt_basic_ops_hm_basic_ops qip, emptya));

init_hta ::
  forall a b. Hashmap a () -> Dlist (Ta_rule a b) -> HashedTa_ext a b ();
init_hta qi delta = HashedTa_ext qi delta Nothing Nothing Nothing ();

hta_proda ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () -> HashedTa_ext (a, c) b ();
hta_proda h1 h2 =
  let {
    (_, (_, a)) = while pa_cond (pa_step h1 h2) (pa_initial h1 h2);
  } in init_hta (cart_hs_ops_hs_ops_hs_ops (hta_Qi h1) (hta_Qi h2)) a;

hta_prod ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () -> HashedTa_ext (a, c) b ();
hta_prod h1 h2 = hta_proda (hta_ensure_idx_s h1) (hta_ensure_idx_sf h2);

def_hashmap_size_nat :: Itself Nat -> Nat;
def_hashmap_size_nat = (\ _ -> nat_of_integer 16);

bounded_hashcode_nat :: Nat -> Nat -> Nat;
bounded_hashcode_nat na n = mod_nat n na;

hashcode_nat :: Nat -> Nat;
hashcode_nat n = n;

instance Hashable Nat where {
  hashcode = hashcode_nat;
  bounded_hashcode = bounded_hashcode_nat;
  def_hashmap_size = def_hashmap_size_nat;
};

htai_mem :: Tree Nat -> HashedTa_ext Nat Nat () -> Bool;
htai_mem = hta_mem;

rqrm_add ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => a -> b -> Hashmap a (Dlist b) -> Hashmap a (Dlist b);
rqrm_add q r res =
  (case hm_lookup q res of {
    Nothing -> hm_update q (insertb r emptya) res;
    Just s -> hm_update q (insertb r s) res;
  });

fifo_appendr :: forall a. a -> ([a], [a]) -> ([a], [a]);
fifo_appendr a f = (a : fst f, snd f);

fifo_isEmpty :: forall a. (Eq a) => ([a], [a]) -> Bool;
fifo_isEmpty f = f == ([], []);

fifo_removel :: forall a. ([a], [a]) -> (a, ([a], [a]));
fifo_removel f =
  (case snd f of {
    [] -> let {
            rp = reverse (fst f);
          } in (hd rp, ([], tl rp));
    a : l -> (a, (fst f, l));
  });

brec_cond ::
  forall a b.
    (Eq a) => (Hashmap a (Tree b),
                (([a], [a]), (Hashmap (Ta_rule a b) Nat, Maybe a))) ->
                Bool;
brec_cond = (\ (_, (w, (_, qwit))) -> not (fifo_isEmpty w) && is_none qwit);

brec_construct_witness ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => Hashmap a (Tree b) -> Ta_rule a b -> Tree b;
brec_construct_witness qm r =
  Node (rhsl r) (map (\ q -> the (hm_lookup q qm)) (rhsq r));

brec_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () ->
                       Ta_rule a b ->
                         (Hashmap a (Tree b),
                           (([a], [a]),
                             (Hashmap (Ta_rule a b) Nat, Maybe a))) ->
                           (Hashmap a (Tree b),
                             (([a], [a]),
                               (Hashmap (Ta_rule a b) Nat, Maybe a)));
brec_inner_step qi r =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      c = the (hm_lookup r rcm);
      cond = less_eq_nat c one_nat && is_none (hm_lookup (lhs r) q);
      rcma = hm_update r (minus_nat c one_nat) rcm;
      qa = (if cond then hm_update (lhs r) (brec_construct_witness q r) q
             else q);
      wa = (if cond then fifo_appendr (lhs r) w else w);
      qwita =
        (if less_eq_nat c one_nat && memb_hm_basic_ops (lhs r) qi
          then Just (lhs r) else qwit);
    } in (qa, (wa, (rcma, qwita))));

brec_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a (Dlist (Ta_rule a b)) ->
                       Hashmap a () ->
                         (Hashmap a (Tree b),
                           (([a], [a]),
                             (Hashmap (Ta_rule a b) Nat, Maybe a))) ->
                           (Hashmap a (Tree b),
                             (([a], [a]),
                               (Hashmap (Ta_rule a b) Nat, Maybe a)));
brec_step rqrm qi =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      (qa, wa) = fifo_removel w;
    } in iteratei_set_op_list_it_ls_ops (rqrm_lookup rqrm qa) (\ _ -> True)
           (brec_inner_step qi) (q, (wa, (rcm, qwit))));

hta_empty :: forall a b. (Hashable a, Hashable b) => () -> HashedTa_ext a b ();
hta_empty u = init_hta (empty_hm_basic_ops ()) emptya;

g_image_ls_ops_ls_ops :: forall a b. (Eq b) => (a -> b) -> Dlist a -> Dlist b;
g_image_ls_ops_ls_ops f s =
  iteratei_set_op_list_it_ls_ops s (\ _ -> True) (\ x -> insertb (f x)) emptya;

g_image_hs_ops_hs_ops ::
  forall a b.
    (Hashable a, Eq b, Hashable b) => (a -> b) -> Hashmap a () -> Hashmap b ();
g_image_hs_ops_hs_ops f s =
  iteratei_set_op_list_it_hs_ops s (\ _ -> True) (\ x -> ins_hm_basic_ops (f x))
    (empty_hm_basic_ops ());

hta_remap ::
  forall a b c.
    (Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => (a -> b) -> HashedTa_ext a c () -> HashedTa_ext b c ();
hta_remap f h =
  init_hta (g_image_hs_ops_hs_ops f (hta_Qi h))
    (g_image_ls_ops_ls_ops (remap_rule f) (hta_delta h));

g_union_dflt_basic_ops_hm_basic_ops ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Hashmap a ();
g_union_dflt_basic_ops_hm_basic_ops s1 s2 =
  iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s1 (\ _ -> True)
    ins_hm_basic_ops s2;

g_union_dj_ls_basic_ops :: forall a. (Eq a) => Dlist a -> Dlist a -> Dlist a;
g_union_dj_ls_basic_ops s1 s2 =
  iteratei_bset_op_list_it_ls_basic_ops s1 (\ _ -> True) insertb s2;

def_hashmap_size_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Itself (Ustate_wrapper a b) -> Nat;
def_hashmap_size_ustate_wrapper =
  (\ _ ->
    plus_nat ((def_hashmap_size :: Itself a -> Nat) Type)
      ((def_hashmap_size :: Itself b -> Nat) Type));

bounded_hashcode_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Nat -> Ustate_wrapper a b -> Nat;
bounded_hashcode_ustate_wrapper n x =
  (case x of {
    USW1 a -> bounded_hashcode n a;
    USW2 b -> minus_nat (minus_nat n one_nat) (bounded_hashcode n b);
  });

hashcode_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Ustate_wrapper a b -> Nat;
hashcode_ustate_wrapper x =
  (case x of {
    USW1 a -> times_nat (nat_of_integer 2) (hashcode a);
    USW2 b -> plus_nat (times_nat (nat_of_integer 2) (hashcode b)) one_nat;
  });

instance (Hashable a, Hashable b) => Hashable (Ustate_wrapper a b) where {
  hashcode = hashcode_ustate_wrapper;
  bounded_hashcode = bounded_hashcode_ustate_wrapper;
  def_hashmap_size = def_hashmap_size_ustate_wrapper;
};

equal_ustate_wrapper ::
  forall a b. (Eq a, Eq b) => Ustate_wrapper a b -> Ustate_wrapper a b -> Bool;
equal_ustate_wrapper (USW2 q2) (USW1 q1) = False;
equal_ustate_wrapper (USW1 q1) (USW2 q2) = False;
equal_ustate_wrapper (USW2 q2a) (USW2 q2) = q2a == q2;
equal_ustate_wrapper (USW1 q1a) (USW1 q1) = q1a == q1;

instance (Eq a, Eq b) => Eq (Ustate_wrapper a b) where {
  a == b = equal_ustate_wrapper a b;
};

hta_union ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         HashedTa_ext (Ustate_wrapper a c) b ();
hta_union h1 h2 =
  init_hta
    (g_union_dflt_basic_ops_hm_basic_ops
      (g_image_hs_ops_hs_ops USW1 (hta_Qi h1))
      (g_image_hs_ops_hs_ops USW2 (hta_Qi h2)))
    (g_union_dj_ls_basic_ops
      (g_image_ls_ops_ls_ops (remap_rule USW1) (hta_delta h1))
      (g_image_ls_ops_ls_ops (remap_rule USW2) (hta_delta h2)));

map_to_nat_hs_ops_hm_ops ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a Nat;
map_to_nat_hs_ops_hm_ops s =
  snd (iteratei_set_op_list_it_hs_ops s (\ _ -> True)
        (\ x (c, m) -> (plus_nat c one_nat, hm_update x c m))
        (zero_nat, hm_empty ()));

g_union_ls_ops_hs_ops ::
  forall a. (Eq a, Hashable a) => Dlist a -> Hashmap a () -> Hashmap a ();
g_union_ls_ops_hs_ops s1 s2 =
  iteratei_set_op_list_it_ls_ops s1 (\ _ -> True) ins_hm_basic_ops s2;

g_Union_image_ls_ops_ls_ops_hs_ops ::
  forall a b. (Eq b, Hashable b) => (a -> Dlist b) -> Dlist a -> Hashmap b ();
g_Union_image_ls_ops_ls_ops_hs_ops f s =
  iteratei_set_op_list_it_ls_ops s (\ _ -> True)
    (\ x -> g_union_ls_ops_hs_ops (f x)) (empty_hm_basic_ops ());

g_from_list_aux_ls_basic_ops :: forall a. (Eq a) => Dlist a -> [a] -> Dlist a;
g_from_list_aux_ls_basic_ops accs (x : l) =
  g_from_list_aux_ls_basic_ops (insertb x accs) l;
g_from_list_aux_ls_basic_ops y [] = y;

g_from_list_ls_basic_ops :: forall a. (Eq a) => [a] -> Dlist a;
g_from_list_ls_basic_ops l = g_from_list_aux_ls_basic_ops emptya l;

rule_states_l :: forall a b. (Eq a) => Ta_rule a b -> Dlist a;
rule_states_l (Rule q f qs) = insertb q (g_from_list_ls_basic_ops qs);

hta_delta_states ::
  forall a b c. (Eq a, Hashable a) => HashedTa_ext a b c -> Hashmap a ();
hta_delta_states h =
  g_Union_image_ls_ops_ls_ops_hs_ops id
    (g_image_filter_ls_ops_ls_ops (\ r -> Just (rule_states_l r))
      (hta_delta h));

hta_states ::
  forall a b c. (Eq a, Hashable a) => HashedTa_ext a b c -> Hashmap a ();
hta_states h =
  g_union_dflt_basic_ops_hm_basic_ops (hta_Qi h) (hta_delta_states h);

hta_reindex ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b () -> HashedTa_ext Nat b ();
hta_reindex h =
  let {
    mp = map_to_nat_hs_ops_hm_ops (hta_states h);
  } in hta_remap (\ q -> the (hm_lookup q mp)) h;

htai_prod ::
  HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_prod h1 h2 = hta_reindex (hta_prod h1 h2);

build_rqrm ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap a (Dlist (Ta_rule a b));
build_rqrm delta =
  iteratei_set_op_list_it_ls_ops delta (\ _ -> True)
    (\ r res -> foldl (\ resa q -> rqrm_add q r resa) res (rhsq r))
    (hm_empty ());

hta_add_qi ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => a -> HashedTa_ext a b () -> HashedTa_ext a b ();
hta_add_qi qi h = init_hta (ins_hm_basic_ops qi (hta_Qi h)) (hta_delta h);

inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops ::
  forall a b c. (Eq c) => ((a, b) -> Maybe c) -> Dlist a -> Dlist b -> Dlist c;
inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops f s1 s2 =
  iteratei_set_op_list_it_ls_ops s1 (\ _ -> True)
    (\ x ->
      iteratei_set_op_list_it_ls_ops s2 (\ _ -> True)
        (\ y res ->
          (case f (x, y) of {
            Nothing -> res;
            Just z -> insertb z res;
          })))
    emptya;

inj_image_filter_cp_ls_ops_ls_ops_ls_ops ::
  forall a b c.
    (Eq c) => ((a, b) -> c) ->
                ((a, b) -> Bool) -> Dlist a -> Dlist b -> Dlist c;
inj_image_filter_cp_ls_ops_ls_ops_ls_ops f p s1 s2 =
  inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops
    (\ xy -> (if p xy then Just (f xy) else Nothing)) s1 s2;

delta_prod_h ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => Dlist (Ta_rule a b) ->
                       Dlist (Ta_rule c b) -> Dlist (Ta_rule (a, c) b);
delta_prod_h delta_1 delta_2 =
  inj_image_filter_cp_ls_ops_ls_ops_ls_ops (\ (a, b) -> r_prod a b)
    (\ (r1, r2) ->
      rhsl r1 == rhsl r2 &&
        equal_nat (size_list (rhsq r1)) (size_list (rhsq r2)))
    delta_1 delta_2;

hta_prodWR ::
  forall a b c d e.
    (Eq a, Hashable a, Eq b, Hashable b, Eq d,
      Hashable d) => HashedTa_ext a b c ->
                       HashedTa_ext d b e -> HashedTa_ext (a, d) b ();
hta_prodWR h1 h2 =
  init_hta (cart_hs_ops_hs_ops_hs_ops (hta_Qi h1) (hta_Qi h2))
    (delta_prod_h (hta_delta h1) (hta_delta h2));

g_inter_dflt_basic_ops_hm_basic_ops ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Hashmap a ();
g_inter_dflt_basic_ops_hm_basic_ops s1 s2 =
  iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s1 (\ _ -> True)
    (\ x s -> (if memb_hm_basic_ops x s2 then ins_dj_hm_basic_ops x s else s))
    (empty_hm_basic_ops ());

hta_reduce ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext a b c -> Hashmap a () -> HashedTa_ext a b ();
hta_reduce h q =
  init_hta (g_inter_dflt_basic_ops_hm_basic_ops q (hta_Qi h))
    (g_image_filter_ls_ops_ls_ops
      (\ r ->
        (if memb_hm_basic_ops (lhs r) q &&
              all (\ qa -> memb_hm_basic_ops qa q) (rhsq r)
          then Just r else Nothing))
      (hta_delta h));

htai_empty :: () -> HashedTa_ext Nat Nat ();
htai_empty = hta_empty;

htai_union ::
  HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_union h1 h2 = hta_reindex (hta_union h1 h2);

brc_rcm_init ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap (Ta_rule a b) Nat;
brc_rcm_init delta =
  iteratei_set_op_list_it_ls_ops delta (\ _ -> True)
    (\ r -> hm_update r (size_list (remdups (rhsq r)))) (hm_empty ());

brc_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat));
brc_initial delta =
  let {
    iq = brc_iq delta;
  } in (iq, (g_to_list_dflt_basic_ops_hm_basic_ops iq, brc_rcm_init delta));

htai_add_qi :: Nat -> HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_add_qi = hta_add_qi;

htai_prodWR ::
  HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_prodWR h1 h2 = hta_reindex (hta_prodWR h1 h2);

g_sel_dflt_basic_ops_hm_basic_ops ::
  forall a. (Hashable a) => Hashmap a () -> (a -> Bool) -> Maybe a;
g_sel_dflt_basic_ops_hm_basic_ops s p =
  iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s is_none
    (\ x _ -> (if p x then Just x else Nothing)) Nothing;

g_disjoint_witness_hs_ops_hs_ops ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Maybe a;
g_disjoint_witness_hs_ops_hs_ops s1 s2 =
  g_sel_dflt_basic_ops_hm_basic_ops s1 (\ x -> memb_hm_basic_ops x s2);

g_set_to_listr_hs_ops_fifo_ops ::
  forall a. (Hashable a) => Hashmap a () -> ([a], [a]);
g_set_to_listr_hs_ops_fifo_ops s =
  iteratei_set_op_list_it_hs_ops s (\ _ -> True) fifo_appendr (fifo_empty ());

brec_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () ->
                       Dlist (Ta_rule a b) ->
                         (Hashmap a (Tree b),
                           (([a], [a]), (Hashmap (Ta_rule a b) Nat, Maybe a)));
brec_initial qi delta =
  let {
    iq = brc_iq delta;
  } in (brec_iqm delta,
         (g_set_to_listr_hs_ops_fifo_ops iq,
           (brc_rcm_init delta, g_disjoint_witness_hs_ops_hs_ops iq qi)));

hta_add_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b -> HashedTa_ext a b () -> HashedTa_ext a b ();
hta_add_rule r h = init_hta (hta_Qi h) (insertb r (hta_delta h));

htai_add_rule ::
  Ta_rule Nat Nat -> HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_add_rule = hta_add_rule;

hta_bwd_reduce ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b ();
hta_bwd_reduce h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in hta_reduce h
         (fst (while brc_cond (brc_step rqrm) (brc_initial (hta_delta h))));

htai_bwd_reduce :: HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_bwd_reduce = hta_bwd_reduce;

g_size_dflt_basic_ops_hm_basic_ops ::
  forall a. (Hashable a) => Hashmap a () -> Nat;
g_size_dflt_basic_ops_hm_basic_ops s =
  iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops s (\ _ -> True)
    (\ _ -> suc) zero_nat;

hs_size :: forall a. (Hashable a) => Hashmap a () -> Nat;
hs_size = g_size_dflt_basic_ops_hm_basic_ops;

g_size_ls_basic_ops :: forall a. Dlist a -> Nat;
g_size_ls_basic_ops s =
  iteratei_bset_op_list_it_ls_basic_ops s (\ _ -> True) (\ _ -> suc) zero_nat;

ls_size :: forall a. Dlist a -> Nat;
ls_size = g_size_ls_basic_ops;

iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops ::
  forall a b.
    (Linorder a) => Rbt a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops s =
  (\ c f -> rm_iterateoi (impl_of s) c (f . fst));

g_size_dflt_basic_oops_rm_basic_ops ::
  forall a. (Linorder a) => Rbt a () -> Nat;
g_size_dflt_basic_oops_rm_basic_ops s =
  iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops s (\ _ -> True)
    (\ _ -> suc) zero_nat;

rs_size :: forall a. (Linorder a) => Rbt a () -> Nat;
rs_size = g_size_dflt_basic_oops_rm_basic_ops;

htai_ensure_idx_f :: HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_ensure_idx_f = hta_ensure_idx_f;

htai_ensure_idx_s :: HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_ensure_idx_s = hta_ensure_idx_s;

htai_ensure_idx_sf :: HashedTa_ext Nat Nat () -> HashedTa_ext Nat Nat ();
htai_ensure_idx_sf = hta_ensure_idx_sf;

hta_is_empty_witness ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> Maybe (Tree b);
hta_is_empty_witness h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in (case while brec_cond (brec_step rqrm (hta_Qi h))
               (brec_initial (hta_Qi h) (hta_delta h))
         of {
         (q, (_, (_, Nothing))) -> Nothing;
         (q, (_, (_, Just qa))) -> hm_lookup qa q;
       });

htai_is_empty_witness :: HashedTa_ext Nat Nat () -> Maybe (Tree Nat);
htai_is_empty_witness = hta_is_empty_witness;

}
