module Ta : sig
  val id : 'a -> 'a
  type 'a equal = {equal : 'a -> 'a -> bool}
  val equal : 'a equal -> 'a -> 'a -> bool
  val eq : 'a equal -> 'a -> 'a -> bool
  type nat = Nat of Big_int.big_int
  type num = One | Bit0 of num | Bit1 of num
  type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool}
  val less_eq : 'a ord -> 'a -> 'a -> bool
  val less : 'a ord -> 'a -> 'a -> bool
  type 'a preorder = {ord_preorder : 'a ord}
  type 'a order = {preorder_order : 'a preorder}
  type 'a linorder = {order_linorder : 'a order}
  type color = R | B
  type ('a, 'b) rbta = Empty |
    Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta
  type ('a, 'b) rbt = Rbt of ('a, 'b) rbta
  type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list
  val lhs : ('a, 'b) ta_rule -> 'a
  val hd : 'a list -> 'a
  val tl : 'a list -> 'a list
  val integer_of_nat : nat -> Big_int.big_int
  val plus_nat : nat -> nat -> nat
  val one_nat : nat
  val suc : nat -> nat
  val rhsl : ('a, 'b) ta_rule -> 'b
  val rhsq : ('a, 'b) ta_rule -> 'a list
  type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b
  val comp : ('a -> 'b) -> ('c -> 'a) -> 'c -> 'b
  val map : ('a -> 'b) -> 'a list -> 'b list
  val fold : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
  val rev : 'a list -> 'a list
  val zip : 'a list -> 'b list -> ('a * 'b) list
  type 'a tree = Node of 'a * 'a tree list
  val null : 'a list -> bool
  type 'a itself = Type
  val empty : 'a linorder -> ('a, 'b) rbt
  val r_prod : ('a, 'b) ta_rule -> ('c, 'd) ta_rule -> (('a * 'c), 'b) ta_rule
  type 'a dlist = Dlist of 'a list
  val foldl : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
  val map_of : 'a equal -> ('a * 'b) list -> 'a -> 'b option
  val less_eq_nat : nat -> nat -> bool
  val less_nat : nat -> nat -> bool
  val ord_nat : nat ord
  val the : 'a option -> 'a
  val balance : ('a, 'b) rbta -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val rbt_ins :
    'a ord ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val paint : color -> ('a, 'b) rbta -> ('a, 'b) rbta
  val rbt_insert_with_key :
    'a ord ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val rbt_insert : 'a ord -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val impl_of : 'a linorder -> ('a, 'b) rbt -> ('a, 'b) rbta
  val insert : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val rbt_lookup : 'a ord -> ('a, 'b) rbta -> 'a -> 'b option
  val lookup : 'a linorder -> ('a, 'b) rbt -> 'a -> 'b option
  val emptya : 'a dlist
  val member : 'a equal -> 'a list -> 'a -> bool
  val inserta : 'a equal -> 'a -> 'a list -> 'a list
  val list_of_dlist : 'a dlist -> 'a list
  val insertb : 'a equal -> 'a -> 'a dlist -> 'a dlist
  val membera : 'a equal -> 'a dlist -> 'a -> bool
  val foldli : 'a list -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val remdups : 'a equal -> 'a list -> 'a list
  val equal_nata : nat -> nat -> bool
  val equal_nat : nat equal
  val preorder_nat : nat preorder
  val order_nat : nat order
  val zero_nat : nat
  val list_all : ('a -> bool) -> 'a list -> bool
  val ord_integer : Big_int.big_int ord
  val max : 'a ord -> 'a -> 'a -> 'a
  val minus_nat : nat -> nat -> nat
  val times_nat : nat -> nat -> nat
  val remap_rule : ('a -> 'b) -> ('a, 'c) ta_rule -> ('b, 'c) ta_rule
  val dlist_iteratei : 'a dlist -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val iteratei_set_op_list_it_ls_ops :
    'a dlist -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val g_image_filter_ls_ops_ls_ops :
    'b equal -> ('a -> 'b option) -> 'a dlist -> 'b dlist
  type ('a, 'b) assoc_list = Assoc_List of ('a * 'b) list
  type 'a hashable =
    {hashcode : 'a -> nat; bounded_hashcode : nat -> 'a -> nat;
      def_hashmap_size : 'a itself -> nat}
  val hashcode : 'a hashable -> 'a -> nat
  val bounded_hashcode : 'a hashable -> nat -> 'a -> nat
  val def_hashmap_size : 'a hashable -> 'a itself -> nat
  type ('a, 'b) hashmap = RBT_HM of (nat, ('a, 'b) assoc_list) rbt
  val impl_of_RBT_HM :
    'a hashable -> ('a, 'b) hashmap -> (nat, ('a, 'b) assoc_list) rbt
  val impl_ofa : ('a, 'b) assoc_list -> ('a * 'b) list
  val lookupa : 'a equal -> ('a, 'b) assoc_list -> 'a -> 'b option
  val linorder_nat : nat linorder
  val lookupb :
    'a equal * 'a hashable -> 'a -> (nat, ('a, 'b) assoc_list) rbt -> 'b option
  val hm_lookup : 'a equal * 'a hashable -> 'a -> ('a, 'b) hashmap -> 'b option
  val lookup_hm_ops_ls_ops :
    'a equal * 'a hashable -> 'a -> ('a, 'b dlist) hashmap -> 'b dlist
  type ('a, 'b, 'c) hashedTa_ext =
    HashedTa_ext of
      ('a, unit) hashmap * ('a, 'b) ta_rule dlist *
        ('b, ('a, 'b) ta_rule dlist) hashmap option *
        ('a, ('a, 'b) ta_rule dlist) hashmap option *
        (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option * 'c
  val hta_idx_f :
    ('a, 'b, 'c) hashedTa_ext -> ('b, ('a, 'b) ta_rule dlist) hashmap option
  val hta_lookup_f :
    'a equal * 'a hashable ->
      'a -> ('b, 'a, 'c) hashedTa_ext -> ('b, 'a) ta_rule dlist
  val list_all_zip : ('a -> 'b -> bool) -> 'a list -> 'b list -> bool
  val faccs :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> 'b tree -> 'a dlist
  val equal_lista : 'a equal -> 'a list -> 'a list -> bool
  val equal_list : 'a equal -> ('a list) equal
  val gen_length : nat -> 'a list -> nat
  val size_list : 'a list -> nat
  val is_none : 'a option -> bool
  val emptyc : 'a hashable -> unit -> (nat, ('a, 'b) assoc_list) rbt
  val hm_empty_const : 'a hashable -> ('a, 'b) hashmap
  val hm_empty : 'a hashable -> unit -> ('a, 'b) hashmap
  val empty_hm_basic_ops : 'a hashable -> unit -> ('a, unit) hashmap
  val snd : 'a * 'b -> 'b
  val fst : 'a * 'b -> 'a
  val update_with_aux :
    'b equal -> 'a -> 'b -> ('a -> 'a) -> ('b * 'a) list -> ('b * 'a) list
  val update_with :
    'a equal ->
      'b -> 'a -> ('b -> 'b) -> ('a, 'b) assoc_list -> ('a, 'b) assoc_list
  val update :
    'a equal -> 'a -> 'b -> ('a, 'b) assoc_list -> ('a, 'b) assoc_list
  val emptyb : ('a, 'b) assoc_list
  val updatea :
    'a equal * 'a hashable ->
      'a -> 'b -> (nat, ('a, 'b) assoc_list) rbt ->
                    (nat, ('a, 'b) assoc_list) rbt
  val hm_update :
    'a equal * 'a hashable -> 'a -> 'b -> ('a, 'b) hashmap -> ('a, 'b) hashmap
  val ins_hm_basic_ops :
    'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> ('a, unit) hashmap
  val g_image_filter_ls_ops_hs_ops :
    'b equal * 'b hashable ->
      ('a -> 'b option) -> 'a dlist -> ('b, unit) hashmap
  val brc_iq :
    'a equal * 'a hashable -> ('a, 'b) ta_rule dlist -> ('a, unit) hashmap
  val hta_Qi : ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val sgn_integer : Big_int.big_int -> Big_int.big_int
  val abs_integer : Big_int.big_int -> Big_int.big_int
  val apsnd : ('a -> 'b) -> 'c * 'a -> 'c * 'b
  val divmod_integer :
    Big_int.big_int -> Big_int.big_int -> Big_int.big_int * Big_int.big_int
  val mod_integer : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val mod_nat : nat -> nat -> nat
  val fifo_empty : unit -> 'a list * 'a list
  val equal_ta_rulea :
    'a equal -> 'b equal -> ('a, 'b) ta_rule -> ('a, 'b) ta_rule -> bool
  val equal_ta_rule : 'a equal -> 'b equal -> ('a, 'b) ta_rule equal
  val idx_build_stepfun_hm_ops_ls_ops :
    'a equal -> 'b equal * 'b hashable ->
      ('a -> 'b) -> 'a -> ('b, 'a dlist) hashmap -> ('b, 'a dlist) hashmap
  val idx_build_hm_ops_ls_ops_ls_ops :
    'a equal -> 'b equal * 'b hashable ->
      ('a -> 'b) -> 'a dlist -> ('b, 'a dlist) hashmap
  val build_rule_index :
    'a equal -> 'b equal -> 'c equal * 'c hashable ->
      (('a, 'b) ta_rule -> 'c) ->
        ('a, 'b) ta_rule dlist -> ('c, ('a, 'b) ta_rule dlist) hashmap
  val build_rule_index_f :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('b, ('a, 'b) ta_rule dlist) hashmap
  val hta_idx_f_update :
    (('a, ('b, 'a) ta_rule dlist) hashmap option ->
      ('a, ('b, 'a) ta_rule dlist) hashmap option) ->
      ('b, 'a, 'c) hashedTa_ext -> ('b, 'a, 'c) hashedTa_ext
  val hta_delta : ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val hta_ensure_idx_f :
    'a equal -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val iteratei_bset_op_list_it_ls_basic_ops :
    'a dlist -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val g_ball_ls_basic_ops : 'a dlist -> ('a -> bool) -> bool
  val memb_hm_basic_ops :
    'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> bool
  val g_disjoint_ls_ops_hs_ops :
    'a equal * 'a hashable -> 'a dlist -> ('a, unit) hashmap -> bool
  val hta_mema :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a tree -> ('b, 'a, 'c) hashedTa_ext -> bool
  val hta_mem :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a tree -> ('b, 'a, 'c) hashedTa_ext -> bool
  val pa_cond :
    'a hashable -> 'b hashable -> 'c hashable ->
      (('a * 'b), unit) hashmap *
        (('a * 'b) list * (('a * 'b), 'c) ta_rule dlist) ->
        bool
  val equal_proda : 'a equal -> 'b equal -> 'a * 'b -> 'a * 'b -> bool
  val equal_prod : 'a equal -> 'b equal -> ('a * 'b) equal
  val def_hashmap_size_prod :
    'a hashable -> 'b hashable -> ('a * 'b) itself -> nat
  val nat_of_integer : Big_int.big_int -> nat
  val bounded_hashcode_prod :
    'a hashable -> 'b hashable -> nat -> 'a * 'b -> nat
  val hashcode_prod : 'a hashable -> 'b hashable -> 'a * 'b -> nat
  val hashable_prod : 'a hashable -> 'b hashable -> ('a * 'b) hashable
  val hta_idx_sf :
    ('a, 'b, 'c) hashedTa_ext ->
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option
  val hta_lookup_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'a -> 'b -> ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val hta_idx_s :
    ('a, 'b, 'c) hashedTa_ext -> ('a, ('a, 'b) ta_rule dlist) hashmap option
  val hta_lookup_s :
    'a equal * 'a hashable ->
      'a -> ('a, 'b, 'c) hashedTa_ext -> ('a, 'b) ta_rule dlist
  val pa_upd_rule :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      (('a * 'b), unit) hashmap ->
        ('a * 'b) list ->
          ('a * 'b) list -> (('a * 'b), unit) hashmap * ('a * 'b) list
  val pa_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a * 'c), unit) hashmap *
            (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist) ->
            (('a * 'c), unit) hashmap *
              (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist)
  val equal_dlista : 'a equal -> 'a dlist -> 'a dlist -> bool
  val equal_dlist : 'a equal -> 'a dlist equal
  val brc_cond :
    'a hashable -> 'b hashable ->
      ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap) -> bool
  val def_hashmap_size_ta_rule :
    'a hashable -> 'b hashable -> ('a, 'b) ta_rule itself -> nat
  val hashcode_list : 'a hashable -> 'a list -> nat
  val hashcode_of_ta_rule :
    'a hashable -> 'b hashable -> ('a, 'b) ta_rule -> nat
  val bounded_hashcode_ta_rule :
    'a hashable -> 'b hashable -> nat -> ('a, 'b) ta_rule -> nat
  val hashcode_ta_rule : 'a hashable -> 'b hashable -> ('a, 'b) ta_rule -> nat
  val hashable_ta_rule : 'a hashable -> 'b hashable -> ('a, 'b) ta_rule hashable
  val brc_inner_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule ->
        ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap) ->
          ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap)
  val rqrm_lookup :
    'a equal * 'a hashable -> ('a, 'b dlist) hashmap -> 'a -> 'b dlist
  val brc_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, ('a, 'b) ta_rule dlist) hashmap ->
        ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap) ->
          ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap)
  val brec_iqm :
    'a equal * 'a hashable -> 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('a, 'b tree) hashmap
  val build_rule_index_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> (('a * 'b), ('a, 'b) ta_rule dlist) hashmap
  val hta_idx_sf_update :
    ((('a * 'b), ('a, 'b) ta_rule dlist) hashmap option ->
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option) ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val hta_ensure_idx_sf :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val build_rule_index_s :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b) ta_rule dlist -> ('a, ('a, 'b) ta_rule dlist) hashmap
  val hta_idx_s_update :
    (('a, ('a, 'b) ta_rule dlist) hashmap option ->
      ('a, ('a, 'b) ta_rule dlist) hashmap option) ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val hta_ensure_idx_s :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, 'c) hashedTa_ext
  val iteratei :
    ('a, 'b) assoc_list -> ('c -> bool) -> ('a * 'b -> 'c -> 'c) -> 'c -> 'c
  val iteratei_map_op_list_it_lm_ops :
    ('a, 'b) assoc_list -> ('c -> bool) -> ('a * 'b -> 'c -> 'c) -> 'c -> 'c
  val rm_iterateoi :
    ('a, 'b) rbta -> ('c -> bool) -> ('a * 'b -> 'c -> 'c) -> 'c -> 'c
  val iteratei_map_op_list_it_rm_ops :
    'a linorder ->
      ('a, 'b) rbt -> ('c -> bool) -> ('a * 'b -> 'c -> 'c) -> 'c -> 'c
  val iterateia :
    'a linorder ->
      ('a, ('b, 'c) assoc_list) rbt ->
        ('d -> bool) -> ('b * 'c -> 'd -> 'd) -> 'd -> 'd
  val hm_iteratei :
    'a hashable ->
      ('a, 'b) hashmap -> ('c -> bool) -> ('a * 'b -> 'c -> 'c) -> 'c -> 'c
  val iteratei_set_op_list_it_hs_ops :
    'a hashable ->
      ('a, unit) hashmap -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val ins_dj_hm_basic_ops :
    'a equal * 'a hashable -> 'a -> ('a, unit) hashmap -> ('a, unit) hashmap
  val cart_hs_ops_hs_ops_hs_ops :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap -> ('b, unit) hashmap -> (('a * 'b), unit) hashmap
  val whilea : ('a -> bool) -> ('a -> 'a) -> 'a -> 'a
  val iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops :
    'a hashable ->
      ('a, unit) hashmap -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val g_to_list_dflt_basic_ops_hm_basic_ops :
    'a hashable -> ('a, unit) hashmap -> 'a list
  val pa_initial :
    'a equal * 'a hashable -> 'b hashable -> 'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a * 'c), unit) hashmap *
            (('a * 'c) list * (('a * 'c), 'b) ta_rule dlist)
  val init_hta :
    ('a, unit) hashmap -> ('a, 'b) ta_rule dlist -> ('a, 'b, unit) hashedTa_ext
  val hta_proda :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext -> (('a * 'c), 'b, unit) hashedTa_ext
  val hta_prod :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext -> (('a * 'c), 'b, unit) hashedTa_ext
  val def_hashmap_size_nat : nat itself -> nat
  val bounded_hashcode_nat : nat -> nat -> nat
  val hashcode_nat : nat -> nat
  val hashable_nat : nat hashable
  val htai_mem : nat tree -> (nat, nat, unit) hashedTa_ext -> bool
  val rqrm_add :
    'a equal * 'a hashable -> 'b equal ->
      'a -> 'b -> ('a, 'b dlist) hashmap -> ('a, 'b dlist) hashmap
  val fifo_appendr : 'a -> 'a list * 'a list -> 'a list * 'a list
  val fifo_isEmpty : 'a equal -> 'a list * 'a list -> bool
  val fifo_removel : 'a list * 'a list -> 'a * ('a list * 'a list)
  val brec_cond :
    'a equal ->
      ('a, 'b tree) hashmap *
        (('a list * 'a list) * ((('a, 'b) ta_rule, nat) hashmap * 'a option)) ->
        bool
  val brec_construct_witness :
    'a equal * 'a hashable -> 'b hashable ->
      ('a, 'b tree) hashmap -> ('a, 'b) ta_rule -> 'b tree
  val brec_inner_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap ->
        ('a, 'b) ta_rule ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, nat) hashmap * 'a option)) ->
            ('a, 'b tree) hashmap *
              (('a list * 'a list) *
                ((('a, 'b) ta_rule, nat) hashmap * 'a option))
  val brec_step :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, ('a, 'b) ta_rule dlist) hashmap ->
        ('a, unit) hashmap ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, nat) hashmap * 'a option)) ->
            ('a, 'b tree) hashmap *
              (('a list * 'a list) *
                ((('a, 'b) ta_rule, nat) hashmap * 'a option))
  val hta_empty :
    'a hashable -> 'b hashable -> unit -> ('a, 'b, unit) hashedTa_ext
  val g_image_ls_ops_ls_ops : 'b equal -> ('a -> 'b) -> 'a dlist -> 'b dlist
  val g_image_hs_ops_hs_ops :
    'a hashable -> 'b equal * 'b hashable ->
      ('a -> 'b) -> ('a, unit) hashmap -> ('b, unit) hashmap
  val hta_remap :
    'a hashable -> 'b equal * 'b hashable -> 'c equal * 'c hashable ->
      ('a -> 'b) -> ('a, 'c, unit) hashedTa_ext -> ('b, 'c, unit) hashedTa_ext
  val g_union_dflt_basic_ops_hm_basic_ops :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> ('a, unit) hashmap
  val g_union_dj_ls_basic_ops : 'a equal -> 'a dlist -> 'a dlist -> 'a dlist
  val def_hashmap_size_ustate_wrapper :
    'a hashable -> 'b hashable -> ('a, 'b) ustate_wrapper itself -> nat
  val bounded_hashcode_ustate_wrapper :
    'a hashable -> 'b hashable -> nat -> ('a, 'b) ustate_wrapper -> nat
  val hashcode_ustate_wrapper :
    'a hashable -> 'b hashable -> ('a, 'b) ustate_wrapper -> nat
  val hashable_ustate_wrapper :
    'a hashable -> 'b hashable -> ('a, 'b) ustate_wrapper hashable
  val equal_ustate_wrappera :
    'a equal -> 'b equal ->
      ('a, 'b) ustate_wrapper -> ('a, 'b) ustate_wrapper -> bool
  val equal_ustate_wrapper :
    'a equal -> 'b equal -> ('a, 'b) ustate_wrapper equal
  val hta_union :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b, unit) hashedTa_ext ->
        ('c, 'b, unit) hashedTa_ext ->
          (('a, 'c) ustate_wrapper, 'b, unit) hashedTa_ext
  val map_to_nat_hs_ops_hm_ops :
    'a equal * 'a hashable -> ('a, unit) hashmap -> ('a, nat) hashmap
  val g_union_ls_ops_hs_ops :
    'a equal * 'a hashable ->
      'a dlist -> ('a, unit) hashmap -> ('a, unit) hashmap
  val g_Union_image_ls_ops_ls_ops_hs_ops :
    'b equal * 'b hashable -> ('a -> 'b dlist) -> 'a dlist -> ('b, unit) hashmap
  val g_from_list_aux_ls_basic_ops : 'a equal -> 'a dlist -> 'a list -> 'a dlist
  val g_from_list_ls_basic_ops : 'a equal -> 'a list -> 'a dlist
  val rule_states_l : 'a equal -> ('a, 'b) ta_rule -> 'a dlist
  val hta_delta_states :
    'a equal * 'a hashable -> ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val hta_states :
    'a equal * 'a hashable -> ('a, 'b, 'c) hashedTa_ext -> ('a, unit) hashmap
  val hta_reindex :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, unit) hashedTa_ext -> (nat, 'b, unit) hashedTa_ext
  val htai_prod :
    (nat, nat, unit) hashedTa_ext ->
      (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val build_rqrm :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> ('a, ('a, 'b) ta_rule dlist) hashmap
  val hta_add_qi :
    'a equal * 'a hashable -> 'b hashable ->
      'a -> ('a, 'b, unit) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops :
    'c equal -> ('a * 'b -> 'c option) -> 'a dlist -> 'b dlist -> 'c dlist
  val inj_image_filter_cp_ls_ops_ls_ops_ls_ops :
    'c equal ->
      ('a * 'b -> 'c) -> ('a * 'b -> bool) -> 'a dlist -> 'b dlist -> 'c dlist
  val delta_prod_h :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'c equal * 'c hashable ->
      ('a, 'b) ta_rule dlist ->
        ('c, 'b) ta_rule dlist -> (('a * 'c), 'b) ta_rule dlist
  val hta_prodWR :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      'd equal * 'd hashable ->
      ('a, 'b, 'c) hashedTa_ext ->
        ('d, 'b, 'e) hashedTa_ext -> (('a * 'd), 'b, unit) hashedTa_ext
  val g_inter_dflt_basic_ops_hm_basic_ops :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> ('a, unit) hashmap
  val hta_reduce :
    'a equal * 'a hashable -> 'b equal ->
      ('a, 'b, 'c) hashedTa_ext ->
        ('a, unit) hashmap -> ('a, 'b, unit) hashedTa_ext
  val htai_empty : unit -> (nat, nat, unit) hashedTa_ext
  val htai_union :
    (nat, nat, unit) hashedTa_ext ->
      (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val brc_rcm_init :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist -> (('a, 'b) ta_rule, nat) hashmap
  val brc_initial :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule dlist ->
        ('a, unit) hashmap * ('a list * (('a, 'b) ta_rule, nat) hashmap)
  val htai_add_qi :
    nat -> (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val htai_prodWR :
    (nat, nat, unit) hashedTa_ext ->
      (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val g_sel_dflt_basic_ops_hm_basic_ops :
    'a hashable -> ('a, unit) hashmap -> ('a -> bool) -> 'a option
  val g_disjoint_witness_hs_ops_hs_ops :
    'a equal * 'a hashable ->
      ('a, unit) hashmap -> ('a, unit) hashmap -> 'a option
  val g_set_to_listr_hs_ops_fifo_ops :
    'a hashable -> ('a, unit) hashmap -> 'a list * 'a list
  val brec_initial :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, unit) hashmap ->
        ('a, 'b) ta_rule dlist ->
          ('a, 'b tree) hashmap *
            (('a list * 'a list) *
              ((('a, 'b) ta_rule, nat) hashmap * 'a option))
  val hta_add_rule :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b) ta_rule ->
        ('a, 'b, unit) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val htai_add_rule :
    (nat, nat) ta_rule ->
      (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val hta_bwd_reduce :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> ('a, 'b, unit) hashedTa_ext
  val htai_bwd_reduce :
    (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val g_size_dflt_basic_ops_hm_basic_ops :
    'a hashable -> ('a, unit) hashmap -> nat
  val hs_size : 'a hashable -> ('a, unit) hashmap -> nat
  val g_size_ls_basic_ops : 'a dlist -> nat
  val ls_size : 'a dlist -> nat
  val iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops :
    'a linorder ->
      ('a, unit) rbt -> ('b -> bool) -> ('a -> 'b -> 'b) -> 'b -> 'b
  val g_size_dflt_basic_oops_rm_basic_ops : 'a linorder -> ('a, unit) rbt -> nat
  val rs_size : 'a linorder -> ('a, unit) rbt -> nat
  val htai_ensure_idx_f :
    (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val htai_ensure_idx_s :
    (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val htai_ensure_idx_sf :
    (nat, nat, unit) hashedTa_ext -> (nat, nat, unit) hashedTa_ext
  val hta_is_empty_witness :
    'a equal * 'a hashable -> 'b equal * 'b hashable ->
      ('a, 'b, 'c) hashedTa_ext -> 'b tree option
  val htai_is_empty_witness : (nat, nat, unit) hashedTa_ext -> nat tree option
end = struct

let rec id x = (fun xa -> xa) x;;

type 'a equal = {equal : 'a -> 'a -> bool};;
let equal _A = _A.equal;;

let rec eq _A a b = equal _A a b;;

type nat = Nat of Big_int.big_int;;

type num = One | Bit0 of num | Bit1 of num;;

type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool};;
let less_eq _A = _A.less_eq;;
let less _A = _A.less;;

type 'a preorder = {ord_preorder : 'a ord};;

type 'a order = {preorder_order : 'a preorder};;

type 'a linorder = {order_linorder : 'a order};;

type color = R | B;;

type ('a, 'b) rbta = Empty |
  Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta;;

type ('a, 'b) rbt = Rbt of ('a, 'b) rbta;;

type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list;;

let rec lhs (Rule (q, l, qs)) = q;;

let rec hd (x :: xs) = x;;

let rec tl = function [] -> []
             | x :: xs -> xs;;

let rec integer_of_nat (Nat x) = x;;

let rec plus_nat
  m n = Nat (Big_int.add_big_int (integer_of_nat m) (integer_of_nat n));;

let one_nat : nat = Nat (Big_int.big_int_of_int 1);;

let rec suc n = plus_nat n one_nat;;

let rec rhsl (Rule (q, l, qs)) = l;;

let rec rhsq (Rule (q, l, qs)) = qs;;

type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b;;

let rec comp f g = (fun x -> f (g x));;

let rec map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> f x :: map f xs;;

let rec fold
  f x1 s = match f, x1, s with f, x :: xs, s -> fold f xs (f x s)
    | f, [], s -> s;;

let rec rev xs = fold (fun a b -> a :: b) xs [];;

let rec zip
  xs ys = match xs, ys with x :: xs, y :: ys -> (x, y) :: zip xs ys
    | xs, [] -> []
    | [], ys -> [];;

type 'a tree = Node of 'a * 'a tree list;;

let rec null = function [] -> true
               | x :: xs -> false;;

type 'a itself = Type;;

let rec empty _A = Rbt Empty;;

let rec r_prod
  (Rule (q1, l1, qs1)) (Rule (q2, l2, qs2)) = Rule ((q1, q2), l1, zip qs1 qs2);;

type 'a dlist = Dlist of 'a list;;

let rec foldl
  f a x2 = match f, a, x2 with f, a, [] -> a
    | f, a, x :: xs -> foldl f (f a x) xs;;

let rec map_of _A
  x0 k = match x0, k with
    (l, v) :: ps, k -> (if eq _A l k then Some v else map_of _A ps k)
    | [], k -> None;;

let rec less_eq_nat
  m n = Big_int.le_big_int (integer_of_nat m) (integer_of_nat n);;

let rec less_nat
  m n = Big_int.lt_big_int (integer_of_nat m) (integer_of_nat n);;

let ord_nat = ({less_eq = less_eq_nat; less = less_nat} : nat ord);;

let rec the (Some x) = x;;

let rec balance
  x0 s t x3 = match x0, s, t, x3 with
    Branch (R, a, w, x, b), s, t, Branch (R, c, y, z, d) ->
      Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, d))
    | Branch (R, Branch (R, a, w, x, b), s, t, c), y, z, Empty ->
        Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Branch (R, Branch (R, a, w, x, b), s, t, c), y, z,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, a, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (R, Empty, w, x, Branch (R, b, s, t, c)), y, z, Empty ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Branch (R, Branch (B, va, vb, vc, vd), w, x, Branch (R, b, s, t, c)), y,
        z, Empty
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Empty))
    | Branch (R, Empty, w, x, Branch (R, b, s, t, c)), y, z,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, Empty, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (R, Branch (B, ve, vf, vg, vh), w, x, Branch (R, b, s, t, c)), y,
        z, Branch (B, va, vb, vc, vd)
        -> Branch
             (R, Branch (B, Branch (B, ve, vf, vg, vh), w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Empty, w, x, Branch (R, b, s, t, Branch (R, c, y, z, d)) ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, d))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, b, s, t, Branch (R, c, y, z, d))
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, d))
    | Empty, w, x, Branch (R, Branch (R, b, s, t, c), y, z, Empty) ->
        Branch (R, Branch (B, Empty, w, x, b), s, t, Branch (B, c, y, z, Empty))
    | Empty, w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, va, vb, vc, vd))
        -> Branch
             (R, Branch (B, Empty, w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Empty)
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Empty))
    | Branch (B, va, vb, vc, vd), w, x,
        Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, ve, vf, vg, vh))
        -> Branch
             (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
               Branch (B, c, y, z, Branch (B, ve, vf, vg, vh)))
    | Empty, s, t, Empty -> Branch (B, Empty, s, t, Empty)
    | Empty, s, t, Branch (B, va, vb, vc, vd) ->
        Branch (B, Empty, s, t, Branch (B, va, vb, vc, vd))
    | Empty, s, t, Branch (v, Empty, vb, vc, Empty) ->
        Branch (B, Empty, s, t, Branch (v, Empty, vb, vc, Empty))
    | Empty, s, t, Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Empty) ->
        Branch
          (B, Empty, s, t,
            Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Empty))
    | Empty, s, t, Branch (v, Empty, vb, vc, Branch (B, vf, vg, vh, vi)) ->
        Branch
          (B, Empty, s, t,
            Branch (v, Empty, vb, vc, Branch (B, vf, vg, vh, vi)))
    | Empty, s, t,
        Branch
          (v, Branch (B, ve, vj, vk, vl), vb, vc, Branch (B, vf, vg, vh, vi))
        -> Branch
             (B, Empty, s, t,
               Branch
                 (v, Branch (B, ve, vj, vk, vl), vb, vc,
                   Branch (B, vf, vg, vh, vi)))
    | Branch (B, va, vb, vc, vd), s, t, Empty ->
        Branch (B, Branch (B, va, vb, vc, vd), s, t, Empty)
    | Branch (B, va, vb, vc, vd), s, t, Branch (B, ve, vf, vg, vh) ->
        Branch (B, Branch (B, va, vb, vc, vd), s, t, Branch (B, ve, vf, vg, vh))
    | Branch (B, va, vb, vc, vd), s, t, Branch (v, Empty, vf, vg, Empty) ->
        Branch
          (B, Branch (B, va, vb, vc, vd), s, t,
            Branch (v, Empty, vf, vg, Empty))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Empty)
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Empty))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Empty, vf, vg, Branch (B, vj, vk, vl, vm))
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch (v, Empty, vf, vg, Branch (B, vj, vk, vl, vm)))
    | Branch (B, va, vb, vc, vd), s, t,
        Branch
          (v, Branch (B, vi, vn, vo, vp), vf, vg, Branch (B, vj, vk, vl, vm))
        -> Branch
             (B, Branch (B, va, vb, vc, vd), s, t,
               Branch
                 (v, Branch (B, vi, vn, vo, vp), vf, vg,
                   Branch (B, vj, vk, vl, vm)))
    | Branch (v, Empty, vb, vc, Empty), s, t, Empty ->
        Branch (B, Branch (v, Empty, vb, vc, Empty), s, t, Empty)
    | Branch (v, Empty, vb, vc, Branch (B, ve, vf, vg, vh)), s, t, Empty ->
        Branch
          (B, Branch (v, Empty, vb, vc, Branch (B, ve, vf, vg, vh)), s, t,
            Empty)
    | Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Empty), s, t, Empty ->
        Branch
          (B, Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Empty), s, t,
            Empty)
    | Branch
        (v, Branch (B, vf, vg, vh, vi), vb, vc, Branch (B, ve, vj, vk, vl)),
        s, t, Empty
        -> Branch
             (B, Branch
                   (v, Branch (B, vf, vg, vh, vi), vb, vc,
                     Branch (B, ve, vj, vk, vl)),
               s, t, Empty)
    | Branch (v, Empty, vf, vg, Empty), s, t, Branch (B, va, vb, vc, vd) ->
        Branch
          (B, Branch (v, Empty, vf, vg, Empty), s, t,
            Branch (B, va, vb, vc, vd))
    | Branch (v, Empty, vf, vg, Branch (B, vi, vj, vk, vl)), s, t,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch (v, Empty, vf, vg, Branch (B, vi, vj, vk, vl)), s, t,
               Branch (B, va, vb, vc, vd))
    | Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
        Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
               Branch (B, va, vb, vc, vd))
    | Branch
        (v, Branch (B, vj, vk, vl, vm), vf, vg, Branch (B, vi, vn, vo, vp)),
        s, t, Branch (B, va, vb, vc, vd)
        -> Branch
             (B, Branch
                   (v, Branch (B, vj, vk, vl, vm), vf, vg,
                     Branch (B, vi, vn, vo, vp)),
               s, t, Branch (B, va, vb, vc, vd));;

let rec rbt_ins _A
  f k v x3 = match f, k, v, x3 with
    f, k, v, Empty -> Branch (R, Empty, k, v, Empty)
    | f, k, v, Branch (B, l, x, y, r) ->
        (if less _A k x then balance (rbt_ins _A f k v l) x y r
          else (if less _A x k then balance l x y (rbt_ins _A f k v r)
                 else Branch (B, l, x, f k y v, r)))
    | f, k, v, Branch (R, l, x, y, r) ->
        (if less _A k x then Branch (R, rbt_ins _A f k v l, x, y, r)
          else (if less _A x k then Branch (R, l, x, y, rbt_ins _A f k v r)
                 else Branch (R, l, x, f k y v, r)));;

let rec paint
  c x1 = match c, x1 with c, Empty -> Empty
    | c, Branch (uu, l, k, v, r) -> Branch (c, l, k, v, r);;

let rec rbt_insert_with_key _A f k v t = paint B (rbt_ins _A f k v t);;

let rec rbt_insert _A = rbt_insert_with_key _A (fun _ _ nv -> nv);;

let rec impl_of _A (Rbt x) = x;;

let rec insert _A
  x xa xb =
    Rbt (rbt_insert _A.order_linorder.preorder_order.ord_preorder x xa
          (impl_of _A xb));;

let rec rbt_lookup _A
  x0 k = match x0, k with Empty, k -> None
    | Branch (uu, l, x, y, r), k ->
        (if less _A k x then rbt_lookup _A l k
          else (if less _A x k then rbt_lookup _A r k else Some y));;

let rec lookup _A
  x = rbt_lookup _A.order_linorder.preorder_order.ord_preorder (impl_of _A x);;

let emptya : 'a dlist = Dlist [];;

let rec member _A
  x0 y = match x0, y with [], y -> false
    | x :: xs, y -> eq _A x y || member _A xs y;;

let rec inserta _A x xs = (if member _A xs x then xs else x :: xs);;

let rec list_of_dlist (Dlist x) = x;;

let rec insertb _A x dxs = Dlist (inserta _A x (list_of_dlist dxs));;

let rec membera _A dxs = member _A (list_of_dlist dxs);;

let rec foldli
  x0 c f sigma = match x0, c, f, sigma with [], c, f, sigma -> sigma
    | x :: xs, c, f, sigma ->
        (if c sigma then foldli xs c f (f x sigma) else sigma);;

let rec remdups _A
  = function [] -> []
    | x :: xs ->
        (if member _A xs x then remdups _A xs else x :: remdups _A xs);;

let rec equal_nata
  m n = Big_int.eq_big_int (integer_of_nat m) (integer_of_nat n);;

let equal_nat = ({equal = equal_nata} : nat equal);;

let preorder_nat = ({ord_preorder = ord_nat} : nat preorder);;

let order_nat = ({preorder_order = preorder_nat} : nat order);;

let zero_nat : nat = Nat Big_int.zero_big_int;;

let rec list_all
  p x1 = match p, x1 with p, [] -> true
    | p, x :: xs -> p x && list_all p xs;;

let ord_integer =
  ({less_eq = Big_int.le_big_int; less = Big_int.lt_big_int} :
    Big_int.big_int ord);;

let rec max _A a b = (if less_eq _A a b then b else a);;

let rec minus_nat
  m n = Nat (max ord_integer Big_int.zero_big_int
              (Big_int.sub_big_int (integer_of_nat m) (integer_of_nat n)));;

let rec times_nat
  m n = Nat (Big_int.mult_big_int (integer_of_nat m) (integer_of_nat n));;

let rec remap_rule f (Rule (q, l, qs)) = Rule (f q, l, map f qs);;

let rec dlist_iteratei xs = foldli (list_of_dlist xs);;

let rec iteratei_set_op_list_it_ls_ops s = dlist_iteratei s;;

let rec g_image_filter_ls_ops_ls_ops _B
  f s = iteratei_set_op_list_it_ls_ops s (fun _ -> true)
          (fun x res ->
            (match f x with None -> res | Some v -> insertb _B v res))
          emptya;;

type ('a, 'b) assoc_list = Assoc_List of ('a * 'b) list;;

type 'a hashable =
  {hashcode : 'a -> nat; bounded_hashcode : nat -> 'a -> nat;
    def_hashmap_size : 'a itself -> nat};;
let hashcode _A = _A.hashcode;;
let bounded_hashcode _A = _A.bounded_hashcode;;
let def_hashmap_size _A = _A.def_hashmap_size;;

type ('a, 'b) hashmap = RBT_HM of (nat, ('a, 'b) assoc_list) rbt;;

let rec impl_of_RBT_HM _A (RBT_HM x) = x;;

let rec impl_ofa (Assoc_List x) = x;;

let rec lookupa _A al = map_of _A (impl_ofa al);;

let linorder_nat = ({order_linorder = order_nat} : nat linorder);;

let rec lookupb (_A1, _A2)
  k m = (match lookup linorder_nat m (hashcode _A2 k) with None -> None
          | Some lm -> lookupa _A1 lm k);;

let rec hm_lookup (_A1, _A2)
  k hm = lookupb (_A1, _A2) k (impl_of_RBT_HM _A2 hm);;

let rec lookup_hm_ops_ls_ops (_A1, _A2)
  i m = (match hm_lookup (_A1, _A2) i m with None -> emptya | Some s -> s);;

type ('a, 'b, 'c) hashedTa_ext =
  HashedTa_ext of
    ('a, unit) hashmap * ('a, 'b) ta_rule dlist *
      ('b, ('a, 'b) ta_rule dlist) hashmap option *
      ('a, ('a, 'b) ta_rule dlist) hashmap option *
      (('a * 'b), ('a, 'b) ta_rule dlist) hashmap option * 'c;;

let rec hta_idx_f
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_f;;

let rec hta_lookup_f (_A1, _A2)
  f h = lookup_hm_ops_ls_ops (_A1, _A2) f (the (hta_idx_f h));;

let rec list_all_zip
  p x1 x2 = match p, x1, x2 with p, [], [] -> true
    | p, a :: asa, b :: bs -> p a b && list_all_zip p asa bs
    | p, v :: va, [] -> false
    | p, [], v :: va -> false;;

let rec faccs _A (_B1, _B2)
  h (Node (f, ts)) =
    let qs = map (faccs _A (_B1, _B2) h) ts in
    g_image_filter_ls_ops_ls_ops _A
      (fun r ->
        let Rule (_, _, qsa) = r in
        (if list_all_zip (membera _A) qs qsa then Some (lhs r) else None))
      (hta_lookup_f (_B1, _B2) f h);;

let rec equal_lista _A
  x0 x1 = match x0, x1 with a :: lista, [] -> false
    | [], a :: lista -> false
    | aa :: listaa, a :: lista -> eq _A aa a && equal_lista _A listaa lista
    | [], [] -> true;;

let rec equal_list _A = ({equal = equal_lista _A} : ('a list) equal);;

let rec gen_length
  n x1 = match n, x1 with n, x :: xs -> gen_length (suc n) xs
    | n, [] -> n;;

let rec size_list x = gen_length zero_nat x;;

let rec is_none = function Some x -> false
                  | None -> true;;

let rec emptyc _A = (fun _ -> empty linorder_nat);;

let rec hm_empty_const _A = RBT_HM (emptyc _A ());;

let rec hm_empty _A = (fun _ -> hm_empty_const _A);;

let rec empty_hm_basic_ops _A = hm_empty _A;;

let rec snd (a, b) = b;;

let rec fst (a, b) = a;;

let rec update_with_aux _B
  v k f x3 = match v, k, f, x3 with v, k, f, [] -> [(k, f v)]
    | v, k, f, p :: ps ->
        (if eq _B (fst p) k then (k, f (snd p)) :: ps
          else p :: update_with_aux _B v k f ps);;

let rec update_with _A
  v k f al = Assoc_List (update_with_aux _A v k f (impl_ofa al));;

let rec update _A k v = update_with _A v k (fun _ -> v);;

let emptyb : ('a, 'b) assoc_list = Assoc_List [];;

let rec updatea (_A1, _A2)
  k v m =
    let hc = hashcode _A2 k in
    (match lookup linorder_nat m hc
      with None -> insert linorder_nat hc (update _A1 k v emptyb) m
      | Some bm -> insert linorder_nat hc (update _A1 k v bm) m);;

let rec hm_update (_A1, _A2)
  k v hm = RBT_HM (updatea (_A1, _A2) k v (impl_of_RBT_HM _A2 hm));;

let rec ins_hm_basic_ops (_A1, _A2) x s = hm_update (_A1, _A2) x () s;;

let rec g_image_filter_ls_ops_hs_ops (_B1, _B2)
  f s = iteratei_set_op_list_it_ls_ops s (fun _ -> true)
          (fun x res ->
            (match f x with None -> res
              | Some v -> ins_hm_basic_ops (_B1, _B2) v res))
          (empty_hm_basic_ops _B2 ());;

let rec brc_iq (_A1, _A2)
  delta =
    g_image_filter_ls_ops_hs_ops (_A1, _A2)
      (fun r -> (if null (rhsq r) then Some (lhs r) else None)) delta;;

let rec hta_Qi
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_Qi;;

let rec sgn_integer
  k = (if Big_int.eq_big_int k Big_int.zero_big_int then Big_int.zero_big_int
        else (if Big_int.lt_big_int k Big_int.zero_big_int
               then Big_int.minus_big_int (Big_int.big_int_of_int 1)
               else (Big_int.big_int_of_int 1)));;

let rec abs_integer
  k = (if Big_int.lt_big_int k Big_int.zero_big_int then Big_int.minus_big_int k
        else k);;

let rec apsnd f (x, y) = (x, f y);;

let rec divmod_integer
  k l = (if Big_int.eq_big_int k Big_int.zero_big_int
          then (Big_int.zero_big_int, Big_int.zero_big_int)
          else (if Big_int.eq_big_int l Big_int.zero_big_int
                 then (Big_int.zero_big_int, k)
                 else comp (comp apsnd Big_int.mult_big_int) sgn_integer l
                        (if Big_int.eq_big_int (sgn_integer k) (sgn_integer l)
                          then Big_int.quomod_big_int (Big_int.abs_big_int k)
                                 (Big_int.abs_big_int l)
                          else let (r, s) =
                                 Big_int.quomod_big_int (Big_int.abs_big_int k)
                                   (Big_int.abs_big_int l)
                                 in
                               (if Big_int.eq_big_int s Big_int.zero_big_int
                                 then (Big_int.minus_big_int r,
Big_int.zero_big_int)
                                 else (Big_int.sub_big_int
 (Big_int.minus_big_int r) (Big_int.big_int_of_int 1),
Big_int.sub_big_int (abs_integer l) s)))));;

let rec mod_integer k l = snd (divmod_integer k l);;

let rec mod_nat m n = Nat (mod_integer (integer_of_nat m) (integer_of_nat n));;

let rec fifo_empty x = (fun _ -> ([], [])) x;;

let rec equal_ta_rulea _A _B
  (Rule (qa, la, listaa)) (Rule (q, l, lista)) =
    eq _A qa q && (eq _B la l && equal_lista _A listaa lista);;

let rec equal_ta_rule _A _B =
  ({equal = equal_ta_rulea _A _B} : ('a, 'b) ta_rule equal);;

let rec idx_build_stepfun_hm_ops_ls_ops _A (_B1, _B2)
  f x m =
    let i = f x in
    (match hm_lookup (_B1, _B2) i m
      with None -> hm_update (_B1, _B2) i (insertb _A x emptya) m
      | Some s -> hm_update (_B1, _B2) i (insertb _A x s) m);;

let rec idx_build_hm_ops_ls_ops_ls_ops _A (_B1, _B2)
  f t = iteratei_set_op_list_it_ls_ops t (fun _ -> true)
          (idx_build_stepfun_hm_ops_ls_ops _A (_B1, _B2) f) (hm_empty _B2 ());;

let rec build_rule_index _A _B (_C1, _C2)
  = idx_build_hm_ops_ls_ops_ls_ops (equal_ta_rule _A _B) (_C1, _C2);;

let rec build_rule_index_f _A (_B1, _B2)
  delta = build_rule_index _A _B1 (_B1, _B2) rhsl delta;;

let rec hta_idx_f_update
  hta_idx_fa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_fa hta_idx_f, hta_idx_s, hta_idx_sf, more);;

let rec hta_delta
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_delta;;

let rec hta_ensure_idx_f _A (_B1, _B2)
  h = (match hta_idx_f h
        with None ->
          hta_idx_f_update
            (fun _ -> Some (build_rule_index_f _A (_B1, _B2) (hta_delta h))) h
        | Some _ -> h);;

let rec iteratei_bset_op_list_it_ls_basic_ops s = dlist_iteratei s;;

let rec g_ball_ls_basic_ops
  s p = iteratei_bset_op_list_it_ls_basic_ops s (fun c -> c) (fun x _ -> p x)
          true;;

let rec memb_hm_basic_ops (_A1, _A2)
  x s = not (is_none (hm_lookup (_A1, _A2) x s));;

let rec g_disjoint_ls_ops_hs_ops (_A1, _A2)
  s1 s2 =
    g_ball_ls_basic_ops s1 (fun x -> not (memb_hm_basic_ops (_A1, _A2) x s2));;

let rec hta_mema (_A1, _A2) (_B1, _B2)
  t h = not (g_disjoint_ls_ops_hs_ops (_B1, _B2) (faccs _B1 (_A1, _A2) h t)
              (hta_Qi h));;

let rec hta_mem (_A1, _A2) (_B1, _B2)
  t h = hta_mema (_A1, _A2) (_B1, _B2) t (hta_ensure_idx_f _B1 (_A1, _A2) h);;

let rec pa_cond _A _B _C s = let (_, (w, _)) = s in
                             not (null w);;

let rec equal_proda _A _B (aa, ba) (a, b) = eq _A aa a && eq _B ba b;;

let rec equal_prod _A _B = ({equal = equal_proda _A _B} : ('a * 'b) equal);;

let rec def_hashmap_size_prod _A _B
  = (fun _ -> plus_nat (def_hashmap_size _A Type) (def_hashmap_size _B Type));;

let rec nat_of_integer k = Nat (max ord_integer Big_int.zero_big_int k);;

let rec bounded_hashcode_prod _A _B
  n x = mod_nat
          (plus_nat
            (times_nat (bounded_hashcode _A n (fst x))
              (nat_of_integer (Big_int.big_int_of_int 33)))
            (bounded_hashcode _B n (snd x)))
          n;;

let rec hashcode_prod _A _B
  x = plus_nat
        (times_nat (hashcode _A (fst x))
          (nat_of_integer (Big_int.big_int_of_int 33)))
        (hashcode _B (snd x));;

let rec hashable_prod _A _B =
  ({hashcode = hashcode_prod _A _B;
     bounded_hashcode = bounded_hashcode_prod _A _B;
     def_hashmap_size = def_hashmap_size_prod _A _B}
    : ('a * 'b) hashable);;

let rec hta_idx_sf
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_sf;;

let rec hta_lookup_sf (_A1, _A2) (_B1, _B2)
  q f h =
    lookup_hm_ops_ls_ops ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) (q, f)
      (the (hta_idx_sf h));;

let rec hta_idx_s
  (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    hta_idx_s;;

let rec hta_lookup_s (_A1, _A2)
  q h = lookup_hm_ops_ls_ops (_A1, _A2) q (the (hta_idx_s h));;

let rec pa_upd_rule (_A1, _A2) (_B1, _B2)
  q w x2 = match q, w, x2 with q, w, [] -> (q, w)
    | q, w, qp :: qs ->
        (if not (memb_hm_basic_ops
                  ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) qp q)
          then pa_upd_rule (_A1, _A2) (_B1, _B2)
                 (ins_hm_basic_ops
                   ((equal_prod _A1 _B1), (hashable_prod _A2 _B2)) qp q)
                 (qp :: w) qs
          else pa_upd_rule (_A1, _A2) (_B1, _B2) q w qs);;

let rec pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 s =
    let (q, (w, delta_d)) = s in
    let (q1, q2) = hd w in
    iteratei_set_op_list_it_ls_ops (hta_lookup_s (_A1, _A2) q1 h1)
      (fun _ -> true)
      (fun r1 ->
        iteratei_set_op_list_it_ls_ops
          (hta_lookup_sf (_C1, _C2) (_B1, _B2) q2 (rhsl r1) h2) (fun _ -> true)
          (fun r2 res ->
            (if equal_nata (size_list (rhsq r1)) (size_list (rhsq r2))
              then let rp = r_prod r1 r2 in
                   let (qa, (wa, delta_da)) = res in
                   let (qb, wb) =
                     pa_upd_rule (_A1, _A2) (_C1, _C2) qa wa (rhsq rp) in
                   (qb, (wb, insertb (equal_ta_rule (equal_prod _A1 _C1) _B1) rp
                               delta_da))
              else res)))
      (q, (tl w, delta_d));;

let rec equal_dlista _A
  dxs dys = equal_lista _A (list_of_dlist dxs) (list_of_dlist dys);;

let rec equal_dlist _A = ({equal = equal_dlista _A} : 'a dlist equal);;

let rec brc_cond _A _B = (fun (_, (w, _)) -> not (null w));;

let rec def_hashmap_size_ta_rule _A _B
  = (fun _ -> nat_of_integer (Big_int.big_int_of_int 32));;

let rec hashcode_list _A
  = foldl (fun h x ->
            plus_nat (times_nat h (nat_of_integer (Big_int.big_int_of_int 33)))
              (hashcode _A x))
      (nat_of_integer (Big_int.big_int_of_int 5381));;

let rec hashcode_of_ta_rule _A _B
  (Rule (q, f, qs)) =
    plus_nat (plus_nat (hashcode _A q) (hashcode _B f)) (hashcode_list _A qs);;

let rec bounded_hashcode_ta_rule _A _B
  n r = mod_nat (hashcode_of_ta_rule _A _B r) n;;

let rec hashcode_ta_rule _A _B = hashcode_of_ta_rule _A _B;;

let rec hashable_ta_rule _A _B =
  ({hashcode = hashcode_ta_rule _A _B;
     bounded_hashcode = bounded_hashcode_ta_rule _A _B;
     def_hashmap_size = def_hashmap_size_ta_rule _A _B}
    : ('a, 'b) ta_rule hashable);;

let rec brc_inner_step (_A1, _A2) (_B1, _B2)
  r = (fun (q, (w, rcm)) ->
        let c =
          the (hm_lookup ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
                rcm)
          in
        let rcma =
          hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
            (minus_nat c one_nat) rcm
          in
        let qa =
          (if less_eq_nat c one_nat then ins_hm_basic_ops (_A1, _A2) (lhs r) q
            else q)
          in
        let wa =
          (if less_eq_nat c one_nat &&
                not (memb_hm_basic_ops (_A1, _A2) (lhs r) q)
            then lhs r :: w else w)
          in
        (qa, (wa, rcma)));;

let rec rqrm_lookup (_A1, _A2)
  rqrm q =
    (match hm_lookup (_A1, _A2) q rqrm with None -> emptya | Some s -> s);;

let rec brc_step (_A1, _A2) (_B1, _B2)
  rqrm =
    (fun (q, (w, rcm)) ->
      iteratei_set_op_list_it_ls_ops (rqrm_lookup (_A1, _A2) rqrm (hd w))
        (fun _ -> true) (brc_inner_step (_A1, _A2) (_B1, _B2))
        (q, (tl w, rcm)));;

let rec brec_iqm (_A1, _A2) _B
  delta =
    iteratei_set_op_list_it_ls_ops delta (fun _ -> true)
      (fun r m ->
        (if null (rhsq r)
          then hm_update (_A1, _A2) (lhs r) (Node (rhsl r, [])) m else m))
      (hm_empty _A2 ());;

let rec build_rule_index_sf (_A1, _A2) (_B1, _B2)
  delta =
    build_rule_index _A1 _B1 ((equal_prod _A1 _B1), (hashable_prod _A2 _B2))
      (fun r -> (lhs r, rhsl r)) delta;;

let rec hta_idx_sf_update
  hta_idx_sfa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sfa hta_idx_sf, more);;

let rec hta_ensure_idx_sf (_A1, _A2) (_B1, _B2)
  h = (match hta_idx_sf h
        with None ->
          hta_idx_sf_update
            (fun _ ->
              Some (build_rule_index_sf (_A1, _A2) (_B1, _B2) (hta_delta h)))
            h
        | Some _ -> h);;

let rec build_rule_index_s (_A1, _A2) _B
  delta = build_rule_index _A1 _B (_A1, _A2) lhs delta;;

let rec hta_idx_s_update
  hta_idx_sa
    (HashedTa_ext (hta_Qi, hta_delta, hta_idx_f, hta_idx_s, hta_idx_sf, more)) =
    HashedTa_ext
      (hta_Qi, hta_delta, hta_idx_f, hta_idx_sa hta_idx_s, hta_idx_sf, more);;

let rec hta_ensure_idx_s (_A1, _A2) _B
  h = (match hta_idx_s h
        with None ->
          hta_idx_s_update
            (fun _ -> Some (build_rule_index_s (_A1, _A2) _B (hta_delta h))) h
        | Some _ -> h);;

let rec iteratei al c f = foldli (impl_ofa al) c f;;

let rec iteratei_map_op_list_it_lm_ops s = iteratei s;;

let rec rm_iterateoi
  x0 c f sigma = match x0, c, f, sigma with Empty, c, f, sigma -> sigma
    | Branch (col, l, k, v, r), c, f, sigma ->
        (if c sigma
          then let sigmaa = rm_iterateoi l c f sigma in
               (if c sigmaa then rm_iterateoi r c f (f (k, v) sigmaa)
                 else sigmaa)
          else sigma);;

let rec iteratei_map_op_list_it_rm_ops _A s = rm_iterateoi (impl_of _A s);;

let rec iterateia _A
  m c f sigma_0 =
    iteratei_map_op_list_it_rm_ops _A m c
      (fun (_, lm) -> iteratei_map_op_list_it_lm_ops lm c f) sigma_0;;

let rec hm_iteratei _A hm = iterateia linorder_nat (impl_of_RBT_HM _A hm);;

let rec iteratei_set_op_list_it_hs_ops _A
  s = (fun c f -> hm_iteratei _A s c (comp f fst));;

let rec ins_dj_hm_basic_ops (_A1, _A2) x s = hm_update (_A1, _A2) x () s;;

let rec cart_hs_ops_hs_ops_hs_ops (_A1, _A2) (_B1, _B2)
  s1 s2 =
    iteratei_set_op_list_it_hs_ops _A2 s1 (fun _ -> true)
      (fun x ->
        iteratei_set_op_list_it_hs_ops _B2 s2 (fun _ -> true)
          (fun y ->
            ins_dj_hm_basic_ops ((equal_prod _A1 _B1), (hashable_prod _A2 _B2))
              (x, y)))
      (empty_hm_basic_ops (hashable_prod _A2 _B2) ());;

let rec whilea b c s = (if b s then whilea b c (c s) else s);;

let rec iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A
  s = (fun c f -> hm_iteratei _A s c (comp f fst));;

let rec g_to_list_dflt_basic_ops_hm_basic_ops _A
  s = iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A s (fun _ -> true)
        (fun a b -> a :: b) [];;

let rec pa_initial (_A1, _A2) _B (_C1, _C2)
  h1 h2 =
    let qip =
      cart_hs_ops_hs_ops_hs_ops (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2) in
    (qip, (g_to_list_dflt_basic_ops_hm_basic_ops (hashable_prod _A2 _C2) qip,
            emptya));;

let rec init_hta qi delta = HashedTa_ext (qi, delta, None, None, None, ());;

let rec hta_proda (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    let (_, (_, a)) =
      whilea (pa_cond _A2 _C2 _B2)
        (pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2) h1 h2)
        (pa_initial (_A1, _A2) _B2 (_C1, _C2) h1 h2)
      in
    init_hta
      (cart_hs_ops_hs_ops_hs_ops (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2))
      a;;

let rec hta_prod (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    hta_proda (_A1, _A2) (_B1, _B2) (_C1, _C2)
      (hta_ensure_idx_s (_A1, _A2) _B1 h1)
      (hta_ensure_idx_sf (_C1, _C2) (_B1, _B2) h2);;

let rec def_hashmap_size_nat
  x = (fun _ -> nat_of_integer (Big_int.big_int_of_int 16)) x;;

let rec bounded_hashcode_nat na n = mod_nat n na;;

let rec hashcode_nat n = n;;

let hashable_nat =
  ({hashcode = hashcode_nat; bounded_hashcode = bounded_hashcode_nat;
     def_hashmap_size = def_hashmap_size_nat}
    : nat hashable);;

let rec htai_mem
  x = hta_mem (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec rqrm_add (_A1, _A2) _B
  q r res =
    (match hm_lookup (_A1, _A2) q res
      with None -> hm_update (_A1, _A2) q (insertb _B r emptya) res
      | Some s -> hm_update (_A1, _A2) q (insertb _B r s) res);;

let rec fifo_appendr a f = (a :: fst f, snd f);;

let rec fifo_isEmpty _A
  f = equal_proda (equal_list _A) (equal_list _A) f ([], []);;

let rec fifo_removel
  f = (match snd f with [] -> let rp = rev (fst f) in
                              (hd rp, ([], tl rp))
        | a :: l -> (a, (fst f, l)));;

let rec brec_cond _A
  = (fun (_, (w, (_, qwit))) -> not (fifo_isEmpty _A w) && is_none qwit);;

let rec brec_construct_witness (_A1, _A2) _B
  qm r =
    Node (rhsl r, map (fun q -> the (hm_lookup (_A1, _A2) q qm)) (rhsq r));;

let rec brec_inner_step (_A1, _A2) (_B1, _B2)
  qi r =
    (fun (q, (w, (rcm, qwit))) ->
      let c =
        the (hm_lookup ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
              rcm)
        in
      let cond =
        less_eq_nat c one_nat && is_none (hm_lookup (_A1, _A2) (lhs r) q) in
      let rcma =
        hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
          (minus_nat c one_nat) rcm
        in
      let qa =
        (if cond
          then hm_update (_A1, _A2) (lhs r)
                 (brec_construct_witness (_A1, _A2) _B2 q r) q
          else q)
        in
      let wa = (if cond then fifo_appendr (lhs r) w else w) in
      let qwita =
        (if less_eq_nat c one_nat && memb_hm_basic_ops (_A1, _A2) (lhs r) qi
          then Some (lhs r) else qwit)
        in
      (qa, (wa, (rcma, qwita))));;

let rec brec_step (_A1, _A2) (_B1, _B2)
  rqrm qi =
    (fun (q, (w, (rcm, qwit))) ->
      let (qa, wa) = fifo_removel w in
      iteratei_set_op_list_it_ls_ops (rqrm_lookup (_A1, _A2) rqrm qa)
        (fun _ -> true) (brec_inner_step (_A1, _A2) (_B1, _B2) qi)
        (q, (wa, (rcm, qwit))));;

let rec hta_empty _A _B u = init_hta (empty_hm_basic_ops _A ()) emptya;;

let rec g_image_ls_ops_ls_ops _B
  f s = iteratei_set_op_list_it_ls_ops s (fun _ -> true)
          (fun x -> insertb _B (f x)) emptya;;

let rec g_image_hs_ops_hs_ops _A (_B1, _B2)
  f s = iteratei_set_op_list_it_hs_ops _A s (fun _ -> true)
          (fun x -> ins_hm_basic_ops (_B1, _B2) (f x))
          (empty_hm_basic_ops _B2 ());;

let rec hta_remap _A (_B1, _B2) (_C1, _C2)
  f h = init_hta (g_image_hs_ops_hs_ops _A (_B1, _B2) f (hta_Qi h))
          (g_image_ls_ops_ls_ops (equal_ta_rule _B1 _C1) (remap_rule f)
            (hta_delta h));;

let rec g_union_dflt_basic_ops_hm_basic_ops (_A1, _A2)
  s1 s2 =
    iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A2 s1 (fun _ -> true)
      (ins_hm_basic_ops (_A1, _A2)) s2;;

let rec g_union_dj_ls_basic_ops _A
  s1 s2 =
    iteratei_bset_op_list_it_ls_basic_ops s1 (fun _ -> true) (insertb _A) s2;;

let rec def_hashmap_size_ustate_wrapper _A _B
  = (fun _ -> plus_nat (def_hashmap_size _A Type) (def_hashmap_size _B Type));;

let rec bounded_hashcode_ustate_wrapper _A _B
  n x = (match x with USW1 a -> bounded_hashcode _A n a
          | USW2 b ->
            minus_nat (minus_nat n one_nat) (bounded_hashcode _B n b));;

let rec hashcode_ustate_wrapper _A _B
  x = (match x
        with USW1 a ->
          times_nat (nat_of_integer (Big_int.big_int_of_int 2)) (hashcode _A a)
        | USW2 b ->
          plus_nat
            (times_nat (nat_of_integer (Big_int.big_int_of_int 2))
              (hashcode _B b))
            one_nat);;

let rec hashable_ustate_wrapper _A _B =
  ({hashcode = hashcode_ustate_wrapper _A _B;
     bounded_hashcode = bounded_hashcode_ustate_wrapper _A _B;
     def_hashmap_size = def_hashmap_size_ustate_wrapper _A _B}
    : ('a, 'b) ustate_wrapper hashable);;

let rec equal_ustate_wrappera _A _B
  x0 x1 = match x0, x1 with USW2 q2, USW1 q1 -> false
    | USW1 q1, USW2 q2 -> false
    | USW2 q2a, USW2 q2 -> eq _B q2a q2
    | USW1 q1a, USW1 q1 -> eq _A q1a q1;;

let rec equal_ustate_wrapper _A _B =
  ({equal = equal_ustate_wrappera _A _B} : ('a, 'b) ustate_wrapper equal);;

let rec hta_union (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    init_hta
      (g_union_dflt_basic_ops_hm_basic_ops
        ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
        (g_image_hs_ops_hs_ops _A2
          ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
          (fun a -> USW1 a) (hta_Qi h1))
        (g_image_hs_ops_hs_ops _C2
          ((equal_ustate_wrapper _A1 _C1), (hashable_ustate_wrapper _A2 _C2))
          (fun a -> USW2 a) (hta_Qi h2)))
      (g_union_dj_ls_basic_ops
        (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
        (g_image_ls_ops_ls_ops
          (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
          (remap_rule (fun a -> USW1 a)) (hta_delta h1))
        (g_image_ls_ops_ls_ops
          (equal_ta_rule (equal_ustate_wrapper _A1 _C1) _B1)
          (remap_rule (fun a -> USW2 a)) (hta_delta h2)));;

let rec map_to_nat_hs_ops_hm_ops (_A1, _A2)
  s = snd (iteratei_set_op_list_it_hs_ops _A2 s (fun _ -> true)
            (fun x (c, m) -> (plus_nat c one_nat, hm_update (_A1, _A2) x c m))
            (zero_nat, hm_empty _A2 ()));;

let rec g_union_ls_ops_hs_ops (_A1, _A2)
  s1 s2 =
    iteratei_set_op_list_it_ls_ops s1 (fun _ -> true)
      (ins_hm_basic_ops (_A1, _A2)) s2;;

let rec g_Union_image_ls_ops_ls_ops_hs_ops (_B1, _B2)
  f s = iteratei_set_op_list_it_ls_ops s (fun _ -> true)
          (fun x -> g_union_ls_ops_hs_ops (_B1, _B2) (f x))
          (empty_hm_basic_ops _B2 ());;

let rec g_from_list_aux_ls_basic_ops _A
  accs x1 = match accs, x1 with
    accs, x :: l -> g_from_list_aux_ls_basic_ops _A (insertb _A x accs) l
    | y, [] -> y;;

let rec g_from_list_ls_basic_ops _A
  l = g_from_list_aux_ls_basic_ops _A emptya l;;

let rec rule_states_l _A
  (Rule (q, f, qs)) = insertb _A q (g_from_list_ls_basic_ops _A qs);;

let rec hta_delta_states (_A1, _A2)
  h = g_Union_image_ls_ops_ls_ops_hs_ops (_A1, _A2) id
        (g_image_filter_ls_ops_ls_ops (equal_dlist _A1)
          (fun r -> Some (rule_states_l _A1 r)) (hta_delta h));;

let rec hta_states (_A1, _A2)
  h = g_union_dflt_basic_ops_hm_basic_ops (_A1, _A2) (hta_Qi h)
        (hta_delta_states (_A1, _A2) h);;

let rec hta_reindex (_A1, _A2) (_B1, _B2)
  h = let mp = map_to_nat_hs_ops_hm_ops (_A1, _A2) (hta_states (_A1, _A2) h) in
      hta_remap _A2 (equal_nat, hashable_nat) (_B1, _B2)
        (fun q -> the (hm_lookup (_A1, _A2) q mp)) h;;

let rec htai_prod
  h1 h2 =
    hta_reindex
      ((equal_prod equal_nat equal_nat),
        (hashable_prod hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_prod (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec build_rqrm (_A1, _A2) (_B1, _B2)
  delta =
    iteratei_set_op_list_it_ls_ops delta (fun _ -> true)
      (fun r res ->
        foldl (fun resa q ->
                rqrm_add (_A1, _A2) (equal_ta_rule _A1 _B1) q r resa)
          res (rhsq r))
      (hm_empty _A2 ());;

let rec hta_add_qi (_A1, _A2) _B
  qi h = init_hta (ins_hm_basic_ops (_A1, _A2) qi (hta_Qi h)) (hta_delta h);;

let rec inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops _C
  f s1 s2 =
    iteratei_set_op_list_it_ls_ops s1 (fun _ -> true)
      (fun x ->
        iteratei_set_op_list_it_ls_ops s2 (fun _ -> true)
          (fun y res ->
            (match f (x, y) with None -> res | Some z -> insertb _C z res)))
      emptya;;

let rec inj_image_filter_cp_ls_ops_ls_ops_ls_ops _C
  f p s1 s2 =
    inj_image_filter_cartesian_product_ls_ops_ls_ops_ls_ops _C
      (fun xy -> (if p xy then Some (f xy) else None)) s1 s2;;

let rec delta_prod_h (_A1, _A2) (_B1, _B2) (_C1, _C2)
  delta_1 delta_2 =
    inj_image_filter_cp_ls_ops_ls_ops_ls_ops
      (equal_ta_rule (equal_prod _A1 _C1) _B1) (fun (a, b) -> r_prod a b)
      (fun (r1, r2) ->
        eq _B1 (rhsl r1) (rhsl r2) &&
          equal_nata (size_list (rhsq r1)) (size_list (rhsq r2)))
      delta_1 delta_2;;

let rec hta_prodWR (_A1, _A2) (_B1, _B2) (_D1, _D2)
  h1 h2 =
    init_hta
      (cart_hs_ops_hs_ops_hs_ops (_A1, _A2) (_D1, _D2) (hta_Qi h1) (hta_Qi h2))
      (delta_prod_h (_A1, _A2) (_B1, _B2) (_D1, _D2) (hta_delta h1)
        (hta_delta h2));;

let rec g_inter_dflt_basic_ops_hm_basic_ops (_A1, _A2)
  s1 s2 =
    iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A2 s1 (fun _ -> true)
      (fun x s ->
        (if memb_hm_basic_ops (_A1, _A2) x s2
          then ins_dj_hm_basic_ops (_A1, _A2) x s else s))
      (empty_hm_basic_ops _A2 ());;

let rec hta_reduce (_A1, _A2) _B
  h q = init_hta (g_inter_dflt_basic_ops_hm_basic_ops (_A1, _A2) q (hta_Qi h))
          (g_image_filter_ls_ops_ls_ops (equal_ta_rule _A1 _B)
            (fun r ->
              (if memb_hm_basic_ops (_A1, _A2) (lhs r) q &&
                    list_all (fun qa -> memb_hm_basic_ops (_A1, _A2) qa q)
                      (rhsq r)
                then Some r else None))
            (hta_delta h));;

let rec htai_empty x = hta_empty hashable_nat hashable_nat x;;

let rec htai_union
  h1 h2 =
    hta_reindex
      ((equal_ustate_wrapper equal_nat equal_nat),
        (hashable_ustate_wrapper hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_union (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec brc_rcm_init (_A1, _A2) (_B1, _B2)
  delta =
    iteratei_set_op_list_it_ls_ops delta (fun _ -> true)
      (fun r ->
        hm_update ((equal_ta_rule _A1 _B1), (hashable_ta_rule _A2 _B2)) r
          (size_list (remdups _A1 (rhsq r))))
      (hm_empty (hashable_ta_rule _A2 _B2) ());;

let rec brc_initial (_A1, _A2) (_B1, _B2)
  delta =
    let iq = brc_iq (_A1, _A2) delta in
    (iq, (g_to_list_dflt_basic_ops_hm_basic_ops _A2 iq,
           brc_rcm_init (_A1, _A2) (_B1, _B2) delta));;

let rec htai_add_qi x = hta_add_qi (equal_nat, hashable_nat) hashable_nat x;;

let rec htai_prodWR
  h1 h2 =
    hta_reindex
      ((equal_prod equal_nat equal_nat),
        (hashable_prod hashable_nat hashable_nat))
      (equal_nat, hashable_nat)
      (hta_prodWR (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        (equal_nat, hashable_nat) h1 h2);;

let rec g_sel_dflt_basic_ops_hm_basic_ops _A
  s p = iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A s is_none
          (fun x _ -> (if p x then Some x else None)) None;;

let rec g_disjoint_witness_hs_ops_hs_ops (_A1, _A2)
  s1 s2 =
    g_sel_dflt_basic_ops_hm_basic_ops _A2 s1
      (fun x -> memb_hm_basic_ops (_A1, _A2) x s2);;

let rec g_set_to_listr_hs_ops_fifo_ops _A
  s = iteratei_set_op_list_it_hs_ops _A s (fun _ -> true) fifo_appendr
        (fifo_empty ());;

let rec brec_initial (_A1, _A2) (_B1, _B2)
  qi delta =
    let iq = brc_iq (_A1, _A2) delta in
    (brec_iqm (_A1, _A2) _B2 delta,
      (g_set_to_listr_hs_ops_fifo_ops _A2 iq,
        (brc_rcm_init (_A1, _A2) (_B1, _B2) delta,
          g_disjoint_witness_hs_ops_hs_ops (_A1, _A2) iq qi)));;

let rec hta_add_rule (_A1, _A2) (_B1, _B2)
  r h = init_hta (hta_Qi h) (insertb (equal_ta_rule _A1 _B1) r (hta_delta h));;

let rec htai_add_rule
  x = hta_add_rule (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec hta_bwd_reduce (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      hta_reduce (_A1, _A2) _B1 h
        (fst (whilea (brc_cond _A2 _B2) (brc_step (_A1, _A2) (_B1, _B2) rqrm)
               (brc_initial (_A1, _A2) (_B1, _B2) (hta_delta h))));;

let rec htai_bwd_reduce
  x = hta_bwd_reduce (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec g_size_dflt_basic_ops_hm_basic_ops _A
  s = iteratei_bset_op_list_it_dflt_basic_ops_hm_basic_ops _A s (fun _ -> true)
        (fun _ -> suc) zero_nat;;

let rec hs_size _A = g_size_dflt_basic_ops_hm_basic_ops _A;;

let rec g_size_ls_basic_ops
  s = iteratei_bset_op_list_it_ls_basic_ops s (fun _ -> true) (fun _ -> suc)
        zero_nat;;

let rec ls_size x = g_size_ls_basic_ops x;;

let rec iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops _A
  s = (fun c f -> rm_iterateoi (impl_of _A s) c (comp f fst));;

let rec g_size_dflt_basic_oops_rm_basic_ops _A
  s = iteratei_bset_op_list_it_dflt_basic_oops_rm_basic_ops _A s (fun _ -> true)
        (fun _ -> suc) zero_nat;;

let rec rs_size _A = g_size_dflt_basic_oops_rm_basic_ops _A;;

let rec htai_ensure_idx_f
  x = hta_ensure_idx_f equal_nat (equal_nat, hashable_nat) x;;

let rec htai_ensure_idx_s
  x = hta_ensure_idx_s (equal_nat, hashable_nat) equal_nat x;;

let rec htai_ensure_idx_sf
  x = hta_ensure_idx_sf (equal_nat, hashable_nat) (equal_nat, hashable_nat) x;;

let rec hta_is_empty_witness (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      (match
        whilea (brec_cond _A1) (brec_step (_A1, _A2) (_B1, _B2) rqrm (hta_Qi h))
          (brec_initial (_A1, _A2) (_B1, _B2) (hta_Qi h) (hta_delta h))
        with (q, (_, (_, None))) -> None
        | (q, (_, (_, Some qa))) -> hm_lookup (_A1, _A2) qa q);;

let rec htai_is_empty_witness
  x = hta_is_empty_witness (equal_nat, hashable_nat) (equal_nat, hashable_nat)
        x;;

end;; (*struct Ta*)
