header "Setup of Environment for CAVA Model Checker"
theory CAVA_Base
  imports 
  "../../Collections/ICF/CollectionsV1"  (*-- {* Compatibility with ICF 1.0 *}*)
  "../../Collections/Refine_Dflt"      

  "Statistics" (*-- {* Collecting statistics by instrumenting the formalization *}*)

  "CAVA_Code_Target" (*-- {* Code Generator Setup *}*)
begin

(* Select-function that selects element from set *)
(* TODO: Move! Is select properly integrated into autoref? *)
  definition select where
    "select S \<equiv> if S={} then RETURN None else RES {Some s | s. s\<in>S}"

  text {* Cleaning up the namespace a bit *}
  
  hide_type (open) Word.word
  no_notation bits_class.test_bit (infixl "!!" 100)

  text {* Some custom setup in cava, that does not match HOL defaults: *}
  declare Let_def[simp add]


  (* TODO: Should be contained in Isabelle since de0a4a76d7aa under 
    Option.bind_split{s,_asm}*)
  lemma option_bind_split: "P (Option.bind m f) 
  \<longleftrightarrow> (m = None \<longrightarrow> P None) \<and> (\<forall>v. m=Some v \<longrightarrow> P (f v))"
    by (cases m) auto

  lemma option_bind_split_asm: "P (Option.bind m f) = (\<not>(
      m=None \<and> \<not>P None 
    \<or> (\<exists>x. m=Some x \<and> \<not>P (f x))))"
    by (cases m) auto

  lemmas option_bind_splits = option_bind_split option_bind_split_asm

end

