theory SE_DFS_Impl
imports Nested_DFS_Impl SE_DFS
begin

locale SE_DFS_Impl_pre = BlueDFS_Impl_pre sops sopsR sopsS M accpt \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>M \<gamma>_inv +
                         SE_DFS_pre \<alpha>succs v\<^sub>0 "Collect accpt" M
  for sops :: "('n, 's, 'X) set_ops_scheme"
  and sopsR :: "('n, 'r, 'Z) set_ops_scheme"
  and sopsS :: "('n, 'st, 'ZZ) set_ops_scheme"
  and accpt
  and \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv
  and M
  and \<gamma>M :: "('st \<times> ('n, 'r) blue_res, 'n, 's, '\<gamma>) impl_sws \<Rightarrow> 'r \<Rightarrow> 'st \<Rightarrow> 'n \<Rightarrow> bool"
begin

definition se_remove_impl' :: "('st \<times> ('n, 'r) blue_res, 'n, 's, '\<gamma>) impl_sws \<Rightarrow> _" where
  "se_remove_impl' s x \<equiv> let _ = NDFS_Statistics.match_blue() in case istate s of
               (St, CYCLE_NO R) \<Rightarrow> do {
                            let hs = hd (istack s);
                            if (accpt x \<or> accpt hs) \<and> setS.memb x St
                            then do {
                              let rs = rev (istack s);
                              let cyc = mk_cycle rs x;
                              let p = [hs, x];
                              RETURN ((St, CYCLE_FIN hs x rs p cyc), iss s) }
                            else RETURN ((St, CYCLE_NO R), iss s) }
              | _ \<Rightarrow> RETURN (istate s, iss s)"

schematic_lemma se_remove_impl_aux:
  "RETURN (?code s x) \<le> se_remove_impl' s x"
  unfolding se_remove_impl'_def
  by (refine_transfer)

concrete_definition se_remove_impl for s x uses se_remove_impl_aux

definition se_dfs_impl :: "('st \<times> ('n, 'r) blue_res, 'n, 's, '\<gamma>) dfs_algorithm_impl" where
  "se_dfs_impl = blue_dfs_impl\<lparr> dfs_impl_remove := se_remove_impl \<rparr>"

lemma se_dfs_impl_simps[simp]:
  "dfs_impl_cond se_dfs_impl S \<longleftrightarrow> (case S of (_, CYCLE_NO _) \<Rightarrow> True | _ \<Rightarrow> False)"
  "dfs_impl_visit se_dfs_impl = blue_visit_impl"
  "dfs_impl_post se_dfs_impl = blue_post_impl"
  "dfs_impl_remove se_dfs_impl = se_remove_impl"
  "dfs_impl_start se_dfs_impl x = (setS.empty(), CYCLE_NO (setR.empty ()))"
by (simp_all add: se_dfs_impl_def)
end

locale SE_DFS_Impl_def = SE_DFS_Impl_pre sops sopsR sopsS accpt \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv +
                         NestedDFS_Impl_def se_dfs se_dfs_impl blue_impl_invar blue\<alpha>\<^sub>\<sigma> sops \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 accpt \<gamma>_inv snd +
                         SE_DFS_def M \<alpha>succs v\<^sub>0 "Collect accpt"
  for sops :: "('n, 's, 'X) set_ops_scheme"
  and sopsR :: "('n, 'r, 'Y) set_ops_scheme"
  and sopsS
  and accpt
  and \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv
begin
abbreviation "se_dfs_code \<equiv> dfs_code"
abbreviation "se_dfs_algo_impl \<equiv> dfs_algo_impl"
abbreviation "se_dfsbr \<equiv> dfsbr"
abbreviation "se_dfs_algo \<equiv> dfs_algo"
end

locale SE_DFS_Impl = SEI: SE_DFS_Impl_def M \<gamma>M sops sopsR sopsS accpt \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv +
                     blue!: BlueDFS_Impl sops sopsR sopsS accpt M \<gamma>M \<gamma>succs \<gamma>\<^sub>0 \<gamma>_inv v\<^sub>0 +
                     SE: SE_DFS M \<alpha>succs v\<^sub>0 "Collect accpt"
  for sops :: "('n, 's, 'X) set_ops_scheme"
  and sopsR :: "('n, 'r, 'Z) set_ops_scheme"
  and sopsS :: "('n, 'st, 'ZZ) set_ops_scheme"
  and M \<gamma>M
  and accpt \<gamma>succs and v\<^sub>0 :: "'n"
  and \<gamma>\<^sub>0 and \<gamma>_inv :: "'\<gamma> \<Rightarrow> bool"
begin

no_notation SEI.DI_to_graph ("\<G>")
no_notation SEI.DI_reachable ("_ \<rightarrow>\<star> _" [100,100] 40) 
no_notation SEI.DI_reachable1 ("_ \<rightarrow>+ _" [100,100] 40)

(* transfer properties from BlueDFS *)
lemma [simp]: "dfs_start_impl x = blue.dfs_start_impl x"
unfolding dfs_start_impl_def blue.dfs_start_impl_def by simp

lemma [simp]: "impl_sws_invar s \<longleftrightarrow> blue.impl_sws_invar s"
unfolding impl_sws_invar_def blue.impl_sws_invar_def
by simp

(* The properties of the new remove impl *)
lemma se_remove_correct':
  assumes "(si, s) \<in> se_dfsbr"
  shows "se_remove_impl' si x \<le> \<Down>statebr (se_dfs_remove s x)"
proof -
  from assms have "blue_impl_invar si" by auto
  with assms show ?thesis
    unfolding se_remove_impl'_def se_dfs_remove_def blue_impl_invar_def
      by refine_rcg 
         (auto 
           simp add: blue.setS.correct blue.statebr'_def blue.statebr_def br_def
           split: prod.splits blue_res.splits)
qed

lemmas se_remove_correct = se_remove_correct'[THEN order_trans[OF se_remove_impl.refine]]

lemma se_remove_invar:
  assumes "(si, s) \<in> se_dfsbr"
  and "blue\<alpha>\<^sub>\<sigma> (istate si) = CYCLE_NO R\<gamma>"
  and "(Si, \<gamma>) = se_remove_impl si x"
  shows "blue_impl_invar (rem_step_upd_impl si Si \<gamma>)"
proof -
  from assms obtain R St where C: "istate si = (St, CYCLE_NO R)" by (cases "istate si", cases "snd (istate si)") auto

  from assms have "blue_impl_invar si" by auto
  with assms C show ?thesis
    unfolding blue_impl_invar_def rem_step_upd_impl_def
    by (fastforce simp add: Let_def se_remove_impl_def split: prod.splits blue_res.splits split_if_asm)
qed
end

sublocale SE_DFS_Impl \<subseteq> DFS_Impl se_dfs se_dfs_impl blue_impl_invar blue\<alpha>\<^sub>\<sigma>
  apply unfold_locales
  apply (simp split: blue_res.splits prod.split)
  apply (simp add: blue.setR.correct blue.setS.correct)
  apply (simp add: blue.blue_impl_invar_start)
  apply (simp add: blue.visit_correct_blue split: blue_res.split_asm)
  apply (simp add: blue.visit_invar split: blue_res.split_asm)
  apply (simp add: se_remove_correct) 
  apply (simp add: se_remove_invar split: blue_res.split_asm)
  apply (simp add: blue.post_correct_blue split: blue_res.split_asm)
  apply (simp add: blue.post_invar split: blue_res.split_asm)
  apply (simp add: blue.succ_step_invar)
done

context SE_DFS_Impl
begin

lemma se_dfs_code_refine:
  assumes "x \<in> V"
  shows "RETURN (se_dfs_code x) \<le>\<Down>se_dfsbr (se_dfs_algo x)"
proof -
  note dfs_code.refine[of x]
  also note dfs_algo_impl_refine[OF assms]
  finally show ?thesis .
qed
end

sublocale SE_DFS_Impl \<subseteq> NestedDFS_Impl se_dfs se_dfs_impl blue_impl_invar blue\<alpha>\<^sub>\<sigma> snd _ _ _ _ _ _ "setR.\<alpha>"
  by unfold_locales (simp add: blue.blue\<alpha>\<^sub>\<sigma>'_correct)

locale HPY_SE_Impl_def = HPY_Impl_pre sops sopsR sopsS
                     + b: SE_DFS_Impl_def hpyM hpyM_impl sops sopsR sopsS accpt \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv
                     + h: HPY_SE_def \<alpha>succs v\<^sub>0 "Collect accpt"
  for \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv accpt sops sopsR sopsS
begin
abbreviation "hpyse_code \<equiv> dfs_code"
abbreviation "hpyse_dfs_algo_impl \<equiv> dfs_algo_impl"
abbreviation "hpyse_dfsbr \<equiv> dfsbr"
abbreviation "hpyse_dfs_algo \<equiv> dfs_algo"
end

locale HPY_SE_Impl = hpyblue!: HPY_Impl sops sopsR sopsS \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv accpt
                   + HPY_SE_Impl_def \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv accpt sops sopsR sopsS
                   + HPY_SE hpyblue.\<alpha>succs v\<^sub>0 "Collect accpt"
  for sops :: "('n, 's, 'X) set_ops_scheme"
  and sopsR :: "('n, 'r, 'Z) set_ops_scheme"
  and sopsS :: "('n, 'st, 'ZZ) set_ops_scheme"
  and \<gamma>succs v\<^sub>0 \<gamma>\<^sub>0 \<gamma>_inv accpt

sublocale HPY_SE_Impl \<subseteq> SE_DFS_Impl sops sopsR sopsS hpyM hpyblue.hpyM_impl
  by unfold_locales
end
