{-# LANGUAGE TypeSynonymInstances #-}
module Nested_DFS_Export_Add (basic_dfs_code, se_dfs_code, hpy_dfs_code, nested_to_visited, edges_to_graph, list_to_set, istate) where

import Nat
import Nested_DFS_Export
import Control.DeepSeq
import Data.Array.Diff (DiffArray)
import Data.Array.IArray (elems, indices)
import Data.Ix (Ix)

instance NFData Nat where
    rnf (Nat x) = rnf x `seq` ()

instance (NFData a, NFData b) => NFData (Rbta a b) where
    rnf Empty = ()
    rnf (Branch _ l a b r) = rnf l `seq` rnf a `seq` rnf b `seq` rnf r

instance (Linorder a, NFData a, NFData b) => NFData (Rbt a b) where
    rnf (Rbt x) = rnf x

instance NFData a => NFData (Dlist a) where
    rnf (Dlist l) = rnf l

instance (NFData a, NFData b, Ix a) => NFData (DiffArray a b) where
    rnf x = rnf (elems x) `seq` rnf (indices x)
