theory Scratch
imports DFS_Framework_Refine_Aux
begin
  (* TODO: Move *)
  lemma hd_not_in_set_iff_Nil[simp]: "hd l \<notin> set l \<longleftrightarrow> l=[]"
    by (cases l) auto

  lemma list_not_cons_iff_Nil[simp]: "(\<forall>x xs. l\<noteq>x#xs) \<longleftrightarrow> (l=[])"
    by (cases l) auto

  definition "select s \<equiv> do {
    ASSERT (s\<noteq>{});
    x \<leftarrow> SPEC (\<lambda>x. x\<in>s);
    RETURN (x,s-{x})
  }"

  lemma "s\<noteq>{} \<Longrightarrow> select s \<le> SPEC (\<lambda>(x,s'). x\<in>s \<and> s'=s-{x})"
    unfolding select_def by refine_vcg auto

  definition "ls_rel \<equiv> {(l,s). set l = s \<and> distinct l}"

  definition "select' l \<equiv> do {
    ASSERT (l\<noteq>[]);
    let x = hd l;
    RETURN (x, tl l)
  }"

  lemma "(l,s)\<in>ls_rel \<Longrightarrow> select' l \<le> \<Down>(Id \<times>\<^sub>r ls_rel) (select s)"
    unfolding select'_def select_def
    by (refine_vcg) (auto simp: ls_rel_def neq_Nil_conv)





  definition "rem s \<equiv> SPEC (\<lambda>r. if s={} then r=s else (\<exists>x\<in>s. r=s-{x}))"

  definition "rem' l \<equiv> case l of [] \<Rightarrow> RETURN [] | x#xs \<Rightarrow> RETURN xs"

  lemma "(l,s)\<in>ls_rel \<Longrightarrow> rem' l \<le> \<Down>ls_rel (rem s)"
    unfolding ls_rel_def rem_def rem'_def
    apply (refine_rcg refine_vcg SPEC_refine)
    apply (auto split: list.split option.split simp: option_rel_def)
    done    







end

