structure L = List;
structure O = Option;

use "Unsynchronized";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Syntax";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Basic";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Lexer";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Expression";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Statement";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/Module";
use "../CAVA_LTL_Modelchecker/code/PromelaParser/SML/SyntaxConverter";

use "Promela";

structure List = L;
structure Option = O;
structure S = SyntaxConverter(PromelaAST);

fun int_to_charlist i = 
    let 
      val i = String.explode (IntInf.toString i)
    in
      if List.length i = 1 then #" "::i else i
    end;

fun nat_to_charlist i = int_to_charlist (Arith.integer_of_nat i);

fun println x = print (x ^ "\n");

PolyML.print_depth 25;

val a = Module.fileParse "test.pml";
val b = List.map S.convert a;
val c = Promela.preprocess b;

val (_,(g,p)) = PolyML.exception_trace (fn () => Promela.setUp c);
List.app (println o String.implode) (Promela.printProcesses int_to_charlist p);
