#!/bin/bash
# Dirty little hack to extract the afp-submissions

function mk_entry {
  entry=$1
  dir=`mktemp -d`
  mkdir "$dir/$entry"
  echo "Building $entry in $dir"
  add_files=""
  test -f "$entry/AFP_ADD_FILES" && add_files=`cat "$entry/AFP_ADD_FILES" | grep -v "^[[:space:]]*#" | sed -re "s/^/$entry\//"`

  cp --parents -a `grep "^$entry/" $raw_deps` "$entry/ROOT" $add_files "$dir/"

  if test -x "$entry/AFP_PREPARE_SUBMISSION"; then
    echo "Preparing submission in $dir/$entry"
    full_path=$PWD/$entry/AFP_PREPARE_SUBMISSION
    pushd "$dir/$entry" > /dev/null
    $full_path
    popd > /dev/null
    echo "Done"
  fi

  tar -C "$dir" -czf "afp_submission/$entry.tgz" "$entry"
}

entries=""
ventries=""

while test $# -gt 0 && test $1 != "-v"; do
  entries="$entries $1"
  shift
done

if test $1 = "-v"; then
  shift
  ventries=$@
fi

test -z "$entries" && entries="CAVA_Automata CAVA_LTL_Modelchecker Gabow_SCC LTL_to_GBA Promela"

echo "Entries: $entries\n Virtual entries (sessions contributing files, but no submission folder): $ventries"

mkdir -p afp_submission

export raw_deps=`mktemp`
echo "Listing Dependencies to $raw_deps"
isabelle-dev build -nld $PWD $entries $ventries | grep "^  $PWD" | sed -re "s|^  $PWD/||g" | sort -u > $raw_deps
for i in $entries; do mk_entry $i; done

