theory Ample_Correctness
imports
  "Ample_Abstract"
  "Formula"
begin

  locale ample_correctness =
    S!: system_complete en ex init int +
    R!: system_complete ren ex init int +
    F!: formula_next_free \<phi> +
    ample_abstract en ex init int ind src ren
    for en :: "'state \<Rightarrow> 'action set"
    and ex :: "'action \<Rightarrow> 'state \<Rightarrow> 'state"
    and init :: "'state set"
    and int :: "'state \<Rightarrow> 'interpretation"
    and ind :: "'action \<Rightarrow> 'action \<Rightarrow> bool"
    and src :: "'state \<Rightarrow> 'state \<Rightarrow> bool"
    and ren :: "'state \<Rightarrow> 'action set"
    and \<phi> :: "'interpretation pltl"
  begin

    lemma reduction_language_indistinguishable:
      assumes "R.language \<subseteq> F.language"
      shows "S.language \<subseteq> F.language"
    proof
      fix u
      assume 1: "u \<in> S.language"
      obtain v where 2: "v \<in> R.language" "u \<approx> v" using reduction_language_stuttering 1 by this
      have 3: "v \<in> F.language" using assms 2(1) by rule
      show "u \<in> F.language" using 2(2) 3 by auto
    qed

    theorem reduction_correct: "S.language \<subseteq> F.language \<longleftrightarrow> R.language \<subseteq> F.language"
      using reduction_language_subset reduction_language_indistinguishable by blast

  end

end
