theory LList_Prefixes
imports
  "Word_Prefixes"
  "../Extensions/Coinductive_List_Extensions"
begin

  lemma llist_of_inf_llist_prefix[intro]: "u \<le>\<^sub>F\<^sub>I v \<Longrightarrow> llist_of u \<le> inf_llist v"
    by (metis (poly_guards_query) le_llist_conv_lprefix ltake_enat_inf_llist
      ltake_is_lprefix order_refl prefix_conc_fst prefix_fininfE take_all)
  lemma prefix_llist_of_inf_llist[intro]: "lfinite u \<Longrightarrow> u \<le> v \<Longrightarrow> list_of u \<le>\<^sub>F\<^sub>I lnth v"
    by (metis le_llist_conv_lprefix llist_of_list_of lnth_lappend_llist_of
      lprefix_conv_lappend prefix_fininfI_nth)

  lemma lproject_prefix_limit_chain:
    assumes "chain w" "\<And> k. lproject A (llist_of (w k)) \<le> x"
    shows "lproject A (inf_llist (limit w)) \<le> x"
  proof (rule lproject_prefix_limit')
    fix k
    obtain l where 1: "k < length (w l)" using assms(1) by rule
    show "\<exists> v \<le> inf_llist (limit w). enat k < llength v \<and> lproject A v \<le> x"
    proof (intro exI conjI)
      show "llist_of (w l) \<le> inf_llist (limit w)"
        using llist_of_inf_llist_prefix chain_prefix_limit assms(1) by this
      show "enat k < llength (llist_of (w l))" using 1 by simp
      show "lproject A (llist_of (w l)) \<le> x" using assms(2) by this
    qed
  qed

end