theory Formula
imports
  "Extensions/Word_Extensions"
  "../Libs/Stuttering_Equivalence/PLTL"
begin

  locale formula =
    fixes \<phi> :: "'a pltl"
  begin

    definition language :: "'a word set"
      where "language \<equiv> {w. w \<Turnstile> \<phi>}"
  
    lemma language_entails[iff]: "w \<in> language \<longleftrightarrow> w \<Turnstile> \<phi>" unfolding language_def by simp

  end

  locale formula_next_free =
    formula \<phi>
    for \<phi> :: "'a pltl"
    +
    assumes next_free: "next_free \<phi>"
  begin

    lemma stutter_equivalent_entails[dest]: "u \<approx> v \<Longrightarrow> u \<Turnstile> \<phi> \<longleftrightarrow> v \<Turnstile> \<phi>"
      using next_free_stutter_invariant next_free by blast

  end

end
