open RegularExpression
open NFA_string
open ThompsonString

fun nth l 0 = hd l
  | nth l n = nth (tl l) (n-1)

fun getParameterString n default =
	if length (CommandLine.arguments ()) <= n
	then default
	else nth (CommandLine.arguments ()) n

fun getParameterInteger n default =
	if length (CommandLine.arguments ()) <= n
	then default
	else
		case Int.fromString (nth (CommandLine.arguments ()) n)
		of SOME k => k
		 | NONE => default

val rexpText = getParameterString 0 "(a+b)b*(a+1)"
val rexp = parse rexpText

val _ =
	case rexp
	of SOME rexp => show_NFA NONE (taTranslateNormalize (liftToString rexp))
	 | NONE => print ("error: the given string (" ^ rexpText ^ ") could not be parsed as a regular expression\n")
