theory LTS_Extensions
imports "../../Automata_Malik_Tuerk/LTS"
begin

  inductive LTS_is_fin_path :: "('q, 'a) LTS \<Rightarrow> 'q \<Rightarrow> ('q \<times> 'a \<times> 'q) list \<Rightarrow> 'q \<Rightarrow> bool"
  for \<Delta>
  where
    "LTS_is_fin_path \<Delta> l [] l" |
    "(p, a, q) \<in> \<Delta> \<Longrightarrow> LTS_is_fin_path \<Delta> q ts l \<Longrightarrow> LTS_is_fin_path \<Delta> p ((p, a, q) # ts) l"

  definition LTS_fin_path_word :: "('q \<times> 'a \<times> 'q) list \<Rightarrow> 'a list"
  where "LTS_fin_path_word ts \<equiv> map (fst \<circ> snd) ts"

  declare LTS_is_fin_path.intros[intro]
  declare LTS_is_fin_path.cases[elim]
  lemma LTS_is_fin_path_simps[simp]:
    "LTS_is_fin_path \<Delta> f [] l \<longleftrightarrow> f = l"
    "LTS_is_fin_path \<Delta> p ((p, a, q) # ts) l \<longleftrightarrow> (p, a, q) \<in> \<Delta> \<and> LTS_is_fin_path \<Delta> q ts l"
    by auto
  lemmas LTS_is_fin_path_induct = LTS_is_fin_path.induct[case_names Reflexive Step]

  lemma LTS_fin_path_word_simps[simp]:
    "LTS_fin_path_word [] = []"
    "LTS_fin_path_word (t # ts) = fst (snd t) # LTS_fin_path_word ts"
    "length (LTS_fin_path_word ts) = length ts"
    unfolding LTS_fin_path_word_def
    by auto

  lemma LTS_is_reachable_fin_path: "LTS_is_reachable \<Delta> f w l \<longleftrightarrow>
    (\<exists> ts. LTS_is_fin_path \<Delta> f ts l \<and> LTS_fin_path_word ts = w)"
    apply (induct w arbitrary: f)
    apply force
    apply force
  done

end