theory Regular_Set_Extensions
imports "../../Libs/Regular-Sets/Regular_Set"
begin

  definition reflcl :: "'a lang \<Rightarrow> 'a lang"
  where "reflcl A \<equiv> \<Union> n \<in> {0..1}. A ^^ n"
  definition transcl :: "'a lang \<Rightarrow> 'a lang"
  where "transcl A \<equiv> \<Union> n \<in> {1..}. A ^^ n"

  lemma reflcl_alt_def: "reflcl A = insert [] A"
  proof -
    have a: "{0 :: nat} \<union> {1} = {0..1}" by auto
    have b: "(\<Union> n \<in> {0} \<union> {1}. A ^^ n) = A ^^ 0 \<union> A ^^ 1" using UN_Un by auto
    show ?thesis using a b unfolding reflcl_def by auto
  qed

  lemma reflcl_transcl_eq_star: "reflcl (transcl A) = star A"
  proof -
    have a: "{0 :: nat} \<union> {1..} = UNIV" by auto
    have b: "(\<Union> n \<in> {0}. A ^^ n) \<union> transcl A = star A"
      using a UN_Un unfolding transcl_def star_def by blast
    show ?thesis using b unfolding reflcl_alt_def by simp
  qed

  lemma set_pow_lang:
    assumes "\<And> w. w \<in> set ws \<Longrightarrow> w \<in> A"
    shows "concat ws \<in> A ^^ length ws"
    using assms
    by (induct ws, auto)

end
