theory TA_Correctness
imports
  TM_Correctness
  TA_EqualityTM
begin

  lemma TA_translate_NFA_wrapper_eq_TM:
    "TA_translate_NFA_wrapper r = TM_translate_NFA_wrapper r"
  proof -
    interpret invar!: TA_invar TM_zero_NFA 0 False
      unfolding TA_invar_def
      using TM_zero_NFA_well_formed
      by auto
    obtain \<A> n e where a: "(\<A>, n, e) = TA_translate_NFA r (TM_zero_NFA, 0, False)"
      using PairE by metis
    have b: "\<A> = fst (TA_translate_NFA r (TM_zero_NFA, 0, False))"
      using a fst_conv
      by metis
    have c: "\<A> = TM_translate_NFA r 0"
      using TA_translate_NFA.adds[OF a invar.TA_invar_axioms, of 0]
      by simp
    show ?thesis
      unfolding TA_translate_NFA_wrapper.simps
      unfolding TM_zero_NFA_def[symmetric]
      using b c
      by simp
  qed

  theorem TA_translate_NFA_wrapper_correct:
    "NFA (TA_translate_NFA_wrapper r)"
    "\<L> (TA_translate_NFA_wrapper r) = lang r"
    unfolding TA_translate_NFA_wrapper_eq_TM
    using TM_translate_NFA_wrapper_correct[of r]
    by this

end
