theory Thompson_Implementation
imports
  "../../Automata_Malik_Tuerk/implementation/NFAByLTS"
  "../../Automata_Malik_Tuerk/implementation/instantiations/RBT/RBT_NFAImpl"
begin

  lemma (in nfa_by_lts_defs) nfa_\<alpha>_simps[simp]:
    "\<Q> (nfa_\<alpha> A) = s.\<alpha> (nfa_states A)"
    "\<Sigma> (nfa_\<alpha> A) = l.\<alpha> (nfa_labels A)"
    "\<Delta> (nfa_\<alpha> A) = d.\<alpha> (nfa_trans A)"
    "\<I> (nfa_\<alpha> A) = s.\<alpha> (nfa_initial A)"
    "\<F> (nfa_\<alpha> A) = s.\<alpha> (nfa_accepting A)"
    using nfa_\<alpha>_def
    by auto

  lemma (in nfa_by_lts_defs) nfa_invar_consequences:
    assumes "nfa_invar \<A>"
    shows
      "s.invar (nfa_states \<A>)"
      "l.invar (nfa_labels \<A>)"
      "d.invar (nfa_trans \<A>)"
      "s.invar (nfa_initial \<A>)"
      "s.invar (nfa_accepting \<A>)"
      "NFA (nfa_\<alpha> \<A>)"
      "nfa_prop_is_complete_deterministic (nfa_props \<A>) \<Longrightarrow>
        SemiAutomaton_is_complete_deterministic (nfa_\<alpha> \<A>)"
      "nfa_prop_is_initially_connected (nfa_props \<A>) \<Longrightarrow>
        SemiAutomaton_is_initially_connected (nfa_\<alpha> \<A>)"
    using assms
    unfolding nfa_invar_full_def
    by auto

  locale Thompson_impl = 
    nfa_by_lts_defs s_ops l_ops d_ops +
    set_iteratei s.\<alpha> s.invar s_it +
    lts_succ_label_it d.\<alpha> d.invar d_succ_label_it
    for s_ops :: "('q :: {automaton_states}, 'q_set, _) set_ops_scheme"
    and l_ops :: "('a, 'a_set, _) set_ops_scheme"
    and d_ops :: "('q, 'a, 'd, _) lts_ops_scheme"
    and s_it :: "'q_set \<Rightarrow> ('q, 'd) set_iterator"
    and d_succ_label_it :: "('q, 'a, 'd, 'd) lts_succ_label_it"

  locale Thompson_nat_impl =
    Thompson_impl s_ops l_ops d_ops s_it d_succ_label_it
    for s_ops :: "(nat, 'nat_set, _) set_ops_scheme"
    and l_ops :: "('a, 'a_set, _) set_ops_scheme"
    and d_ops :: "(nat, 'a, 'd, _) lts_ops_scheme"
    and s_it :: "'nat_set \<Rightarrow> (nat, 'd) set_iterator"
    and d_succ_label_it :: "(nat, 'a, 'd, 'd) lts_succ_label_it"

  interpretation rs_Thompson_impl: Thompson_nat_impl
    rs_ops rs_ops rs_lts_dlts_ops rs_iteratei rs_lts_dlts_succ_label_it
    apply unfold_locales
    using rs_lts_dlts_succ_label_it_impl
    unfolding lts_succ_label_it_def rs_lts_dlts_ops_def
    by auto

end
