set terminal pdf enhanced linewidth 2 size 10cm, 7cm
set output "translation_duration.pdf"

data = "TM.txt"
col = 4
load "fit_power.gnuplot"
a1 = exp(a)
b1 = b

data = "TS.txt"
col = 4
load "fit_power.gnuplot"
a2 = exp(a)
b2 = b

data = "TA.txt"
col = 4
load "fit_power.gnuplot"
a3 = exp(a)
b3 = b

set key left top

set xlabel "regular expression length"
set logscale x 10
set xrange [0.75:10000]
set xtics 10
set mxtics 10

set ylabel "translation duration [s]"
set logscale y 10
set yrange [1e-6:1e3]
set ytics 10
set mytics 0
set format y "10^{%L}"

plot \
	"TM.txt" using 1:4 title sprintf("TM: %.3g · x^{%.3g}", a1, b1) linecolor rgb "#FF0000" pointtype 7 pointsize 0.5, a1 * x**b1 notitle linecolor rgb "#FF0000", \
	"TS.txt" using 1:4 title sprintf("TS: %.3g · x^{%.3g}", a2, b2) linecolor rgb "#00FF00" pointtype 7 pointsize 0.5, a2 * x**b2 notitle linecolor rgb "#00FF00", \
	"TA.txt" using 1:4 title sprintf("TA: %.3g · x^{%.3g}", a3, b3) linecolor rgb "#0000FF" pointtype 7 pointsize 0.5, a3 * x**b3 notitle linecolor rgb "#0000FF"
