set terminal pdf enhanced linewidth 2 size 10cm, 7cm
set output "automaton_statistics.pdf"

data = "TM.txt"
col = 5
load "fit_power.gnuplot"
atms = exp(a)
btms = b

data = "TM.txt"
col = 6
load "fit_power.gnuplot"
atmt = exp(a)
btmt = b

data = "TS.txt"
col = 5
load "fit_power.gnuplot"
atss = exp(a)
btss = b

data = "TS.txt"
col = 6
load "fit_power.gnuplot"
atst = exp(a)
btst = b

set key left top

set xlabel "regular expression length"
set logscale x 10
set xrange [0.75:10000]
set xtics 10
set mxtics 10

set ylabel "state count / transition count"
set logscale y 10
set yrange [1e0:1e7]
set ytics 10
set mytics 0
set format y "10^{%L}"

plot \
	"TM.txt" using 1:5 title sprintf("TMS: %.3g · x^{%.3g}", atms, btms) linecolor rgb "#FF0000" pointtype 7 pointsize 0.5, atms * x**btms notitle linecolor rgb "#FF0000", \
	"TS.txt" using 1:5 title sprintf("TSS: %.3g · x^{%.3g}", atss, btss) linecolor rgb "#00FF00" pointtype 7 pointsize 0.5, atss * x**btss notitle linecolor rgb "#00FF00", \
	"TM.txt" using 1:6 title sprintf("TMT: %.3g · x^{%.3g}", atmt, btmt) linecolor rgb "#0000FF" pointtype 7 pointsize 0.5, atmt * x**btmt notitle linecolor rgb "#0000FF", \
	"TS.txt" using 1:6 title sprintf("TST: %.3g · x^{%.3g}", atst, btst) linecolor rgb "#FFFF00" pointtype 7 pointsize 0.5, atst * x**btst notitle linecolor rgb "#FFFF00"
