# curve fitting works much better in log/log scale
f(x) = a + b*x
w(x) = log(x)**2
fit f(x) data using (log($1)):(log(column(col))):(1/w($1)) via a, b

# back to regular scale
g(x) = exp(f(log(x)))

# since g(x) = exp(a) * x**b, exp(a) and b are the parameters resulting from fitting an exponential function to the data
print exp(a), b

# weighted relative error at data point x, y
e(x, y) = w(x) * (abs(y - g(x)) / y)
