theory SM_Ample (* TODO: Rename to SM_POR *)
imports SM_Sticky Derive
begin
  (* TODO: Move *)

  (* TODO: Move to gen_set. Generic algorithm for set_of_list *)
  lemma set_by_fold: "set l = fold insert l {}"
  proof -
    {
      fix s
      have "fold insert l s = s \<union> set l"
        by (induction l arbitrary: s) auto
    } from this[of "{}"] show ?thesis by simp
  qed

  context begin interpretation autoref_syn .
    lemma [autoref_itype]: "set ::\<^sub>i \<langle>I\<rangle>\<^sub>ii_list \<rightarrow>\<^sub>i \<langle>I\<rangle>\<^sub>ii_set" by simp
  end

  lemma gen_set[autoref_rules_raw]:
    fixes R :: "('c\<times>'a)set" and Rs :: "('c\<times>'a) set \<Rightarrow> (_\<times>'a set) set"
    assumes [simplified,param]:
      "GEN_OP em {} (\<langle>R\<rangle>Rs)"
      "GEN_OP ins insert (R \<rightarrow> \<langle>R\<rangle>Rs \<rightarrow> \<langle>R\<rangle>Rs)"
    shows "(\<lambda>li. fold ins li em,set)\<in>\<langle>R\<rangle>list_rel \<rightarrow> \<langle>R\<rangle>Rs"
      unfolding set_by_fold[abs_def]
      by parametricity

  schematic_lemma
    shows "(?c,set [1,2,3::nat])\<in>\<langle>nat_rel\<rangle>dflt_ahs_rel"
      using [[autoref_trace_failed_id]]
      by (autoref (trace, keep_goal))




  lemma [code_unfold]: "{(a,b). (a,b)\<in>X \<and> P a b} = Set.filter (\<lambda>(a,b). P a b) X"
    by auto

  (* TODO: Possibly, we can drop the
    find_min_idx_f - stuff, and formalize our ample-set 
    using the abstract LEAST, which is then implemented
    by collecti_index.
  *)  

  (* Find minimum index and result where function returns non-none value *)  
  primrec find_min_idx_f :: "('a \<rightharpoonup> 'b) \<Rightarrow> 'a list \<rightharpoonup> (nat \<times> 'b)" where
    "find_min_idx_f f [] = None"
  | "find_min_idx_f f (x#xs) = (
      case f x of 
        Some r \<Rightarrow> Some (0,r) 
      | None \<Rightarrow> map_option (map_prod Suc id) (find_min_idx_f f xs)
    )"
  
  lemma find_min_idx_f_None_conv: 
    "find_min_idx_f f l = None \<longleftrightarrow> (\<forall>a\<in>set l. f a = None)"
    apply (induction l)
    apply (auto split: option.splits)
    done

  lemma find_min_idx_f_SomeD:
    "find_min_idx_f f l = Some (i,r) \<Longrightarrow> f (l!i) = Some r \<and> i < length l"
    by (induction l arbitrary: i) (auto split: split_if_asm option.splits)

  lemma find_min_idx_f_SomeD_complete: 
    "find_min_idx_f f l = Some (i,r) 
      \<Longrightarrow> (f (l!i) = Some r \<and> i < length l \<and> (\<forall>j<i. f (l!j) = None))"
    apply (induction l arbitrary: i) 
    apply (auto split: split_if_asm option.splits)
    apply (case_tac j)
    apply auto
    done

  lemma find_min_idx_f_LEAST_eq: "find_min_idx_f f l = (
    if \<exists>i<length l. f (l!i) \<noteq> None then
      let i = LEAST i. i<length l \<and> f (l!i) \<noteq> None in Some (i,the (f (l!i)))
    else
      None
  )"
    apply (cases "find_min_idx_f f l")
    apply (auto simp: find_min_idx_f_None_conv) []
    apply (auto dest!: find_min_idx_f_SomeD_complete) []
    apply (smt2 LeastI_ex less_linear not_less_Least option.distinct(1))
    by (smt2 LeastI_ex less_linear not_less_Least option.distinct(1) option.sel)


  (*  
  primrec fold_index' where
    "fold_index' i f [] s = s"
  | "fold_index' i f (x#xs) s = fold_index' (Suc i) f xs (f i x s)"  

  primrec fold_indexr' where
    "fold_indexr' i f [] s = s"
  | "fold_indexr' i f (x#xs) s = f i x (fold_index' (Suc i) f xs s)"

  abbreviation "fold_index \<equiv> fold_index' 0"

  primrec collect_index' :: "nat \<Rightarrow> (nat \<Rightarrow> 'a \<Rightarrow> 'b set) \<Rightarrow> 'a list \<Rightarrow> (nat\<times>'b) set" where
    "collect_index' i c [] = {}"
  | "collect_index' i c (x#xs) = ({i} \<times> c i x) \<union> (collect_index' (Suc i) c xs)"  

  abbreviation "collect_index \<equiv> collect_index' 0"

  lemma collect_index'_collect: "collect_index' i0 f l 
    = {(i0+i,x) | i x. i<length l \<and> x\<in>f (i0+i) (l!i)}"
    apply (induction l arbitrary: i0)
    apply simp
    apply simp
    apply auto
    apply (case_tac i, auto)
    apply (case_tac i, auto)
    done
    
  lemma collect_index_collect: "collect_index f l 
    = {(i,x) | i x. i<length l \<and> x\<in>f i (l!i)}"  
    by (simp add: collect_index'_collect)
  *)  

  primrec collect_indexr' :: "nat \<Rightarrow> (nat\<times>'b) set \<Rightarrow> (nat \<Rightarrow> 'a \<Rightarrow> 'b set) \<Rightarrow> 'a list \<Rightarrow> (nat\<times>'b) set" where
    "collect_indexr' i a c [] = a"
  | "collect_indexr' i a c (x#xs) = (collect_indexr' (Suc i) (a\<union>({i} \<times> c i x)) c xs)"  

  abbreviation "collect_indexr \<equiv> collect_indexr' 0 {}"

  lemma collect_indexr'_collect: "collect_indexr' i0 a f l 
    = a \<union> {(i0+i,x) | i x. i<length l \<and> x\<in>f (i0+i) (l!i)}"
    apply (induction l arbitrary: i0 a)
    apply simp
    apply simp
    apply auto
    apply (case_tac i, auto)
    apply (case_tac i, auto)
    done

  lemma collect_indexr_collect: "collect_indexr f l 
    = {(i,x) | i x. i<length l \<and> x\<in>f i (l!i)}"  
    by (simp add: collect_indexr'_collect)
  

  primrec collecti_index' :: "nat \<Rightarrow> (nat\<times>'b) set \<Rightarrow> (nat \<Rightarrow> 'a \<Rightarrow> (bool \<times> 'b set)) \<Rightarrow> 'a list \<Rightarrow> (nat\<times>'b) set" where
    "collecti_index' i a c [] = a"
  | "collecti_index' i a c (x#xs) = (case c i x of
      (False,s) \<Rightarrow> collecti_index' (Suc i) (a \<union> {i}\<times>s) c xs
    | (True,s) \<Rightarrow> {i}\<times>s)"

  abbreviation "collecti_index \<equiv> collecti_index' 0 {}"

  lemma collecti_index'_collect: "collecti_index' i0 a0 f l 
    = (
      if \<exists>i<length l. fst (f (i0+i) (l!i)) then
        let i=LEAST i . i<length l \<and> fst (f (i0+i) (l!i)) in {i0+i} \<times> snd (f (i0+i) (l!i))
      else
        a0 \<union> {(i0+i,x) | i x. i<length l \<and> x\<in>snd (f (i0+i) (l!i))})"
  proof (cases "\<exists>i<length l. fst (f (i0+i) (l!i))")
    case False[simp] hence "\<forall>i<length l. \<not>fst (f (i0+i) (l!i))" by blast
    hence "collecti_index' i0 a0 f l = collect_indexr' i0 a0 (snd oo f) l"
    proof (induction l arbitrary: i0 a0)
      case (Cons x l)
      from Cons.prems have "\<not>fst (f i0 x)" by auto
      hence [simp]: "\<And>v. f i0 x \<noteq> (True,v)" by auto
      have "collecti_index' i0 a0 f (x#l) = 
        collecti_index' (Suc i0) (a0 \<union> {i0} \<times> (snd (f i0 x))) f l" 
        by (simp split: prod.splits bool.splits)
      also have "\<dots> = collect_indexr' (Suc i0) ((a0 \<union> {i0} \<times> (snd (f i0 x)))) (snd oo f) l" 
        apply (subst Cons.IH)
        using Cons.prems
        by auto
      finally have 1: "collecti_index' i0 a0 f (x # l) =
        collect_indexr' (Suc i0) (a0 \<union> {i0} \<times> snd (f i0 x)) (snd \<circ>\<circ> f) l" . 
      show ?case by (subst 1) simp
    qed simp
    also note collect_indexr'_collect
    finally show ?thesis by simp
  next
    case True[simp]
    def im \<equiv> "\<lambda>l (i0::nat). LEAST i . i<length l \<and> fst (f (i0+i) (l!i))"
    from LeastI_ex[OF True] have 
      1: "im l i0<length l" "fst (f (i0+im l i0) (l!im l i0))" 
      unfolding im_def by (auto) 
    have 2: "\<forall>i<im l i0. \<not> fst (f (i0+i) (l!i))"
    proof safe
      fix i
      assume A: "i<im l i0" with 1 have "i<length l" by simp
      moreover assume "fst (f (i0+i) (l!i))"
      ultimately have "im l i0 \<le> i"
        unfolding im_def by (auto intro: Least_le)
      with A show False by simp  
    qed  

    from 1 2 have "collecti_index' i0 a0 f l = {i0+im l i0} \<times> snd (f (i0+im l i0) (l!im l i0))"
    proof (induction l arbitrary: i0 a0)
      case (Cons x l)
      show ?case proof (cases "fst (f i0 x)")
        case True
        hence [simp]: "\<And>y. f i0 x \<noteq> (False,y)" by auto
        note [simp] = True        

        from Cons.prems(3) have [simp]: "im (x#l) i0 = 0"
          by auto

        thus ?thesis
          by (auto split: prod.splits bool.splits)
      next
        case False
        hence "im (x#l) i0 = Suc (im l (Suc i0))"
          unfolding im_def
          apply (subst Least_Suc)
          apply (rule conjI) 
          apply (rule Cons.prems)+
          apply simp
          apply simp
          done
        hence ims: "im (x#l) i0 > 0" "im l (Suc i0) = im (x#l) i0 - 1" 
          by simp_all

        from False have 1: "collecti_index' i0 a0 f (x # l) 
          = collecti_index' (Suc i0) (a0 \<union> {i0} \<times> (snd (f i0 x))) f l"
          by (auto)

        show ?thesis
          apply (subst 1)
          apply (subst Cons.IH)
          using Cons.prems(1) ims apply (simp)
          using Cons.prems(2) ims apply simp
          using Cons.prems(3)
          apply (auto simp: ims nth_Cons less_diff_conv split: nat.splits) []
          using ims(1) apply (auto simp: ims(2))
          done
      qed
    qed simp
    thus ?thesis
      by (simp add: im_def)

  qed      

  lemma collecti_index_collect: "collecti_index f l 
    = (
      if \<exists>i<length l. fst (f i (l!i)) then
        let i=LEAST i . i<length l \<and> fst (f i (l!i)) in {i} \<times> snd (f i (l!i))
      else
        {(i,x) | i x. i<length l \<and> x\<in>snd (f i (l!i))})"
    using collecti_index'_collect[of 0 "{}" f l]
    by (simp cong: if_cong split del: split_if)

  primrec collecti_index'_list :: "nat \<Rightarrow> (nat\<times>'b) list \<Rightarrow> (nat \<Rightarrow> 'a \<Rightarrow> (bool \<times> 'b list)) \<Rightarrow> 'a list \<Rightarrow> (nat\<times>'b) list" where
    "collecti_index'_list i a c [] = a"
  | "collecti_index'_list i a c (x#xs) = (case c i x of
      (False,s) \<Rightarrow> collecti_index'_list (Suc i) (a @ map (Pair i) s) c xs
    | (True,s) \<Rightarrow> map (Pair i) s)"

  abbreviation "collecti_index_list \<equiv> collecti_index'_list 0 []"

  lemma collecti_index'_list_invar:
    assumes "\<And>i x b l. c i x = (b,l) \<Longrightarrow> distinct l"
    assumes "fst`set a \<subseteq> {0..<i0}" "distinct a"
    shows "distinct (collecti_index'_list i0 a c l)"
    using assms
    apply (induction l arbitrary: i0 a)
    apply simp
    apply (auto split: prod.splits bool.splits simp: nth_Cons' distinct_map)
    apply rprems
    apply (auto simp: distinct_map)
    done

  lemma image_Pair_eq_prod_sng[simp]: "Pair x ` s = {x}\<times>s" by auto  

  lemma collecti_index'_list_\<alpha>: 
    assumes "\<And>i x b l. ci i x = (b,l) \<Longrightarrow> c i x = (b,set l)"
    shows 
      "set (collecti_index'_list i0 ai ci l) = collecti_index' i0 (set ai) c l"
  proof -
    from assms have A: "\<And>i x b s. c i x = (b,s) \<longleftrightarrow> (\<exists>l. ci i x = (b, l) \<and> s=set l)"
      apply auto apply (case_tac "ci i x") apply auto done

    show ?thesis  
      apply (induction l arbitrary: i0 ai)
      apply simp
      apply simp
      apply (split prod.split, clarsimp)
      apply (split bool.split, clarsimp, intro allI impI conjI)
      apply (force simp add: A) []
  
      apply (simp split: prod.splits bool.splits add: A)
      apply safe
      apply simp_all
      apply blast
      done
  qed

  lemma collecti_index_list_refine:
    "(collecti_index_list,collecti_index)\<in>
       (nat_rel \<rightarrow> Id \<rightarrow> bool_rel \<times>\<^sub>r \<langle>Id\<rangle>list_set_rel) \<rightarrow> \<langle>Id\<rangle>list_rel 
    \<rightarrow> \<langle>nat_rel\<times>\<^sub>rId\<rangle>list_set_rel"
    apply (intro fun_relI)
    apply (simp add: list_set_rel_def)
    apply (rule brI)

    apply (simp add: br_def)
    apply (rule collecti_index'_list_\<alpha>[of _ _ 0 "[]", simplified, symmetric])
    apply (drule_tac x=i and x'=i in fun_relD, simp)
    apply (drule_tac x=x and x'=x in fun_relD, simp)
    apply (auto simp: prod_rel_def) []

    apply (rule collecti_index'_list_invar)
    apply auto
    apply (drule_tac x=i and x'=i in fun_relD, simp)
    apply (drule_tac x=x and x'=x in fun_relD, simp)
    apply (auto simp: prod_rel_def br_def) []
    done

  context system_concurrent begin
    lemma pac_en_blocked':
      assumes A: "s \<in> reachable" "w \<in> words_fin s" "pac p \<inter> en s \<inter> set w = {}"
      assumes IS: "\<And>s' a. \<lbrakk>pac p \<inter> en s = pac p \<inter> en s'; psen p s = psen p s'; a\<in>en s'; a\<notin>pac p \<rbrakk> 
        \<Longrightarrow> pac p \<inter> en (ex a s') = pac p \<inter> en s' \<and> psen p (ex a s') = psen p s'"
      shows "pac p \<inter> set w = {}"
    proof (rule words_fin_blocked[OF _ A(2,3)])
      fix w
      assume "w \<in> words_fin s" "pac p \<inter> set w = {}"
      hence "pac p \<inter> en s = pac p \<inter> en (fold ex w s) \<and> psen p s = psen p (fold ex w s)"
      proof (induction w rule: rev_induct)
        case (snoc a w) 
        from snoc have 
          "pac p \<inter> en s = pac p \<inter> en (fold ex w s)" 
          "psen p s = psen p (fold ex w s)"
          by auto
        with IS[OF this] snoc.prems show ?case by auto
      qed simp
      thus "pac p \<inter> en (fold ex w s) \<subseteq> pac p \<inter> en s" by blast
    qed
  
  end

  definition is_ample_static :: "cmd \<Rightarrow> bool" where
    "is_ample_static c \<equiv> \<forall>(a,c')\<in>cfg'_succ c. 
      read_globals a = {} \<and> write_globals a = {}"


  context visible_prog 
  begin
    lemma None_ga_en_conv[simp]: 
      "None\<in>ga_en gc \<longleftrightarrow> ga_en gc = {None}"
      by (auto simp: ga_en_def stutter_extend_en_def)

      
    lemma genabled_no_global_read_indep_other_pids:
      assumes "read_globals a = {}" 
      assumes "pid'\<noteq>pid"
      shows "(pid,c,a, c')\<in>ga_gen (ga_gex (pid',cac') gc) 
        \<longleftrightarrow> (pid,c,a, c')\<in>ga_gen gc"
      using assms 
      apply (auto 
        simp: ga_gen_def ga_gex_def ex_pres_en
        split: prod.splits)
      done    


  end

  definition pid_pac :: "pid \<Rightarrow> global_action option set" where
    "pid_pac pid \<equiv> Collect (\<lambda>Some (pid',_) \<Rightarrow> pid'=pid | None \<Rightarrow> True)"

  lemma pid_pac_None[simp]: "None \<in> pid_pac pid"
    by (auto simp: pid_pac_def)


  context visible_prog
  begin  

    thm ga_en_def

    definition pid_procs :: "pid_global_config \<Rightarrow> pid set" where
      "pid_procs gc \<equiv> {0..<length (pid_global_config.processes gc)}"
    
  (*  definition pid_pac :: "pid \<Rightarrow> global_action option set" where
      "pid_pac pid \<equiv> {Some (pid,cac) | cac. True}"
  *)
    
    definition pid_psen :: "pid \<Rightarrow> pid_global_config \<Rightarrow> global_action option set"
      where "pid_psen pid gc \<equiv> insert None 
        (Some`{(pid,c,a,c') | c a c'. c = cmd_of_pid gc pid \<and> cfg' c a c'})"

    sublocale jsys: system_concurrent
      ga_en ga_ex "{pid_init_gc prog}"
      pid_procs pid_pac pid_psen
    
      apply unfold_locales
      
      apply (auto simp: pid_procs_def) []

      apply (auto 
        simp: pid_pac_def pid_psen_def ga_en_def ga_gen_def
        simp: stutter_extend_en_def
        split: option.splits
        ) []
      
      apply (auto 
        simp: pid_pac_def pid_psen_def ga_en_def ga_gen_def
        simp: stutter_extend_en_def ga_ex_def ga_gex_def
        split: option.splits split_if_asm prod.splits
        ) []
      done

  end

  locale ample_prog = sticky_prog +
    fixes ga_ample :: "pid_global_config \<Rightarrow> global_action option set"
    assumes ga_ample_approx: 
    "\<lbrakk>gc\<in>ga.reachable; ga_ample gc \<noteq> ga_en gc\<rbrakk> \<Longrightarrow> 
      ga_ample gc \<inter> sticky_ga = {}
    \<and> ga_ample gc \<noteq> {}
    \<and> (\<exists>pid. 
        ga_ample gc = ga_en gc \<inter> pid_pac pid 
      \<and> is_ample_static (cmd_of_pid gc pid))"

  begin

    lemma pid_enabled_ample:
      assumes REACH[simp, intro!]: "gc \<in> ga.reachable"
      shows "jsys.ample_set gc (ga_ample gc)"
    proof (cases "ga_ample gc = ga_en gc")
      case True thus ?thesis by auto
    next
      case False
      from ga_ample_approx[OF REACH False] obtain pid where 
        AMPLE_SS: "ga_ample gc \<subseteq> ga_en gc"
      and NE: "ga_ample gc \<noteq> {}"  
      and NS: "ga_ample gc \<inter> sticky_ga = {}"
      and AMPLE_FMT: "ga_ample gc = pid_pac pid \<inter> ga_en gc"
      and A_STATIC: "is_ample_static (cmd_of_pid gc pid)"
        by blast
      hence aux1: "ga_ample gc = ga_ample gc \<inter> ga_en gc" by blast
  
      from False NE AMPLE_SS have NN: "None \<notin> ga_en gc" by auto

      
      from A_STATIC have LOC: "
        \<And>c a c'. Some (pid, c,a,c') \<in> pid_psen pid gc 
          \<Longrightarrow> read_globals a = {} \<and> write_globals a = {}"
        unfolding is_ample_static_def pid_psen_def cfg'_succ_iff_cfg'[symmetric]
        by auto
      from A_STATIC have LOC': "
        \<And>c a c'. Some (pid, c,a,c') \<in> pid_pac pid \<inter> ga_en gc 
          \<Longrightarrow> read_globals a = {} \<and> write_globals a = {}"
        unfolding is_ample_static_def pid_pac_def ga_en_def 
        by (auto 
          split: prod.splits 
          simp: cfg'_succ_iff_cfg'[symmetric] ga_gen_def)

      from reachable_alt[symmetric] REACH 
      have REACH': "gc \<in> jsys.reachable" by simp  

      have INV': 
        "\<And>c a c'. Some (pid,c,a,c')\<in>ga_en gc 
        \<Longrightarrow> Some (pid,c,a,c') \<notin> jsys.visible"
        using NS sticky_ga_approx_visible
        apply (clarsimp simp: AMPLE_FMT pid_pac_def split: option.splits) 
        apply blast
        done

      { 
        fix ga gc'
        assume en_eq: "pid_pac pid \<inter> ga_en gc = pid_pac pid \<inter> ga_en gc'"
        assume psen_eq: "pid_psen pid gc = pid_psen pid gc'"
        assume ga_en: "ga \<in> ga_en gc'" 
        assume ga_not_pid: "ga \<notin> pid_pac pid"
        
        from en_eq NN have [simp]: "None \<notin> ga_en gc'"
          using pid_pac_None
          by blast

        with ga_en have "ga\<noteq>None" by metis
        then obtain pid' c a c' where [simp]: "ga = Some (pid',c,a,c')"
          by (cases ga) auto
  
        from ga_not_pid have [simp]: "pid'\<noteq>pid" by (auto simp: pid_pac_def)
        
        have [simp]: "\<And>cac. Some (pid,cac) \<in> ga_en gc' 
          \<longleftrightarrow> Some (pid,cac) \<in> ga_en gc"
          using en_eq unfolding pid_pac_def
            by (auto split: option.splits)
        hence pid_gen_gc'_gc: "\<And>cac. (pid,cac) \<in> ga_gen gc' 
          \<longleftrightarrow> (pid,cac) \<in> ga_gen gc"
          unfolding ga_en_def
          by simp
  
        have "cmd_of_pid (ga_gex (pid', c, a, c') gc') pid 
          = cmd_of_pid gc' pid"
          by (auto simp: ga_gex_def split: prod.splits)
        hence G1: "pid_psen pid (ga_ex ga gc') = pid_psen pid gc'"
          by (auto simp: pid_psen_def ga_gex_def ga_ex_def
            split: prod.splits)
  
        have pid_ge_ex_invar: "\<And>cac. 
          (pid,cac)\<in>ga_gen (ga_ex (Some (pid', c, a, c')) gc') \<longleftrightarrow>
          (pid,cac)\<in>ga_gen gc'"
          apply (clarsimp simp: ga_en_def ga_ex_def) 
        proof
          fix c'' a'' c'''
          assume A: "(pid, c'', a'', c''') \<in> ga_gen (ga_gex (pid', c, a, c') gc')"
          hence "Some (pid, c'', a'', c''') \<in> pid_psen pid (ga_gex (pid', c, a, c') gc')"
            by (auto simp: pid_psen_def ga_gen_def)
          hence "Some (pid, c'', a'', c''') \<in> pid_psen pid gc" using G1 psen_eq
            by (simp add: ga_ex_def)
          from LOC[OF this]
            have "read_globals a'' = {}" by simp
          from genabled_no_global_read_indep_other_pids[OF this `pid'\<noteq>pid`] A
          show "((pid, c'', a'', c''') \<in> ga_gen gc')" ..
        next
          fix c'' a'' c'''
          assume A: "((pid, c'', a'', c''') \<in> ga_gen gc')"
          hence "Some (pid, c'', a'', c''') \<in> pid_psen pid gc'"
            by (auto simp: pid_psen_def ga_gen_def)
          hence "Some (pid, c'', a'', c''') \<in> pid_psen pid gc" using psen_eq
            by (simp)
          from LOC[OF this] have "read_globals a'' = {}" by simp
          from genabled_no_global_read_indep_other_pids[OF this `pid'\<noteq>pid`] A
          show "(pid, c'', a'', c''') \<in> ga_gen (ga_gex (pid', c, a, c') gc')" ..
        qed
  
        have [simp]: 
          "ga_gen (ga_ex (Some (pid', c, a, c')) gc') \<noteq> {}"
          "ga_gen gc' \<noteq> {}"
        proof -
          from NN NE obtain cac2 where "Some (pid,cac2) \<in> ga_en gc"
            unfolding AMPLE_FMT
            apply (clarsimp simp: ex_in_conv[symmetric])
            using NN
            apply (auto simp: pid_pac_def split: option.splits)
            done
          hence "(pid,cac2) \<in> ga_gen gc" by (auto simp: ga_en_def)
          hence 1: "(pid,cac2) \<in> ga_gen gc'"
            by (simp add: pid_gen_gc'_gc)
          thus "ga_gen gc' \<noteq> {}" by blast
          from 1 have "(pid,cac2) \<in> ga_gen (ga_ex (Some (pid', c, a, c')) gc')"
            by (simp add: pid_ge_ex_invar pid_gen_gc'_gc)
          thus "ga_gen (ga_ex (Some (pid', c, a, c')) gc') \<noteq> {}" by blast  
        qed
        
        have G2: "pid_pac pid \<inter> ga_en (ga_ex ga gc') =
             pid_pac pid \<inter> ga_en gc'"
          apply (auto simp: pid_pac_def split: option.splits)
          apply (auto simp add: ga_en_def stutter_extend_en_def
              pid_ge_ex_invar
              split: split_if_asm) [2]
          done
        note G1 G2
      } note aux=this

      show ?thesis
        apply (subst AMPLE_FMT)
        apply (rule jsys.restrict_ample_set)
        apply (simp add: reachable_alt)
        using NE AMPLE_FMT apply blast
        using NS AMPLE_FMT apply blast
        apply safe []
        apply (rename_tac ga1 ga2)
        apply (case_tac "(ga1,ga2)" rule: ind.cases) 
        using NN apply (simp_all) [4]
        apply (simp_all add: pid_pac_def LOC' INV') []
        
        apply (rule jsys.pac_en_blocked'[OF REACH'])
        apply assumption+
        apply (rule conjI)
        apply (rule aux, assumption+)
        apply (rule aux, assumption+)
        done
    qed
  
    sublocale jsys!: ample_abstract
      ga_en ga_ex "{pid_init_gc prog}" 
      pid_interp_gc ind "jsys.scut\<inverse>\<inverse>" ga_ample
      apply unfold_locales
      apply (rule pid_enabled_ample)
      apply (simp add: reachable_alt)
      done

    thm jsys.reduction_language_subset  
    thm jsys.reduction_language_stuttering  

    definition "ample_step \<equiv> pred_of_enex (ga_ample, ga_ex)"
    definition "ample_succ \<equiv> succ_of_enex (ga_ample, ga_ex)"

    sublocale ample!: lsystem "op = (pid_init_gc prog)" ample_step pid_interp_gc .

    lemma jsys_R_lang_eq: "jsys.R.language = Collect ample.accept"
      apply (subst system_complete_language_eq_lsystem_accept)
      apply (auto simp: ample_step_def sngp_sym_conv)
      done      

    lemma ample_accept_subset: "ample.accept w \<Longrightarrow> lv.accept w"
    proof -
      assume "ample.accept w"
      hence "w\<in>jsys.R.language" by (simp add: jsys_R_lang_eq)
      hence "w\<in>jsys.language" using jsys.reduction_language_subset ..
      with jsys_lang_eq show "lv.accept w" by auto
    qed

    lemma ample_accept_stuttering:
      assumes A: "lv.accept w" 
      obtains w' where "w\<approx>w'" "ample.accept w'"
    proof -
      from A have "w\<in>jsys.language" by (simp add: jsys_lang_eq)
      then obtain w' where "w\<approx>w'" "w'\<in>jsys.R.language"
        by (rule jsys.reduction_language_stuttering)
      hence "ample.accept w'" by (simp add: jsys_R_lang_eq)
      thus ?thesis using `w\<approx>w'` by (blast intro: that)
    qed
  end

  context sticky_prog
  begin
    definition ga_gample :: "pid_global_config \<Rightarrow> global_action set" where
      "ga_gample gc \<equiv> let
        lcs = pid_global_config.processes gc;
        gs = pid_global_config.state gc;
        as = find_min_idx_f (\<lambda>lc.
          let
            c = local_config.command lc;
            ls = local_config.state lc
          in
            if is_ample_static c then
              let 
                as = cfg'_succ c;
                as = {(a,c')\<in>as. la_en' (ls,gs) a}
              in
                if as={} \<or> (\<exists>(a,c')\<in>as. (c,c')\<in>sticky_E) then 
                  None 
                else 
                  Some (c,as)
            else
              None
        ) lcs
      in
        case as of
          Some (pid,c,as) \<Rightarrow> (\<lambda>(a,c'). (pid,c,a,c'))`as
        | None \<Rightarrow> ga_gen gc"
    
    definition "ga_ample \<equiv> stutter_extend_en ga_gample"

    definition (in visible_prog) ga_gamplei 
      :: "_ \<Rightarrow> _ \<Rightarrow> pid_global_config \<Rightarrow> global_action set" where
      "ga_gamplei mem sticky_Ei gc \<equiv> let
        lcs = pid_global_config.processes gc;
        gs = pid_global_config.state gc;
        as = find_min_idx_f (\<lambda>lc.
          let
            c = local_config.command lc;
            ls = local_config.state lc
          in
            if is_ample_static c then
              let 
                as = cfg'_succ c;
                as = {(a,c')\<in>as. la_en' (ls,gs) a}
              in
                if as={} \<or> (\<exists>(a,c')\<in>as. mem (c,c') sticky_Ei) then 
                  None 
                else 
                  Some (c,as)
            else
              None
        ) lcs
      in
        case as of
          Some (pid,c,as) \<Rightarrow> (\<lambda>(a,c'). (pid,c,a,c'))`as
        | None \<Rightarrow> ga_gen gc"

    thm ga_gamplei_def
    term find_min_idx_f

(*
  lemma [param]: "(find_min_idx_f,find_min_idx_f) "('a \<Rightarrow> 'b option) \<Rightarrow> 'a list \<Rightarrow> (nat \<times> 'b) option""
*)

    lemma ga_gamplei_impl:
      assumes [param]: "(sticky_Ei,sticky_E)\<in>R"
      assumes [param]: "(mem,op \<in>) \<in> Id \<rightarrow> R \<rightarrow> bool_rel"
      shows "(ga_gamplei mem sticky_Ei gc,ga_gample gc)\<in>Id"
    proof -
      have A: "\<And>x. mem x sticky_Ei \<longleftrightarrow> x \<in> sticky_E"
        apply (rule IdD)
        apply parametricity
        by (rule IdI)
      show ?thesis
        unfolding ga_gamplei_def ga_gample_def
        apply (subst A)
        by simp
    qed    




    lemma ga_gample_subset: "ga_gample gc \<subseteq> ga_gen gc"
      unfolding ga_gample_def ga_gen_def
      by (auto 
        simp: cfg'_succ_iff_cfg'
        split: option.splits split_if_asm 
        dest!: find_min_idx_f_SomeD)

    lemma ga_gample_empty_iff: "ga_gample gc = {} \<longleftrightarrow> ga_gen gc = {}"  
      unfolding ga_gample_def ga_gen_def
      by (fastforce 
        simp: cfg'_succ_iff_cfg'
        split: option.splits split_if_asm 
        dest!: find_min_idx_f_SomeD)

    lemma ga_ample_None_iff: "None \<in> ga_ample gc \<longleftrightarrow> None \<in> ga_en gc"
      by (auto 
        simp: ga_ample_def ga_en_def stutter_extend_en_def ga_gample_empty_iff)
      
    lemma ga_ample_neq_en_eq:
      assumes "ga_ample gc \<noteq> ga_en gc"
      shows "ga_ample gc = Some`ga_gample gc \<and> ga_en gc = Some`ga_gen gc"
      using assms ga_gample_subset
      unfolding ga_ample_def ga_en_def stutter_extend_en_def
      by (auto split: split_if_asm simp: ga_gample_empty_iff)

    lemma pid_pac_alt: "pid_pac pid = insert None (Some`{(pid',cac). pid'=pid})" 
      apply (auto simp: pid_pac_def split: option.splits)
      apply (case_tac x)
      apply auto
      done

    sublocale ample_prog prog is_vis_var sticky_E ga_ample
    proof -
      have aux: "\<And>A B pid. 
        Some`A = Some`B \<inter> pid_pac pid \<longleftrightarrow> A = {(pid',cac)\<in>B. pid'=pid}"
        apply (simp add: pid_pac_alt)
        apply auto
        done

      show "ample_prog prog is_vis_var sticky_E ga_ample"
        apply unfold_locales
        apply (frule ga_ample_neq_en_eq, clarsimp)
        apply (intro conjI)
        apply (auto 
          simp: ga_gample_def sticky_ga_def
          dest!: find_min_idx_f_SomeD
          split: option.splits split_if_asm) []
        apply (fastforce 
          simp: ga_gample_def sticky_ga_def
          dest!: find_min_idx_f_SomeD
          split: option.splits split_if_asm) []
        unfolding aux (* TODO: Clean up! *)
        apply (simp add: inj_image_eq_iff pid_pac_def)
        apply (thin_tac "ga_ample ?a = ?b")
        apply (simp add: ga_gample_def split: option.splits prod.splits)
        apply (thin_tac "?a \<noteq> ga_gen ?b")
        apply (drule find_min_idx_f_SomeD)
        apply clarsimp
        apply (rename_tac gc pid c as)
        apply (rule_tac x=pid in exI)
        apply (auto 
          split: split_if_asm prod.splits 
          simp: ga_gen_def cfg'_succ_iff_cfg')
        done
    qed    
        
    thm ample_accept_subset
    thm ample_accept_stuttering
  end


  lemma id_aux: 
    "(program.processes, program.processes) \<in> Id \<rightarrow> \<langle>Id\<rangle>list_rel"
    "(body, body) \<in> Id \<rightarrow> Id"
    by auto

  schematic_lemma 
    assumes [autoref_rules]: "(prog,prog)\<in>Id"
    shows "(?c,cfg_V0 prog) \<in> \<langle>Id\<rangle>list_set_rel"
    unfolding cfg_V0_def
    using [[autoref_trace_failed_id]]
    apply (parametricity add: gen_set)
    apply autoref_side
    apply autoref_side
    apply (parametricity add: id_aux)+
    by (rule IdI)


  definition "fs_en' lc gs \<equiv> {(c,a,c'). 
    c=local_config.command lc 
  \<and> (a,c')\<in>cfg'_succ c
  \<and> la_en' (local_config.state lc,gs) a}"

  lemma [code]: "fs_en' lc gs = (let c = local_config.command lc in 
    {c} \<times> {(a,c')\<in>cfg'_succ c. la_en' (local_config.state lc,gs) a}
  )"
    unfolding fs_en'_def by (auto)

  export_code fs_en'

  (*
  definition "ga_gen_exec gc \<equiv> collect_index 
      (\<lambda>_ lc. fs_en' lc (pid_global_config.state gc)) 
      (pid_global_config.processes gc)"

  context visible_prog begin
    lemma "ga_gen gc = ga_gen_exec gc"
      apply (simp add: collect_index_collect fs_en'_def cfg'_succ_iff_cfg' 
        ga_gen_def ga_gen_exec_def)
      apply auto
      done
  end
  *)
    

  definition "ga_gamplei2 mem sticky_Ei (gc::pid_global_config) = (
    let 
      lcs = pid_global_config.processes gc;
      gs = pid_global_config.state gc
    in
      collecti_index (\<lambda>_ lc. let
          c = local_config.command lc;
          ls = local_config.state lc;
          s={(a,c')\<in>cfg'_succ c. la_en' (ls,gs) a};
          ample = s\<noteq>{} \<and> is_ample_static c \<and> (\<forall>(a,c')\<in>s. \<not>mem (c,c') sticky_Ei)
        in
          (ample,{c}\<times>s)
      ) lcs
  )"

  export_code ga_gamplei2 in SML module_name Test


  context sticky_prog begin

    lemma ga_gamplei2_impl_aux: 
      "ga_gamplei mem sticky_Ei gc = ga_gamplei2 mem sticky_Ei gc"
    proof -
      def lcs \<equiv> "pid_global_config.processes gc"
      def gs \<equiv> "pid_global_config.state gc"

      def f1 \<equiv> "(\<lambda>lc::local_config.
          let
            c = local_config.command lc;
            ls = local_config.state lc
          in
            if is_ample_static c then
              let 
                as = cfg'_succ c;
                as = {(a,c')\<in>as. la_en' (ls,gs) a}
              in
                if as={} \<or> (\<exists>(a,c')\<in>as. mem (c,c') sticky_Ei) then 
                  None 
                else 
                  Some (c,as)
            else
              None
        )"

      def f2' \<equiv> "(\<lambda>(lc::local_config). let
            c = local_config.command lc;
            ls = local_config.state lc;
            s={(a,c')\<in>cfg'_succ c. la_en' (ls,gs) a};
            ample = s\<noteq>{} \<and> is_ample_static c \<and> (\<forall>(a,c')\<in>s. \<not>mem (c,c') sticky_Ei)
          in
            (ample,{c}\<times>s)
        )"  
      def f2 \<equiv> "\<lambda>(_::nat) lc. f2' lc"  

      note aux_defs = lcs_def gs_def f1_def f2'_def f2_def
      note aux_folds = aux_defs[symmetric]


      have ga_gamplei_alt: "ga_gamplei mem sticky_Ei gc = (
        let
          as = find_min_idx_f f1 lcs
        in case as of
          None \<Rightarrow> Pid_Gen_Scheduler_linit.ga_gen cfg' la_en' gc
        | Some (pid, c, as) \<Rightarrow> (\<lambda>(a, c'). (pid, c, a, c')) ` as
        )"
        unfolding ga_gamplei_def aux_defs by simp

      have ga_gamplei2_alt: 
        "ga_gamplei2 mem sticky_Ei gc = collecti_index f2 lcs"  
        unfolding ga_gamplei2_def aux_defs by simp

      {
        fix pid lc
        have "f1 lc = None \<longleftrightarrow> fst (f2 pid lc) = False"
          unfolding f1_def f2_def f2'_def
          by (auto split: split_if_asm)
      } note f12_none_eq = this

      {
        fix pid lc c as
        have "f1 lc = Some (c,as) \<longleftrightarrow> f2 pid lc = (True,{c}\<times>as)"
          unfolding f1_def f2_def f2'_def
          by (auto split: split_if_asm simp: times_eq_iff)
      } note f12_some_eq = this

      {
        fix pid lc
        have "f1 lc \<noteq> None \<longleftrightarrow> fst (f2 pid lc)"
          unfolding f1_def f2_def f2'_def
          by (auto split: split_if_asm simp: times_eq_iff)
      } note f12_ne_none_iff = this

      have L_eq: "(LEAST i. i<length lcs \<and> f1 (lcs!i) \<noteq> None)
        = (LEAST i. i<length lcs \<and> fst (f2 i (lcs!i)))"
        apply (subst f12_ne_none_iff)
        apply (simp add: f2_def)
        done

      show ?thesis
      proof (cases "\<exists>i<length lcs. f1 (lcs!i) \<noteq> None")
        case True
        def i \<equiv> "LEAST i. i<length lcs \<and> f1 (lcs!i) \<noteq> None"
        from True find_min_idx_f_LEAST_eq[of f1 lcs] 
        have [simp]: "find_min_idx_f f1 lcs = Some (i,the (f1 (lcs!i)))"
          by (simp add: i_def)
        from LeastI_ex[OF True, folded i_def] 
        have "i < length lcs" "f1 (lcs ! i) \<noteq> None" by auto
        then obtain c as where [simp]: "f1 (lcs ! i) = Some (c,as)"
          by (cases "f1 (lcs ! i)") auto
        with f12_some_eq have [simp]: "f2 i (lcs!i) = (True,{c}\<times>as)" by simp
        
        from True have ex2: "\<exists>i<length lcs. fst (f2 i (lcs!i))"
          apply (elim exE)
          apply (subst (asm) f12_ne_none_iff)
          by auto
        have i_alt: "i = (LEAST i. i<length lcs \<and> fst (f2 i (lcs!i)))"   
          unfolding i_def L_eq ..
          
        thm ga_gamplei_def    


        show ?thesis  
          unfolding ga_gamplei_alt ga_gamplei2_alt
          apply simp
          apply (simp add: collecti_index_collect ex2 i_alt[symmetric])
          apply auto
          done
      next
        case False

        from False have ex2: "\<not>(\<exists>i<length lcs. fst (f2 i (lcs!i)))"
          apply safe
          apply (subst (asm) f12_ne_none_iff)
          by auto

        show ?thesis
          unfolding ga_gamplei_alt find_min_idx_f_LEAST_eq 
          apply (simp only: False)
          apply simp
          unfolding ga_gamplei2_alt collecti_index_collect
          apply (simp only: ex2)
          apply simp

          unfolding ga_gen_def aux_defs
          apply (auto simp: cfg'_succ_iff_cfg')
          done
      qed
    qed
    
    lemma ga_gamplei2_impl:
      assumes "(sticky_Ei,sticky_E)\<in>R"
      assumes "(mem,op \<in>) \<in> Id \<rightarrow> R \<rightarrow> bool_rel"
      shows "ga_gamplei2 mem sticky_Ei gc = ga_gample gc"
      apply (subst ga_gamplei2_impl_aux[symmetric])
      using ga_gamplei_impl[OF assms]
      by simp 
      
  end

  term ga_gamplei2

  lemma ga_gamplei2_refine:
    shows "(ga_gamplei2, ga_gamplei2)\<in>(Id\<times>\<^sub>rId\<rightarrow>R\<rightarrow>bool_rel) \<rightarrow> R \<rightarrow> Id"
  proof (intro fun_relI, rule, rule ext)
    fix gc and m :: "cmd\<times>cmd\<Rightarrow>_" and mi s si
    assume "(si,s)\<in>R" and "(mi,m)\<in>Id\<times>\<^sub>rId\<rightarrow>R\<rightarrow>bool_rel"
    hence 1: "\<And>x. mi x si \<longleftrightarrow> m x s" by (auto dest: fun_relD)
    show "ga_gamplei2 mi si gc = ga_gamplei2 m s gc"
      unfolding ga_gamplei2_def
      apply (subst 1)
      ..
  qed
    
  lemma cfg_V0_autoref[autoref_rules]:
    assumes "GEN_OP em {} (\<langle>Id\<rangle>Rs)"
    assumes "GEN_OP ins Set.insert (Id\<rightarrow>\<langle>Id\<rangle>Rs\<rightarrow>\<langle>Id\<rangle>Rs)"
    shows "(\<lambda>prog. fold (ins o proc_decl.body) (program.processes prog) em, cfg_V0) 
      \<in> Id \<rightarrow> \<langle>Id\<rangle>Rs"
  proof (rule,simp)
    fix prog
    note [param] = assms[simplified]

    have "cfg_V0 prog = fold (insert o proc_decl.body) (program.processes prog) {}"
      unfolding cfg_V0_def
      by (simp add: set_by_fold fold_map)
    also have "(fold (ins o proc_decl.body) (program.processes prog) em,\<dots>)\<in>\<langle>Id\<rangle>Rs"
      apply parametricity
      apply (rule introR[where R="Id\<rightarrow>Id"]) by auto
    finally show "(fold (ins o proc_decl.body) (program.processes prog) em, cfg_V0 prog) 
      \<in> \<langle>Id\<rangle>Rs" .
  qed  

primrec cfg_succ_list :: "cmd \<Rightarrow> ((action+brk_ctd) \<times> cmd) list" where
  "cfg_succ_list (Assign x e) = [((Inl (AAssign x e)), Skip)]"
| "cfg_succ_list (Assign_local x e) = [((Inl (AAssign_local x e)), Skip)]"
| "cfg_succ_list (Assign_global x e) = [((Inl (AAssign_global x e)), Skip)]"
| "cfg_succ_list (Test e) = [((Inl (ATest e)), Skip)]"
| "cfg_succ_list (Seq c1 c2) =
    (if c1=Skip then [((Inl ASkip), c2)] else [])
  @ map (\<lambda>(e,c1'). (e,Seq c1' c2)) (cfg_succ_list c1)"
| "cfg_succ_list (Or c1 c2) = remdups [(Inl ASkip, c1), (Inl ASkip, c2)]"
| "cfg_succ_list (Loop c) =  [((Inl ASkip), (Iterate c c))]"
| "cfg_succ_list (Break) = [(Inr AIBreak, Invalid)]"
| "cfg_succ_list (Continue) = [(Inr AIContinue, Invalid)]"
| cfg_succ_list_iterate: 
  "cfg_succ_list (Iterate c cb) =
  (if c=Skip then [(Inl ASkip, Iterate cb cb)] else [])
  @ remdups (map (
    \<lambda> (Inl e,c') \<Rightarrow> (Inl e, Iterate c' cb)
    | (Inr AIBreak,_) \<Rightarrow> (Inl ASkip,Skip)
    | (Inr AIContinue,_) \<Rightarrow> (Inl ASkip, Iterate cb cb)
  ) (cfg_succ_list c))"
| "cfg_succ_list Skip = []"
| "cfg_succ_list Invalid = []"

lemma cfg_succ_list_invar: "distinct (cfg_succ_list c)"
  apply (induction c)
  apply (auto simp: distinct_map)
  apply (rule inj_onI)
  apply auto []
  done  

lemma cfg_succ_list_\<alpha>: "cfg_succ c = set (cfg_succ_list c)"
  apply (induction c)
  apply (simp_all only: cfg_succ.simps cfg_succ_list.simps)
  apply (simp_all)
  apply auto []
  done

term List.map_filter

definition "cfg'_succ_list c 
  \<equiv> (List.map_filter (\<lambda>(Inl a,c) \<Rightarrow> Some (a,c) | _ \<Rightarrow> None) (cfg_succ_list c))"

lemma cfg'_succ_list_invar: "distinct (cfg'_succ_list c)"
  unfolding cfg'_succ_list_def
  apply (simp add: cfg_succ_list_invar map_filter_def distinct_map)
  apply (rule inj_onI)
  apply (auto split: sum.splits)
  done

lemma cfg'_succ_list_\<alpha>: "set (cfg'_succ_list c) = cfg'_succ c"
  unfolding cfg'_succ_def cfg'_succ_list_def
  by (force 
    simp: map_filter_def cfg_succ_list_\<alpha> isl_def
    split: sum.splits)


definition "cfgE_succ_list c 
  \<equiv> remdups (List.map_filter (\<lambda>(Inl a,c) \<Rightarrow> Some c | _ \<Rightarrow> None) (cfg_succ_list c))"

lemma cfgE_succ_list_invar: "distinct (cfgE_succ_list c)"
  unfolding cfgE_succ_list_def
  apply (simp add: cfg_succ_list_invar map_filter_def distinct_map)
  done

lemma cfgE_succ_list_\<alpha>: "set (cfgE_succ_list c) = snd`cfg'_succ c"
  unfolding cfg'_succ_def cfgE_succ_list_def
  by (force 
    simp: map_filter_def cfg_succ_list_\<alpha> isl_def
    split: sum.splits)

lemma [autoref_rules]: "(cfgE_succ_list,cfg_E) \<in> \<langle>Id\<rangle>slg_rel"
  unfolding cfg_E_as_succ cfg_E_succ_def[abs_def]
  unfolding slg_rel_def list_set_rel_def
  apply (simp add: br_def E_of_succ_def)
  apply rule
    apply rule
    apply (simp add: cfgE_succ_list_invar cfgE_succ_list_\<alpha>)

    apply auto []
  done

print_derives
derive hashable un_op
derive hashable bin_op
derive hashable exp
derive hashable cmd 

  thm ga_gamplei2_def

  term cfg'_succ_list

  definition "ga_gamplei_list mem sticky_Ei (gc::pid_global_config) = (
    let 
      lcs = pid_global_config.processes gc;
      gs = pid_global_config.state gc
    in
      collecti_index_list (\<lambda>_ lc. let
          c = local_config.command lc;
          ls = local_config.state lc;
          s = filter (la_en' (ls,gs) o fst) (cfg'_succ_list c);
          ample = s\<noteq>[] \<and> is_ample_static c \<and> (\<forall>(a,c')\<in>set s. \<not>mem (c,c') sticky_Ei)
        in
          (ample,map (Pair c) s)
      ) lcs
  )"

  thm collecti_index_list_refine

  lemma ga_gamplei_list_impl:
    "(ga_gamplei_list mem sticky_Ei gc, ga_gamplei2 mem sticky_Ei gc) 
    \<in> \<langle>nat_rel \<times>\<^sub>r Id\<rangle>list_set_rel"
    unfolding ga_gamplei_list_def ga_gamplei2_def
    apply (parametricity)
    apply (rule IdI)
    apply (rule IdI)
    apply (intro fun_relI)
    apply (rule collecti_index_list_refine[param_fo])
    apply (intro fun_relI)
    apply (simp add: list_set_rel_def br_def distinct_map 
      cfg'_succ_list_invar cfg'_succ_list_\<alpha>)
    apply (auto simp: cfg'_succ_list_\<alpha> filter_empty_conv)
    apply force
    done

  export_code ga_gamplei_list in SML module_name Test

  thm ga_gamplei2_refine

  lemma ga_gamplei_list_refine:
    "(ga_gamplei_list, ga_gamplei2) 
    \<in> (Id \<times>\<^sub>r Id \<rightarrow> R \<rightarrow> bool_rel) \<rightarrow> R \<rightarrow> Id \<rightarrow> \<langle>nat_rel \<times>\<^sub>r Id\<rangle>list_set_rel"
    apply (intro fun_relI)
    apply (drule (1) ga_gamplei2_refine[param_fo])
    apply (drule IdD)+
    apply (drule sym, drule sym, simp)
    apply (rule ga_gamplei_list_impl[simplified])
    done


  schematic_lemma get_sticky_impl_aux:
    fixes vis_edges :: "cmd rel"
    assumes [autoref_rules]: 
      "(vii,vis_edges)\<in>\<langle>Id\<times>\<^sub>rId\<rangle>fun_set_rel"
      "(prog,prog)\<in>Id"
    shows "(RETURN (?c::?'c),find_fas_init cfg_E (cfg_V0 prog) vis_edges)\<in>?R"
    by autoref_monadic

  concrete_definition get_sticky_impl uses get_sticky_impl_aux
  export_code get_sticky_impl in SML

  definition "cr_ample vis_edges prog \<equiv> do {
    sticky \<leftarrow> find_fas_init cfg_E (cfg_V0 prog) vis_edges;
    RETURN (ga_gamplei2 op \<in> sticky)
  }"

  schematic_lemma cr_ample_impl_aux:
    assumes [autoref_rules]: 
      "(vii,vis_edges)\<in>\<langle>Id\<times>\<^sub>rId\<rangle>fun_set_rel"
      "(prog,prog)\<in>Id"
    notes [autoref_rules] = ga_gamplei_list_refine  
    shows "(RETURN (?c::?'c),cr_ample vis_edges prog)\<in>?R"
    unfolding cr_ample_def
    using [[autoref_trace_failed_id, autoref_trace_intf_unif]]
    by (autoref_monadic (plain, trace))
  concrete_definition cr_ample_impl uses cr_ample_impl_aux
  export_code cr_ample_impl in SML module_name Test

  thm cr_ample_impl.refine



  definition "is_vis_edge is_vis_var \<equiv> \<lambda>(c,c'). 
    \<exists>(a,cc')\<in>set (cfg'_succ_list c). c'=cc' \<and> (\<exists>v\<in>write_globals a. is_vis_var v)"
      
  export_code is_vis_edge in SML   

  definition "ga_gex_impl ga gc \<equiv> 
    let (pid, c, a, c') = ga; fs = fs_of_pid gc pid;
        (ls', gs') = la_ex' fs a;
        gc' =
          \<lparr>pid_global_config.processes =
             pid_global_config.processes gc
             [pid := \<lparr>command = c', state = ls'\<rparr>],
             state = gs'\<rparr>
    in gc'"

  (* TODO: Move *)  
  lemma in_dom_map_code[code_unfold]: 
    "x\<in>dom m = (case m x of None \<Rightarrow> False | _ \<Rightarrow> True)"
    by (auto split: option.splits)

  export_code ga_gex_impl in SML module_name Test

  thm stutter_extend_en_def

  schematic_lemma stutter_extend_en_list_aux: "(?c, stutter_extend_en) 
    \<in> (R \<rightarrow> \<langle>S\<rangle>list_set_rel) \<rightarrow> R \<rightarrow> \<langle>\<langle>S\<rangle>option_rel\<rangle>list_set_rel"
    unfolding stutter_extend_en_def[abs_def]
    apply (autoref)
    done
  concrete_definition stutter_extend_en_list uses stutter_extend_en_list_aux


  lemma succ_of_enex_impl_aux: 
    "{s'. \<exists>a\<in>en s. s'=ex a s} = (\<lambda>a. ex a s)`en s" by auto

  schematic_lemma succ_of_enex_list_aux: "(?c, succ_of_enex) \<in> 
    (Id \<rightarrow> \<langle>Id\<rangle>list_set_rel) \<times>\<^sub>r (Id \<rightarrow> Id \<rightarrow> Id) \<rightarrow> Id \<rightarrow> \<langle>Id\<rangle>list_set_rel"
    unfolding succ_of_enex_def[abs_def]
    unfolding succ_of_enex_impl_aux
    by (autoref (trace, keep_goal))
  concrete_definition succ_of_enex_list uses succ_of_enex_list_aux

Argh: We have to compare states, to make distinct list-set of them!
  This is not possible for states stored as functions!
  Where to do refinement for states! If possible, after ample-stuff!


  definition "ample_succ_impl prog is_vis_var \<equiv> let
    gample = cr_ample_impl (is_vis_edge is_vis_var) prog
  in
    succ_of_enex_list (stutter_extend_en_list gample, stutter_extend_ex ga_gex_impl)"

  export_code succ_of_enex_list in SML  
  export_code stutter_extend_en_list cr_ample_impl ga_gex_impl in SML module_name Test  

  export_code ample_succ_impl in SML module_name Test 

  term visible_prog.pid_interp_gc  

  interpretation ample_impl!: lsystem 
    "op = (pid_init_gc prog)" 
    "pred_of_succ (ample_succ_impl prog is_vis_var)"
    "visible_prog.pid_interp_gc is_vis_var"
    for prog is_vis_var
    .
    
  term ample_impl.accept

  context sticky_prog begin
    lemma ample_accept_subset_refpoint:
      "ample.accept w \<Longrightarrow> \<exists>w'. w = interp_gs \<circ> w' \<and> accept prog w'"
      using ample_accept_subset[unfolded lv_accept_conv] by blast

    lemma ample_accept_stuttering_refpoint:
      assumes A: "accept prog w" 
      obtains w' where "interp_gs \<circ> w \<approx> w'" "ample.accept w'"
      using assms ample_accept_stuttering[unfolded lv_accept_conv]
      by blast

  end


  context visible_prog begin

    lemma ga_gex_impl_impl: "ga_gex_impl = ga_gex"
      unfolding ga_gex_impl_def[abs_def] ga_gex_def[abs_def]
      by simp

    lemma is_vis_edge_refine: 
      "(is_vis_edge is_vis_var,vis_edges)\<in>\<langle>Id\<times>\<^sub>rId\<rangle>fun_set_rel"
      unfolding is_vis_edge_def vis_edges_def fun_set_rel_def
      by (auto simp: br_def cfg'_succ_list_\<alpha>)

    lemma cr_ample_impl_rule:
      assumes "\<And>sticky_E. sticky_prog prog is_vis_var sticky_E 
        \<Longrightarrow> P (sticky_prog.ga_gample sticky_E)"
      shows "P (cr_ample_impl (is_vis_edge is_vis_var) prog)"
    proof -
      have "cr_ample vis_edges prog \<le> SPEC P"
        unfolding cr_ample_def
        apply (refine_vcg order_trans[OF find_fas_init_correct])
        apply simp
      proof clarsimp  
        fix sticky_E
        assume "is_fas cfg_E cfg_V0 sticky_E" "vis_edges \<subseteq> sticky_E"
        then interpret sticky_prog prog is_vis_var sticky_E
          by unfold_locales
          
        have 1: "ga_gamplei2 op \<in> sticky_E = ga_gample"
          apply (rule ext)
          apply (subst ga_gamplei2_impl)
          apply (rule IdI)
          by auto

        show "P (ga_gamplei2 op \<in> sticky_E)"
          unfolding 1
          apply (rule assms)
          by unfold_locales
      qed
      with cr_ample_impl.refine[OF is_vis_edge_refine IdI, of prog]
      show ?thesis by (auto simp: nres_rel_def refine_pw_simps pw_le_iff)
    qed

    lemma (in sticky_prog) fold_ample_step_aux:
      "(pred_of_enex
             (stutter_extend_en
               (sticky_prog.ga_gample sticky_E),
              stutter_extend_ex ga_gex_impl)) = ample_step"
        unfolding ample_step_def 
        unfolding ga_ample_def
        unfolding ga_gex_impl_impl
        unfolding ga_ex_def
        ..

    theorem ample_impl_accept_subset[rule_format]:
      "ample_impl.accept prog is_vis_var w \<longrightarrow> (\<exists>w'. w = interp_gs \<circ> w' \<and> accept prog w')"
      unfolding ample_succ_impl_def
      apply (rule cr_ample_impl_rule)
      unfolding Let_def x_of_enex_conv
      apply (subst sticky_prog.fold_ample_step_aux, assumption)
      apply clarify
      apply (drule (1) sticky_prog.ample_accept_subset_refpoint)
      by auto

    thm ample_impl_accept_subset

    theorem ample_impl_accept_stuttering:
      "accept prog w \<Longrightarrow> (\<exists>w'. interp_gs \<circ> w \<approx> w' \<and> ample_impl.accept prog is_vis_var w')"
      unfolding ample_succ_impl_def
      apply (rule cr_ample_impl_rule)
      unfolding Let_def x_of_enex_conv
      apply (subst sticky_prog.fold_ample_step_aux, assumption)
      apply (erule (1) sticky_prog.ample_accept_stuttering_refpoint)
      apply auto
      done
  end    

end

