*** Obsolete ***
theory SM_Command_Hc
imports "../RefPoint/SM_Cfg" "Uint32" Derive Code_Char CAVA_Base
  "../Lib/Bisimulation" Type_System SM_Finite_Reachable Gen_Cfg_Bisim
begin

  (* TODO: Move *)
  lemma rel_multiset_brp: 
    "rel_multiset (brp \<alpha> I) = brp (mmap \<alpha>) (\<lambda>m. \<forall>x. x:#m \<longrightarrow> I x)"
  proof (intro ext iffI)
    fix m m'
    assume "rel_multiset (brp \<alpha> I) m m'"
    thus "brp (mmap \<alpha>) (\<lambda>m. \<forall>x. x:#m \<longrightarrow> I x) m m'"
      apply (induction "(brp \<alpha> I)" _ _ rule: rel_multiset_induct)
      apply (auto simp: build_relp_def)
      done
  next
    fix m m'
    assume "brp (mmap \<alpha>) (\<lambda>m. \<forall>x. x \<in># m \<longrightarrow> I x) m m'"
    hence 1: "m' = mmap \<alpha> m" 
      and "\<forall>x. x \<in># m \<longrightarrow> I x" by (auto simp: build_relp_def)
    from this(2) show "rel_multiset (brp \<alpha> I) m m'"
      unfolding 1
      apply (induction m)
      apply (simp add: rel_multiset_Zero)
      apply simp
      apply (rule rel_multiset_Plus)
      apply (simp add: build_relp_def)
      .
  qed    

  lemma rel_multiset_of_mapI:
    assumes "\<forall>x\<in>set l. R (f x) (g x)"
    shows "rel_multiset R (multiset_of (map f l)) (multiset_of (map g l))"
    using assms
    apply (induction l)
    apply (auto simp: rel_multiset_Zero rel_multiset_Plus)
    done



  derive hashable un_op
  derive hashable bin_op
  derive hashable exp
  derive hashable cmd

  thm hashcode_cmd_def

  datatype cmd' =
    Assign uint32 exp ident exp 
  | Assign_local uint32 exp ident exp 
  | Assign_global uint32 exp ident exp
  | Test uint32 exp 
  | Skip      
  | Seq uint32 cmd' cmd' 
  | Or uint32 cmd' cmd' 
  | Loop uint32 cmd'       
  | Break 
  | Continue                          
  | Iterate uint32 cmd' cmd'                            
  | Invalid

  definition [simp]: "hc_Skip \<equiv> hashcode cmd.Skip"
  definition [simp]: "hc_Break \<equiv> hashcode cmd.Break"
  definition [simp]: "hc_Continue \<equiv> hashcode cmd.Continue"
  definition [simp]: "hc_Invalid \<equiv> hashcode cmd.Invalid"

  definition "hc_Seq i1 i2 ==  844900734 * i1 + (838240367 * i2 + 851561101)"
  lemma hc_Seq:  "hashcode (cmd.Seq c1 c2) = hc_Seq (hashcode c1) (hashcode c2)"
    by (simp add: hc_Seq_def hashcode_cmd_def)

  definition "hc_Iterate i1 i2 == 55136646 * i1 + (48476279 * i2 + 61797013)"
  lemma hc_Iterate:  "hashcode (cmd.Iterate c1 c2) = hc_Iterate (hashcode c1) (hashcode c2)"
    by (simp add: hc_Iterate_def hashcode_cmd_def)


  primrec label_of :: "cmd' \<Rightarrow> uint32" where
    "label_of (Assign i _ _ _) = i"
  | "label_of (Assign_local i _ _ _) = i"  
  | "label_of (Assign_global i _ _ _) = i"  
  | "label_of (Test i _) = i"  
  | "label_of (Skip) = hc_Skip"  
  | "label_of (Seq i _ _) = i"  
  | "label_of (Or i _ _) = i"  
  | "label_of (Loop i _) = i"  
  | "label_of (Break) = hc_Break"  
  | "label_of (Continue) = hc_Continue"  
  | "label_of (Iterate i _ _) = i"  
  | "label_of (Invalid) = hc_Invalid"  

  instantiation cmd' :: hashable begin
    definition "hashcode = label_of"
    definition "def_hashmap_size (T::cmd' itself) \<equiv> 16"
    instance apply default unfolding def_hashmap_size_cmd'_def by auto
  end
  
  primrec proj_cmd' :: "cmd' \<Rightarrow> cmd" where
    "proj_cmd' (Assign _ ge x e) = cmd.Assign ge x e"
  | "proj_cmd' (Assign_local _ ge x e) = cmd.Assign_local ge x e" 
  | "proj_cmd' (Assign_global _ ge x e) = cmd.Assign_global ge x e" 
  | "proj_cmd' (Test _ e) = cmd.Test e" 
  | "proj_cmd' (Skip) = cmd.Skip" 
  | "proj_cmd' (Seq _ c1 c2) = cmd.Seq (proj_cmd' c1) (proj_cmd' c2)" 
  | "proj_cmd' (Or _ c1 c2) = cmd.Or (proj_cmd' c1) (proj_cmd' c2)" 
  | "proj_cmd' (Loop _ c1) = cmd.Loop (proj_cmd' c1)" 
  | "proj_cmd' (Break) = cmd.Break" 
  | "proj_cmd' (Continue) = cmd.Continue" 
  | "proj_cmd' (Iterate _ c1 c2) = cmd.Iterate (proj_cmd' c1) (proj_cmd' c2)" 
  | "proj_cmd' (Invalid) = cmd.Invalid" 

  primrec cmd'_invar :: "cmd' \<Rightarrow> bool" where
    "cmd'_invar (Assign i ge x e) \<longleftrightarrow> i=hashcode (cmd.Assign ge x e)"
  | "cmd'_invar (Assign_local i ge x e) \<longleftrightarrow> i=hashcode (cmd.Assign_local ge x e)" 
  | "cmd'_invar (Assign_global i ge x e) \<longleftrightarrow> i=hashcode (cmd.Assign_global ge x e)" 
  | "cmd'_invar (Test i e) \<longleftrightarrow> i=hashcode (cmd.Test e)" 
  | "cmd'_invar (Skip) \<longleftrightarrow> True" 
  | "cmd'_invar (Seq i c1 c2) \<longleftrightarrow> i=hashcode (cmd.Seq (proj_cmd' c1) (proj_cmd' c2)) \<and> cmd'_invar c1 \<and> cmd'_invar c2"
  | "cmd'_invar (Or i c1 c2) \<longleftrightarrow> i=hashcode (cmd.Or (proj_cmd' c1) (proj_cmd' c2)) \<and> cmd'_invar c1 \<and> cmd'_invar c2"
  | "cmd'_invar (Loop i c1) \<longleftrightarrow> i=hashcode (cmd.Loop (proj_cmd' c1)) \<and> cmd'_invar c1"
  | "cmd'_invar (Break) \<longleftrightarrow> True" 
  | "cmd'_invar (Continue) = True" 
  | "cmd'_invar (Iterate i c1 c2) \<longleftrightarrow> i=hashcode (cmd.Iterate (proj_cmd' c1) (proj_cmd' c2)) \<and> cmd'_invar c1 \<and> cmd'_invar c2"
  | "cmd'_invar (Invalid) = True" 

  primrec trans_cmd :: "cmd \<Rightarrow> cmd'" where
    "trans_cmd (cmd.Assign ge x e) = (Assign (hashcode (cmd.Assign ge x e)) ge x e)"
  | "trans_cmd (cmd.Assign_local ge x e) = (Assign_local (hashcode (cmd.Assign_local ge x e)) ge x e)" 
  | "trans_cmd (cmd.Assign_global ge x e) = (Assign_global (hashcode (cmd.Assign_global ge x e)) ge x e)" 
  | "trans_cmd (cmd.Test e) = (Test (hashcode (cmd.Test e)) e)"
  | "trans_cmd (cmd.Skip) = (Skip)"
  | "trans_cmd (cmd.Seq c1 c2) = (Seq (hashcode (cmd.Seq c1 c2)) (trans_cmd c1) (trans_cmd c2))"
  | "trans_cmd (cmd.Or c1 c2) = (Or (hashcode (cmd.Or c1 c2)) (trans_cmd c1) (trans_cmd c2))"
  | "trans_cmd (cmd.Loop c1) = (Loop (hashcode (cmd.Loop c1)) (trans_cmd c1))"
  | "trans_cmd (cmd.Break) = (Break)"
  | "trans_cmd (cmd.Continue) = (Continue)"
  | "trans_cmd (cmd.Iterate c1 c2) = (Iterate (hashcode (cmd.Iterate c1 c2)) (trans_cmd c1) (trans_cmd c2))"
  | "trans_cmd (cmd.Invalid) = (Invalid)"

  lemma proj_trans_cmd_inverse[simp]: "proj_cmd' (trans_cmd c) = c"
    by (induction c) auto

  lemma trans_proj_cmd_inverse[simp]: "cmd'_invar c \<Longrightarrow> trans_cmd (proj_cmd' c) = c"
    by (induction c) auto

  lemma proj_trans_invar[simp]: "cmd'_invar (trans_cmd c)"
    by (induction c) auto

  definition "cmd'_rel = brp proj_cmd' cmd'_invar"

  lemma cmd'_invar_hc: "cmd'_invar c \<Longrightarrow> hashcode (proj_cmd' c) = label_of c"
    by (cases c) auto

  lemma proj_trans_conv: "cmd'_invar c' \<Longrightarrow> c = proj_cmd' c' \<longleftrightarrow> c' = trans_cmd c"
    by auto

  lemma trans_proj_conv: "cmd'_invar c' \<Longrightarrow> c' = trans_cmd c \<longleftrightarrow> c = proj_cmd' c'"
    by auto

  lemma cmd'_rel_unfold1: "cmd'_rel c1 c2 \<longleftrightarrow> c1 = trans_cmd c2"  
    by (auto simp: cmd'_rel_def build_relp_def)

  lemma cmd'_rel_unfold2: "cmd'_rel c1 c2 \<longleftrightarrow> c2 = proj_cmd' c1 \<and> cmd'_invar c1"  
    by (auto simp: cmd'_rel_def build_relp_def)

  lemma cmd'_sim0: "cmd'_rel (trans_cmd c) c"
    unfolding cmd'_rel_def build_relp_def by auto

  lemma label_of_trans_cmd_conv: "label_of (trans_cmd c) = hashcode c"
    using cmd'_invar_hc[of "trans_cmd c"] by simp
    
  definition "sc_Seq c1 c2 \<equiv> Seq (hc_Seq (label_of c1) (label_of c2)) c1 c2"
  lemma sc_Seq_invar[simp]: "\<lbrakk>cmd'_invar c1; cmd'_invar c2\<rbrakk> \<Longrightarrow> cmd'_invar (sc_Seq c1 c2)"
    by (auto simp: sc_Seq_def hc_Seq cmd'_invar_hc)
  lemma sc_Seq_proj[simp]: "proj_cmd' (sc_Seq c1 c2) = cmd.Seq (proj_cmd' c1) (proj_cmd' c2)"  
    by (auto simp: sc_Seq_def)

  lemma sc_Seq_fold: "(cmd'.Seq (hashcode (cmd.Seq c1 c2)) (trans_cmd c1) (trans_cmd c2))
    = sc_Seq (trans_cmd c1) (trans_cmd c2)"
    by (simp add: sc_Seq_def hc_Seq label_of_trans_cmd_conv)
    
  definition "sc_Iterate c1 c2 \<equiv> Iterate (hc_Iterate (label_of c1) (label_of c2)) c1 c2"
  lemma sc_Iterate_invar[simp]: "\<lbrakk>cmd'_invar c1; cmd'_invar c2\<rbrakk> \<Longrightarrow> cmd'_invar (sc_Iterate c1 c2)"
    by (auto simp: sc_Iterate_def hc_Iterate cmd'_invar_hc)
  lemma sc_Iterate_proj[simp]: "proj_cmd' (sc_Iterate c1 c2) = cmd.Iterate (proj_cmd' c1) (proj_cmd' c2)"  
    by (auto simp: sc_Iterate_def)

  lemma sc_Iterate_fold: "(cmd'.Iterate (hashcode (cmd.Iterate c1 c2)) (trans_cmd c1) (trans_cmd c2))
    = sc_Iterate (trans_cmd c1) (trans_cmd c2)"  
    by (simp add: sc_Iterate_def hc_Iterate label_of_trans_cmd_conv)


  inductive cfg_hc :: "cmd' \<Rightarrow> (action + brk_ctd) \<Rightarrow> cmd' \<Rightarrow> bool" where
    Ass: "cfg_hc (Assign _ c x e) (Inl (AAssign c x e)) (Skip)"
  | Assl: "cfg_hc (Assign_local _ c x e) (Inl (AAssign_local c x e)) (Skip)"
  | Assg: "cfg_hc (Assign_global _ c x e) (Inl (AAssign_global c x e)) (Skip)"
  | Test: "cfg_hc (Test _ e) (Inl (ATest e)) (Skip)"

  | Seq1: "cfg_hc (Seq _ Skip c2) (Inl ASkip) c2"
  | Seq2: "\<lbrakk> cfg_hc c1 e c1' \<rbrakk> \<Longrightarrow> cfg_hc (Seq _ c1 c2) e (sc_Seq c1' c2)"

  | Or1: "cfg_hc (Or _ c1 c2) (Inl ASkip) c1"
  | Or2: "cfg_hc (Or _ c1 c2) (Inl ASkip) c2"

  | Loop: "cfg_hc (Loop i c) (Inl ASkip) (sc_Iterate c c)"

  | Break: "cfg_hc (Break) (Inr AIBreak) Invalid"
  | Continue: "cfg_hc (Continue) (Inr AIContinue) Invalid"
  
  | Iterate1: "cfg_hc (Iterate _ (Skip) c) (Inl ASkip) (sc_Iterate c c)"
  | Iterate2: "\<lbrakk> cfg_hc c (Inl e) c' \<rbrakk> \<Longrightarrow> cfg_hc (Iterate _ c cb) (Inl e) (sc_Iterate c' cb)"
  | IterateBrk: "\<lbrakk> cfg_hc c (Inr AIBreak) _  \<rbrakk> \<Longrightarrow> cfg_hc (Iterate _ c cb) (Inl ASkip) (Skip)"
  | IterateCtd: "\<lbrakk> cfg_hc c (Inr AIContinue) _  \<rbrakk> \<Longrightarrow> cfg_hc (Iterate _ c cb) (Inl ASkip) (sc_Iterate cb cb)"

  lemma cfg_hc_sim1: "\<lbrakk> cfg c1 a c2; cmd'_rel c1' c1 \<rbrakk> \<Longrightarrow> \<exists>c2'. cmd'_rel c2' c2 \<and> cfg_hc c1' a c2'"
    apply (induction arbitrary: c1' rule: cfg.induct)
    apply (force 
      intro: cfg_hc.intros 
      simp: cmd'_rel_unfold1 sc_Seq_fold
      )+

    apply (auto simp: cmd'_rel_unfold1) []
    apply (subst (2) sc_Seq_fold)
    apply (auto intro: cfg_hc.intros) []    

    apply (auto 
      intro: cfg_hc.intros 
      simp: cmd'_rel_unfold1 
      )

    apply (subst sc_Iterate_fold)
    apply (auto intro: cfg_hc.intros) []    
    
    apply (subst sc_Iterate_fold)
    apply (auto intro: cfg_hc.intros) []    

    apply (subst (2) sc_Iterate_fold)
    apply (auto intro: cfg_hc.intros) []

    apply (subst (2) sc_Iterate_fold)
    apply (auto intro: cfg_hc.intros) []
    done


  lemma cfg_hc_sim2: "\<lbrakk> cfg_hc c1' a c2'; cmd'_rel c1' c1 \<rbrakk> \<Longrightarrow> \<exists>c2. cmd'_rel c2' c2 \<and> cfg c1 a c2"
    apply (induction arbitrary: c1 rule: cfg_hc.induct)
    apply (auto intro: cfg.intros simp: cmd'_rel_unfold2)
    done

  definition "cfg_hc' c a c' \<equiv> cfg_hc c (Inl a) c'"
    
  lemma cfg_hc'_sim1: "\<lbrakk> cfg' c1 a c2; cmd'_rel c1' c1 \<rbrakk> \<Longrightarrow> \<exists>c2'. cmd'_rel c2' c2 \<and> cfg_hc' c1' a c2'"
    unfolding cfg_hc'_def cfg'_def
    by (blast dest: cfg_hc_sim1)
  
  lemma cfg_hc'_sim2: "\<lbrakk> cfg_hc' c1' a c2'; cmd'_rel c1' c1 \<rbrakk> \<Longrightarrow> \<exists>c2. cmd'_rel c2' c2 \<and> cfg' c1 a c2"
    unfolding cfg_hc'_def cfg'_def
    by (blast dest: cfg_hc_sim2)

  typ global_config  

  type_synonym local_config = "(cmd', local_state) Gen_Scheduler.local_config"
  type_synonym global_config = "(cmd', local_state, global_state) Gen_Scheduler.global_config"

  term init_pc

  definition init_pc :: "proc_decl \<Rightarrow> local_config" where
    "init_pc pd \<equiv> \<lparr>
      local_config.command = trans_cmd (proc_decl.body pd),
      local_config.state = \<lparr>
        local_state.variables = init_valuation (proc_decl.local_vars pd)
      \<rparr>
    \<rparr>"

  definition init_gc :: "program \<Rightarrow> global_config" where
    "init_gc prog \<equiv> \<lparr>
      global_config.processes = multiset_of (map init_pc (program.processes prog)),
      global_config.state = \<lparr>
        global_state.variables = init_valuation (program.global_vars prog)
      \<rparr>
    \<rparr>"


  interpretation lih': Gen_Scheduler'_linit 
    cfg_hc' la_en' la_ex' 
    "op = (init_gc prog)" global_config.state for prog .

  interpretation hc_bisim!: Gen_Cfg_Bisim_Pre cmd'_rel
    cfg_hc' cfg' la_en' la_ex'
    apply unfold_locales
    apply (blast dest: cfg_hc'_sim2)
    apply (blast dest: cfg_hc'_sim1)
    done

  interpretation hc_bisim!: Gen_Cfg_LBisim cmd'_rel
    cfg_hc' "op = (init_gc prog)" global_config.state
    cfg' "op = (SM_Semantics.init_gc prog)" global_config.state la_en' la_ex'
    apply unfold_locales
    apply (auto 
      simp: init_gc_def SM_Semantics.init_gc_def 
      simp: init_pc_def SM_Semantics.init_pc_def 
      simp: hc_bisim.rel_gc_def hc_bisim.rel_lc_def 
      simp: cmd'_rel_unfold1
      intro!: rel_multiset_of_mapI)
    done

  lemma "lih'.accept prog = li'.accept prog"  
    by (rule hc_bisim.accept_bisim)

  definition "lc_\<alpha> lc \<equiv> \<lparr>
    local_config.command = proj_cmd' (local_config.command lc),
    local_config.state = local_config.state lc
  \<rparr>"
  definition "lc_invar lc \<equiv> cmd'_invar (local_config.command lc)"
  lemma hc_bisim_rel_lc_brp_conv: "hc_bisim.rel_lc = brp lc_\<alpha> lc_invar"
    apply (intro ext)
    unfolding hc_bisim.rel_lc_def 
    unfolding cmd'_rel_def lc_\<alpha>_def lc_invar_def build_relp_def
    by auto
    
  definition "gc_\<alpha> gc \<equiv> \<lparr>
    global_config.processes = mmap lc_\<alpha> (global_config.processes gc),
    global_config.state = global_config.state gc
  \<rparr>"
  definition "gc_invar gc \<equiv> \<forall>lc. lc \<in># global_config.processes gc \<longrightarrow> lc_invar lc"

  lemma hc_bisim_rel_gc_brp_conv: "hc_bisim.rel_gc = brp gc_\<alpha> gc_invar"
    apply (intro ext)
    unfolding hc_bisim.rel_gc_def hc_bisim_rel_lc_brp_conv
    unfolding cmd'_rel_def gc_\<alpha>_def gc_invar_def build_relp_def
    apply (auto simp: rel_multiset_brp)
    apply (auto simp: build_relp_def)
    done


  lemma bi_unique_cmd'_rel: "bi_unique cmd'_rel"
    apply (auto 
      intro!: bi_uniqueI left_uniqueI right_uniqueI 
      simp: cmd'_rel_def build_relp_def)
    apply (drule arg_cong[where f=trans_cmd])
    by simp

  lemmas bi_unique_rel_gc = hc_bisim.bi_unique_rel_gcI[OF bi_unique_cmd'_rel] 
  lemmas bi_unique_rel_lc = hc_bisim.bi_unique_rel_lcI[OF bi_unique_cmd'_rel] 

  
  (* TODO: Move? *)
  lemma finite_max1_elemI:
    assumes "(\<forall>x y. x\<in>S \<and> y\<in>S \<longrightarrow> x=y)"  
    shows "finite S"
  proof (cases "S={}")
    case False 
    with assms obtain x where "S={x}" by auto
    thus ?thesis by auto
  qed auto


  lemma left_unique_finite_sngI: 
    assumes "left_unique R" 
    shows "finite {a. R a b}"
  proof (rule finite_subset)
    { 
      fix x y
      assume "x\<in>{a. R a b}" "y\<in>{a. R a b}"
      hence "x=y" using assms
        by (auto dest: left_uniqueD)
    } thus "finite {a. R a b}"
      by (blast intro: finite_max1_elemI)
  qed auto   

  context well_typed_prog begin 
    lemma lih'_accept_eq: "lih'.accept prog = accept prog"  
      by (simp add: hc_bisim.accept_bisim li'.accept_eq)

    lemma lih'_is_run_conv: "is_run prog r \<longleftrightarrow> 
      (\<exists>r'. r=Some o gc_\<alpha> o r' \<and> lih'.is_run prog r')"  
      unfolding li'.is_run_conv 
      unfolding hc_bisim.brp_run_conv[unfolded hc_bisim_rel_gc_brp_conv, OF refl]
      by fastforce


    thm li'_finite_reachable  
    term lih'.reachable  

    lemma lih'_finite_reachable: "finite (lih'.reachable prog)"
      apply (rule hc_bisim.s1.reachable_finite_sim)
      apply (rule li'_finite_reachable)
      apply simp
      apply (rule left_unique_finite_sngI)
      using bi_unique_rel_gc
      apply (simp add: bi_unique_alt_def)
      done
    
  end


  definition approx_reachable where 
    "approx_reachable c \<equiv> trans_cmd ` SM_Cfg.approx_reachable (proj_cmd' c)"

  lemma trans_cmd_inj_simp[simp]: "trans_cmd c = trans_cmd c' \<longleftrightarrow> c=c'" 
    by (auto dest: arg_cong[where f=proj_cmd'])

  lemma trans_cmd_inj_image_simp[simp]: "trans_cmd c \<in> trans_cmd ` X \<longleftrightarrow> c\<in>X"
    by auto  


  lemma finite_approx_reachable[simp, intro!]: "finite (approx_reachable c)"
    unfolding approx_reachable_def
    by auto
 
  lemma approx_reachable_refl[simp]: "cmd'_invar c \<Longrightarrow> c\<in>approx_reachable c"
    unfolding approx_reachable_def
    apply (rule image_eqI[OF _ SM_Cfg.approx_reachable_refl[of "proj_cmd' c"]])
    by simp
    
  lemma approx_reachable_closed: 
    "\<lbrakk>c \<in> approx_reachable c0; cfg_hc c a c'\<rbrakk> \<Longrightarrow> c' \<in> approx_reachable c0"
    unfolding approx_reachable_def
    apply clarsimp
    apply (drule cfg_hc_sim2)
    apply (simp add: cmd'_rel_def build_relp_def)
    apply (clarsimp simp: cmd'_rel_def build_relp_def)
    apply (drule (1) approx_reachable_closed)
    apply force
    done


  hide_const (open) SM_Cfg.cfg Type_System.cfg'

  abbreviation "cfg \<equiv> cfg_hc"
  abbreviation "cfg' \<equiv> cfg_hc'"


  hide_type (open) SM_Syntax.cmd
  type_synonym cmd = cmd'




section {* Executable Successor Function *}

(* CFG successors *)
primrec cfg_succ :: "cmd \<Rightarrow> ((action+brk_ctd) \<times> cmd) set" where
  "cfg_succ (Assign _ c x e) = {((Inl (AAssign c x e)), Skip)}"
| "cfg_succ (Assign_local _ c x e) = {((Inl (AAssign_local c x e)), Skip)}"
| "cfg_succ (Assign_global _ c x e) = {((Inl (AAssign_global c x e)), Skip)}"
| "cfg_succ (Test _ e) = {((Inl (ATest e)), Skip)}"
| "cfg_succ (Seq _ c1 c2) =
    (if c1=Skip then {((Inl ASkip), c2)} else {})
  \<union> { (e,sc_Seq c1' c2) | c1' e.  (e,c1')\<in>cfg_succ c1}"
| "cfg_succ (Or _ c1 c2) = {(Inl ASkip, c1), (Inl ASkip, c2)}"
| "cfg_succ (Loop _ c) =  {((Inl ASkip), (sc_Iterate c c))}"
| "cfg_succ (Break) = {(Inr AIBreak, Invalid)}"
| "cfg_succ (Continue) = {(Inr AIContinue, Invalid)}"
| cfg_succ_iterate: 
  "cfg_succ (Iterate _ c cb) =
  (if c=Skip then {(Inl ASkip, sc_Iterate cb cb)} else {})
  \<union> (
    \<lambda> (Inl e,c') \<Rightarrow> (Inl e, sc_Iterate c' cb)
    | (Inr AIBreak,_) \<Rightarrow> (Inl ASkip,Skip)
    | (Inr AIContinue,_) \<Rightarrow> (Inl ASkip, sc_Iterate cb cb)
  )`cfg_succ c"
| "cfg_succ Skip = {}"
| "cfg_succ Invalid = {}"


declare cfg_succ_iterate[simp del]
lemma cfg_succ_iterate'[simp]: "cfg_succ (Iterate uu c cb) = 
  (if c=Skip then {(Inl ASkip, sc_Iterate cb cb)} else {})
  \<union> { (Inl e, sc_Iterate c' cb) | e c'. (Inl e, c') \<in> cfg_succ c }
  \<union> (if \<exists>c'. (Inr AIBreak,c')\<in> cfg_succ c then { (Inl ASkip, Skip)} else {})
  \<union> (if \<exists>c'. (Inr AIContinue,c')\<in> cfg_succ c then { (Inl ASkip, sc_Iterate cb cb)} else {})"
  unfolding cfg_succ_iterate
  apply (rule sym)
  apply (cases "c=Skip")
  apply simp
  apply safe
  apply simp_all
  apply force
  apply (force split: split_if_asm)
  apply (force split: split_if_asm)
  apply (auto split: split_if_asm sum.splits brk_ctd.splits)
  done


export_code cfg_succ in SML

lemma cfg_succ_iff_cfg: "(a,c')\<in>cfg_succ c \<longleftrightarrow> cfg c a c'"
  apply rule
  apply (induction c arbitrary: a c')
  apply (auto intro: cfg_hc.intros split: split_if_asm)
  
  apply (induction rule: cfg_hc.induct)
  apply auto
  done

theorem cfg_succ_correct: "cfg_succ c = {(a,c'). cfg c a c'}"
  using cfg_succ_iff_cfg by auto

lemma cfg_succ_finite[simp, intro!]: "finite (cfg_succ c)"
  apply (induction c)
  using [[simproc add: finite_Collect]]
  by (simp_all del: cfg_succ_iterate' add: cfg_succ_iterate)

end

