theory Pred_Ex
imports Main
begin
  text \<open>Lets specify transitive closure\<close>
  inductive trc :: "('a \<Rightarrow> 'a \<Rightarrow> bool) \<Rightarrow> 'a \<Rightarrow> 'a \<Rightarrow> bool" for P where
    "P a b \<Longrightarrow> trc P a b"
  | "P a b \<Longrightarrow> trc P b c \<Longrightarrow> trc P a c"  

  code_pred trc .

  thm trc.equation

  inductive P :: "nat \<Rightarrow> nat \<Rightarrow> bool" where
    "x<9 \<Longrightarrow> P x (Suc x)"
  code_pred P .  
    
  values "{y. trc P 5 y}"
  (*values "{y. trc P y 5}" Loops! *)

  
  inductive acc :: "('a \<Rightarrow> 'b \<Rightarrow> 'a \<Rightarrow> bool) \<Rightarrow> 'a \<Rightarrow> 'b list \<Rightarrow> 'a \<Rightarrow> bool" for \<Delta>
    where
      "acc \<Delta> q [] q" 
    | "\<lbrakk> \<Delta> q a q'; acc \<Delta> q' w q'' \<rbrakk> \<Longrightarrow> acc \<Delta> q (a#w) q''"  

  code_pred acc .

  inductive A :: "nat \<Rightarrow> char \<Rightarrow> nat \<Rightarrow> bool" where
    "A 0 CHR ''a'' 1"
  | "A 1 CHR ''a'' 1"
  | "A 1 CHR ''b'' 2"

  code_pred A .

  definition "foo == acc A 0 ''a'' 2"

  values [mode: i \<Rightarrow> i \<Rightarrow> o \<Rightarrow> bool] "{q. acc A 0 ''aaac'' q}"

  values [mode: o \<Rightarrow> i \<Rightarrow> i \<Rightarrow> bool] "{q. acc A q ''aaab'' 2}"

  (*values [mode: o \<Rightarrow> o \<Rightarrow> i \<Rightarrow> bool] "{(q,w). acc A q w 2}"*)

  inductive reachable :: "(nat \<Rightarrow> char \<Rightarrow> nat \<Rightarrow> bool) \<Rightarrow> nat \<Rightarrow> bool" for \<Delta> where
    "reachable \<Delta> 0"
  | "\<lbrakk> \<Delta> q CHR ''a'' q'; reachable \<Delta> q \<rbrakk> \<Longrightarrow> reachable \<Delta> q'"

  code_pred reachable .

  inductive rA where "reachable A q \<Longrightarrow> rA q"
  code_pred rA .
  thm rA.equation
  (* value "rA 2" *)

  export_code rA rA_i rA_o in SML

end

